import { openBlock as C, createElementBlock as x, Fragment as he, renderList as ye, normalizeClass as R, createBlock as kt, resolveDynamicComponent as Et, mergeProps as ut, createElementVNode as T, createCommentVNode as G, createTextVNode as wr, resolveComponent as Ke, toDisplayString as we, createVNode as Se, renderSlot as et, withDirectives as $e, vShow as yn, pushScopeId as vn, popScopeId as mn, vModelSelect as Kt, vModelText as kn, normalizeProps as Oe, vModelDynamic as Fi, guardReactiveProps as Re, vModelRadio as Mi, vModelCheckbox as ji } from "vue";
const Bi = {
  props: {
    only: {
      type: Array,
      required: !1
    },
    except: {
      type: Array,
      required: !1
    },
    orderByOnly: {
      type: Boolean,
      required: !1,
      default: !1
    }
  },
  methods: {
    subset(s) {
      if (this.only || this.except) {
        let c = Object.keys(s).filter(
          (f) => this.only ? this.only.includes(f) : !this.except.includes(f)
        ).reduce((f, z) => (f[z] = s[z], f), {});
        if (this.orderByOnly && !this.except) {
          let f = {};
          this.only.forEach((z) => {
            f[z] = c[z];
          }), c = f;
        }
        return c;
      }
      return s;
    }
  }
}, Tn = {
  mixins: [Bi],
  props: {
    columns: {
      type: Number,
      required: !1,
      default: 1,
      validator: function(s) {
        return 12 % s === 0;
      }
    },
    spread: {
      type: Boolean,
      required: !1,
      default: !0
    },
    rowClass: {
      type: String,
      required: !1,
      default: null
    },
    colClass: {
      type: String,
      required: !1,
      default: null
    },
    componentClass: {
      type: String,
      required: !1,
      default: null
    }
  },
  methods: {
    rows(s) {
      const c = this.subset(s), f = Object.keys(c), z = f.length, V = Math.ceil(z / this.columns);
      let H = [...Array(V).keys()];
      for (const P in H) {
        let A = [];
        for (let te = P * this.columns; te <= P * this.columns + (this.columns - 1); te++)
          if (f[te]) {
            const le = { ...c[f[te]] };
            le.key = f[te], A.push(le);
          }
        H[P] = A;
      }
      return H;
    },
    colSize(s) {
      let c = 12 / this.columns;
      return s.length < this.columns && this.spread && (c = Math.floor(12 / s.length)), c;
    }
  }
}, Ve = {
  props: {
    labelPosition: {
      type: String,
      required: !1,
      default: "horizontal",
      validator: function(s) {
        return ["horizontal", "vertical", "none"].includes(s);
      }
    },
    labelColumnSize: {
      type: Number,
      required: !1,
      default: 6,
      validator: function(s) {
        return s < 12;
      }
    },
    synchronous: {
      type: Boolean,
      required: !1,
      default: !1
    },
    helperText: {
      type: String,
      required: !1,
      default: ""
    },
    helperTextClass: {
      type: String,
      required: !1,
      default: ""
    }
  },
  computed: {
    boundValue: {
      get() {
        return this.getFilter(this.filter.key);
      },
      set(s) {
        this.setFilterLoadData(this.filter.key, s);
      }
    }
  },
  methods: {
    setFilterLoadData(s, c) {
      this.setFilter(s, c), !this.synchronous && this.pageDefinition.loadData && this.loadData();
    }
  }
};
const Te = (s, c) => {
  const f = s.__vccOpts || s;
  for (const [z, V] of c)
    f[z] = V;
  return f;
}, $i = {
  name: "FilterGrid",
  mixins: [Tn, Ve],
  props: {
    labelPosition: {
      type: String,
      required: !1,
      default: "horizontal",
      validator: function(s) {
        return ["horizontal", "vertical", "none"].includes(s);
      }
    },
    synchronous: {
      type: Boolean,
      required: !1,
      default: !1
    },
    clearButton: {
      type: Boolean,
      required: !1,
      default: !0
    },
    buttonPosition: {
      type: String,
      required: !1,
      default: "center",
      validator: function(s) {
        return ["left", "center", "right", "none"].includes(s);
      }
    }
  },
  methods: {
    initializeDefaultsLoadData() {
      this.initializeDefaults(
        this.subset(this.getFilters) ? Object.keys(this.subset(this.getFilters)) : null
      ), !this.synchronous && this.pageDefinition.loadData && this.loadData();
    }
  }
}, Ri = ["id"], Ii = {
  key: 0,
  class: "row button-row harness-vue-bootstrap-filtergrid-row harness-vue-bootstrap-filtergrid-buttonrow"
}, zi = /* @__PURE__ */ wr(" \xA0 ");
function Vi(s, c, f, z, V, H) {
  return C(), x("div", null, [
    (C(!0), x(he, null, ye(s.rows(this.filters), (P, A) => (C(), x("div", {
      class: R("row harness-vue-bootstrap-filtergrid-row " + s.rowClass),
      key: A
    }, [
      (C(!0), x(he, null, ye(P, (te, le) => (C(), x("div", {
        class: R(
          "harness-vue-bootstrap-filtergrid-col col-sm-" + 12 / s.columns + " " + s.colClass
        ),
        key: s.pageDefinition.key + "-" + le,
        id: te.key + "-col"
      }, [
        (C(), kt(Et(te.component), ut({ filter: te, ...te.props, ...s.$props, ...s.$attrs }, {
          key: s.pageDefinition.key + "-filtergrid-" + te.key,
          class: s.componentClass
        }), null, 16, ["class"]))
      ], 10, Ri))), 128))
    ], 2))), 128)),
    (f.synchronous || f.clearButton) && f.buttonPosition !== "none" ? (C(), x("div", Ii, [
      T("div", {
        class: R("col-md-12 text-" + f.buttonPosition)
      }, [
        f.synchronous ? (C(), x("button", {
          key: 0,
          class: "btn btn-primary btn-sm harness-vue-bootstrap-filtergrid-applybutton",
          onClick: c[0] || (c[0] = (...P) => s.loadData && s.loadData(...P)),
          role: "button"
        }, " Apply Filters ")) : G("", !0),
        zi,
        f.clearButton ? (C(), x("button", {
          key: 1,
          role: "button",
          class: "btn btn-primary btn-sm harness-vue-bootstrap-filtergrid-clearbutton",
          onClick: c[1] || (c[1] = (...P) => H.initializeDefaultsLoadData && H.initializeDefaultsLoadData(...P))
        }, " Clear Filters ")) : G("", !0)
      ], 2)
    ])) : G("", !0)
  ]);
}
const Wi = /* @__PURE__ */ Te($i, [["render", Vi], ["__scopeId", "data-v-7744e4c4"]]), Ui = {
  name: "ChartGrid",
  mixins: [Tn],
  computed: {
    chartRows() {
      return this.rows(this.charts);
    }
  }
};
function Gi(s, c, f, z, V, H) {
  return C(), x("div", null, [
    (C(!0), x(he, null, ye(H.chartRows, (P, A) => (C(), x("div", {
      class: R("row harness-vue-bootstrap-chartgrid-row " + s.rowClass),
      key: A
    }, [
      (C(!0), x(he, null, ye(P, (te, le) => (C(), x("div", {
        class: R("col-md-" + s.colSize(P) + " " + s.colClass),
        key: le
      }, [
        (C(), kt(Et(te.component), ut({ chart: te, ...te.props, ...s.$props, ...s.$attrs }, {
          key: s.pageDefinition.key + "-chartgrid-" + te.key,
          class: s.componentClass
        }), null, 16, ["class"]))
      ], 2))), 128))
    ], 2))), 128))
  ]);
}
const Qi = /* @__PURE__ */ Te(Ui, [["render", Gi]]), Xi = {
  name: "GridWithFilters",
  props: ["columns"]
}, Ki = { class: "display-4" }, Ji = { class: "row" }, Yi = { class: "col-md-12" }, Zi = { class: "card" }, es = /* @__PURE__ */ T("div", { class: "card-header" }, "Filters", -1), ts = { class: "card-body" };
function rs(s, c, f, z, V, H) {
  const P = Ke("FilterGrid"), A = Ke("ChartGrid");
  return C(), x("div", null, [
    T("h1", Ki, we(s.page.title), 1),
    T("div", Ji, [
      T("div", Yi, [
        T("div", Zi, [
          es,
          T("div", ts, [
            Se(P)
          ])
        ])
      ])
    ]),
    Se(A, { columns: f.columns }, null, 8, ["columns"])
  ]);
}
const ns = /* @__PURE__ */ Te(Xi, [["render", rs]]), Cn = {
  props: {
    chart: {
      type: Object,
      required: !0
    },
    tableClass: {
      type: String,
      required: !1,
      default: null
    },
    headerClass: {
      type: String,
      required: !1,
      default: null
    },
    labelClass: {
      type: String,
      required: !1,
      default: null
    },
    rowClass: {
      type: String,
      required: !1,
      default: null
    },
    cellClass: {
      type: String,
      required: !1,
      default: null
    },
    rowHeaderCol: {
      type: Boolean,
      required: !1,
      default: !1
    }
  },
  computed: {
    columnHeaders() {
      return this.validatedChartData ? Object.keys(this.validatedChartData[0]) : [];
    },
    validatedChartData() {
      return this.validateChartData(this.chartData, this.chart.key);
    }
  }
};
const is = {
  name: "DataTable508",
  mixins: [Cn],
  computed: {
    columnHeaders() {
      return this.validatedChartData ? Object.keys(this.validatedChartData[0]) : [];
    },
    chartData() {
      let s = this.getChartData(this.chart.key) || null, c = this.getChartProps(this.chart.key).tableAdapter || null;
      if (s && c)
        try {
          return c(
            this.chart,
            this.filters,
            s,
            this.pageStore
          );
        } catch (f) {
          throw String(
            "There was an error in the formatted text from your tableAdapter function: " + String(f)
          );
        }
      return s;
    }
  }
}, ss = ["id"], as = ["innerHTML"], os = ["innerHTML"], ls = ["innerHTML"];
function us(s, c, f, z, V, H) {
  return s.validatedChartData && s.validatedChartData.length ? (C(), x("div", {
    key: 0,
    id: s.chart.key + "_data_table",
    class: "harness-vue-bootstrap-datatable"
  }, [
    T("table", {
      class: R("harness-vue-bootstrap-table table " + s.tableClass)
    }, [
      T("thead", {
        class: R(s.headerClass)
      }, [
        T("tr", null, [
          (C(!0), x(he, null, ye(H.columnHeaders, (P, A) => (C(), x("th", {
            scope: "col",
            key: A,
            class: R(s.labelClass),
            innerHTML: P
          }, null, 10, as))), 128))
        ])
      ], 2),
      T("tbody", null, [
        (C(!0), x(he, null, ye(s.validatedChartData, (P, A) => (C(), x("tr", {
          key: A,
          class: R(s.rowClass)
        }, [
          (C(!0), x(he, null, ye(H.columnHeaders, (te, le) => (C(), x(he, null, [
            le === 0 && s.rowHeaderCol ? (C(), x("th", {
              key: le,
              class: R(s.cellClass),
              innerHTML: P[te],
              scope: "row"
            }, null, 10, os)) : (C(), x("td", {
              key: `${le}-else`,
              class: R(s.cellClass),
              innerHTML: P[te]
            }, null, 10, ls))
          ], 64))), 256))
        ], 2))), 128))
      ])
    ], 2)
  ], 8, ss)) : G("", !0);
}
const fs = /* @__PURE__ */ Te(is, [["render", us], ["__scopeId", "data-v-5a510616"]]);
const cs = {
  name: "ChartWithTable",
  props: {
    chart: {
      type: Object,
      required: !0
    },
    chartComponent: {
      type: [Object, Function],
      required: !0
    },
    tableDisplay: {
      type: String,
      required: !1,
      default: "toggle"
    },
    scrollable: {
      type: Boolean,
      required: !1,
      default: !1
    },
    downloadable: {
      type: Boolean,
      required: !1,
      default: !0
    },
    card: {
      type: Boolean,
      required: !1,
      default: !0
    },
    buttonPosition: {
      type: String,
      required: !1,
      default: "top"
    },
    saveImageButton: {
      type: Function,
      required: !1
    },
    collapsible: {
      type: Boolean,
      required: !1,
      default: !1
    },
    collapsibleFunc: {
      type: Function,
      required: !1,
      default: () => !0
    },
    startCollapsed: {
      type: Boolean,
      required: !1,
      default: !1
    },
    showTableButtonText: {
      type: String,
      required: !1,
      default: "Show Table"
    },
    showChartButtonText: {
      type: String,
      required: !1,
      default: "Show Chart"
    }
  },
  data: function() {
    return {
      view: "chart",
      chartReady: !1,
      collapsed: this.startCollapsed
    };
  },
  methods: {
    toggleView() {
      switch (this.view) {
        case "chart":
          this.view = "table";
          break;
        case "table":
          this.view = "chart";
          break;
      }
      this.$emit("view", this.view);
    },
    toggleCollapse() {
      this.collapsed = !this.collapsed, this.$emit("collapsed", this.collapsed), this.collapsibleFunc();
    }
  },
  computed: {
    labels() {
      let s = {};
      return this.$attrs.tableColumns && this.$attrs.tableColumnLabels ? (s.tableColumns = this.$attrs.tableColumns, s.tableColumnLabels = this.$attrs.tableColumnLabels) : this.getChartProps(this.chart.key).tableColumns && this.getChartProps(this.chart.key).tableColumnLabels && (s.tableColumns = this.getChartProps(this.chart.key).tableColumns, s.tableColumnLabels = this.getChartProps(
        this.chart.key
      ).tableColumnLabels), s;
    },
    scroll() {
      return this.scrollable ? "height:" + this.getChartProps(this.chart.key).height + "px;overflow-y:auto;" : "";
    }
  }
}, ds = (s) => (vn("data-v-20098f71"), s = s(), mn(), s), hs = ["id"], ps = { class: "row" }, gs = { class: "harness-vue-bootstrap-chartwithtable-title" }, ys = ["aria-controls"], bs = { class: "harness-vue-bootstrap-chartwithtable-subtitle" }, vs = {
  key: 0,
  class: "col-md-6"
}, ms = {
  id: "button-container",
  class: "float-right"
}, ks = ["aria-label"], Ts = ["innerHTML"], Cs = ["aria-label"], ws = ["innerHTML"], Ss = ["aria-label"], xs = ["aria-label"], _s = ["id"], Ds = { class: "harness-vue-bootstrap-chartwithtable-abovechart" }, Ls = /* @__PURE__ */ ds(() => /* @__PURE__ */ T("br", null, null, -1)), qs = { class: "harness-vue-bootstrap-chartwithtable-belowchart" }, As = ["id"], Ns = {
  id: "button-container",
  class: "float-right"
}, Ps = ["aria-label"], Es = ["innerHTML"], Os = ["aria-label"], Hs = ["innerHTML"], Fs = { key: 2 }, Ms = ["aria-label"], js = { key: 3 }, Bs = ["aria-label"];
function $s(s, c, f, z, V, H) {
  const P = Ke("DataTable508");
  return C(), x("div", {
    id: f.chart.key + "_container",
    class: R((f.card ? "card" : "") + " harness-vue-bootstrap-chartwithtable")
  }, [
    T("div", {
      class: R(f.card ? "card-header" : "")
    }, [
      T("div", ps, [
        T("div", {
          class: R(f.buttonPosition === "top" ? "col-md-6" : "col-md-12")
        }, [
          T("h3", {
            class: R(f.card ? "card-title" : "")
          }, [
            T("div", gs, [
              T("div", null, [
                et(s.$slots, "title", {
                  innerHTML: f.chart.title
                }, void 0, !0),
                f.collapsible ? (C(), x("button", {
                  key: 0,
                  id: "collapseButton",
                  "data-toggle": "collapse",
                  "aria-expanded": "false",
                  "aria-controls": f.chart.key + "ChartTableBody " + f.chart.key + "Buttons",
                  onClick: c[0] || (c[0] = (...A) => H.toggleCollapse && H.toggleCollapse(...A)),
                  "aria-label": "Toggle Chart"
                }, we(s.collapsed ? "+" : "-"), 9, ys)) : G("", !0)
              ]),
              T("div", bs, [
                et(s.$slots, "subtitle", {}, void 0, !0)
              ])
            ])
          ], 2)
        ], 2),
        f.buttonPosition === "top" ? (C(), x("div", vs, [
          T("h3", {
            class: R(
              "harness-vue-bootstrap-chartwithtable-buttonrow" + (f.card ? " card-title" : "")
            )
          }, [
            T("span", ms, [
              f.tableDisplay == "toggle" && s.view == "chart" ? (C(), x("button", {
                key: 0,
                role: "button",
                "aria-label": "Show Table: " + (f.chart.title || f.chart.key),
                onClick: c[1] || (c[1] = (...A) => H.toggleView && H.toggleView(...A)),
                class: "btn btn-sm btn-primary harness-vue-bootstrap-togglebutton"
              }, [
                T("span", { innerHTML: f.showTableButtonText }, null, 8, Ts)
              ], 8, ks)) : G("", !0),
              f.tableDisplay == "toggle" && s.view == "table" ? (C(), x("button", {
                key: 1,
                role: "button",
                "aria-label": "Show Chart: " + (f.chart.title || f.chart.key),
                onClick: c[2] || (c[2] = (...A) => H.toggleView && H.toggleView(...A)),
                class: "btn btn-sm btn-primary harness-vue-bootstrap-togglebutton"
              }, [
                T("span", { innerHTML: f.showChartButtonText }, null, 8, ws)
              ], 8, Cs)) : G("", !0),
              f.downloadable && s.getChartData(f.chart.key) ? (C(), x("button", {
                key: 2,
                role: "button",
                "aria-label": "Download Table: " + (f.chart.title || f.chart.key),
                onClick: c[3] || (c[3] = (A) => s.downloadCSV(f.chart.key)),
                class: "btn btn-sm btn-primary harness-vue-bootstrap-downloadbutton"
              }, " Download CSV ", 8, Ss)) : G("", !0),
              f.saveImageButton && s.getChartData(f.chart.key) ? (C(), x("button", {
                key: 3,
                role: "button",
                "aria-label": "Download Table: " + (f.chart.title || f.chart.key),
                onClick: c[4] || (c[4] = (A) => f.saveImageButton()),
                class: "btn btn-sm btn-primary harness-vue-bootstrap-downloadbutton"
              }, " Save Image ", 8, xs)) : G("", !0),
              et(s.$slots, "additional-buttons", {}, void 0, !0)
            ])
          ], 2)
        ])) : G("", !0)
      ])
    ], 2),
    T("div", {
      id: f.chart.key + "ChartTableBody",
      class: R(
        "card-body harness-vue-bootstrap-chartwithtable-body" + (f.collapsible ? " " + f.chart.key + "-multi-collapse" : "") + (s.collapsed ? " collapse" : " show")
      )
    }, [
      T("div", Ds, [
        et(s.$slots, "above-chart", {}, void 0, !0)
      ]),
      $e((C(), kt(Et(f.chartComponent), ut({ chart: f.chart, ...f.chart.props, ...s.$attrs }, {
        key: "chartwithtable" + f.chart.key + "chart"
      }), null, 16)), [
        [yn, f.tableDisplay != "toggle" || s.view == "chart"]
      ]),
      Ls,
      T("div", qs, [
        et(s.$slots, "below-chart", {}, void 0, !0)
      ]),
      $e((C(), kt(P, ut({ chart: f.chart, ...f.chart.props, ...s.$attrs }, {
        key: "chartwithtable" + f.chart.key + "table",
        style: H.scroll
      }), null, 16, ["style"])), [
        [yn, f.tableDisplay != "toggle" || s.view == "table"]
      ])
    ], 10, _s),
    f.buttonPosition === "bottom" ? (C(), x("h3", {
      key: 0,
      id: f.chart.key + "Buttons",
      class: R(
        "harness-vue-bootstrap-chartwithtable-buttonrow" + (f.collapsible ? " " + f.chart.key + "-multi-collapse" : "") + (s.collapsed ? " collapse" : " show") + (f.card ? " card-title" : "")
      )
    }, [
      T("span", Ns, [
        f.tableDisplay == "toggle" && s.view == "chart" ? (C(), x("button", {
          key: 0,
          role: "button",
          "aria-label": "Show Table: " + (f.chart.title || f.chart.key),
          onClick: c[5] || (c[5] = (...A) => H.toggleView && H.toggleView(...A)),
          class: "btn btn-sm btn-primary harness-vue-bootstrap-togglebutton"
        }, [
          T("span", { innerHTML: f.showTableButtonText }, null, 8, Es)
        ], 8, Ps)) : G("", !0),
        f.tableDisplay == "toggle" && s.view == "table" ? (C(), x("button", {
          key: 1,
          role: "button",
          "aria-label": "Show Chart: " + (f.chart.title || f.chart.key),
          onClick: c[6] || (c[6] = (...A) => H.toggleView && H.toggleView(...A)),
          class: "btn btn-sm btn-primary harness-vue-bootstrap-togglebutton"
        }, [
          T("span", { innerHTML: f.showChartButtonText }, null, 8, Hs)
        ], 8, Os)) : G("", !0),
        f.downloadable && s.getChartData(f.chart.key) ? (C(), x("span", Fs, [
          T("button", {
            role: "button",
            "aria-label": "Download Table: " + (f.chart.title || f.chart.key),
            onClick: c[7] || (c[7] = (A) => s.downloadCSV(f.chart.key, H.labels || null)),
            class: "btn btn-sm btn-primary harness-vue-bootstrap-downloadbutton"
          }, " Download CSV ", 8, Ms)
        ])) : G("", !0),
        f.saveImageButton && s.getChartData(f.chart.key) ? (C(), x("span", js, [
          f.saveImageButton ? (C(), x("button", {
            key: 0,
            role: "button",
            "aria-label": "Download Image: " + (f.chart.title || f.chart.key),
            onClick: c[8] || (c[8] = (A) => f.saveImageButton()),
            class: "btn btn-sm btn-primary harness-vue-bootstrap-downloadbutton"
          }, " Save Image ", 8, Bs)) : G("", !0)
        ])) : G("", !0),
        et(s.$slots, "additional-buttons", {}, void 0, !0)
      ])
    ], 10, As)) : G("", !0)
  ], 10, hs);
}
const Rs = /* @__PURE__ */ Te(cs, [["render", $s], ["__scopeId", "data-v-20098f71"]]);
const Is = {
  name: "InteractiveTable",
  mixins: [Cn],
  props: {
    local: {
      type: Object,
      required: !1,
      default: () => {
      }
    },
    numRowOptions: {
      type: Array,
      required: !0
    },
    defaultSortColumn: {
      type: String,
      required: !0
    },
    defaultSortOrder: {
      type: String,
      required: !1,
      default: "asc",
      validator: function(s) {
        return ["asc", "desc"].includes(s);
      }
    },
    numPaginationOptions: {
      type: Number,
      required: !1,
      default: 5
    }
  },
  data() {
    return {
      sortedDescending: this.defaultSortOrder === "desc",
      pageNumber: 1,
      searchQuery: "",
      columnSelector: this.defaultSortColumn,
      columnSort: this.defaultSortOrder,
      paginationAmount: 5
    };
  },
  methods: {
    setColumnFilter(s) {
      s === this.columnSelector && (this.sortedDescending = !this.sortedDescending), this.columnSelector = s, this.columnSort = this.sortedDescending ? "desc" : "asc", this.tableOptions.length && this.setFilter(this.chart.key + "TableOptions", [
        {
          pageNumber: this.pageNumber,
          searchQuery: this.searchQuery,
          columnSelector: this.columnSelector,
          columnSort: this.sortedDescending ? "desc" : "asc",
          paginationAmount: this.paginationAmount,
          numberOfPages: this.numberOfPages
        }
      ]), (!this.isSearchable || !this.isSortable || !this.isPaginated) && this.loadData();
    },
    setPageNum(s) {
      this.pageNumber = s, this.tableOptions.length && this.setFilter(this.chart.key + "TableOptions", {
        pageNumber: this.pageNumber,
        searchQuery: this.searchQuery,
        columnSelector: this.columnSelector,
        columnSort: this.columnSort,
        paginationAmount: this.paginationAmount,
        numberOfPages: this.numberOfPages
      }), (!this.isSearchable || !this.isSortable || !this.isPaginated) && this.loadData();
    },
    isActiveAndDescending(s) {
      return this.columnSort === "desc" && this.columnSelector === s;
    },
    isActiveAndAscending(s) {
      return this.columnSort === "asc" && this.columnSelector === s;
    }
  },
  computed: {
    tableOptions() {
      let s = [];
      return Object.keys(this.filters).includes(this.chart.key + "TableOptions") && (s = this.getOptionsForFilter(this.chart.key + "TableOptions")), s;
    },
    tableAdaptedData() {
      let s = this.getChartData(this.chart.key) || null, c = this.getChartProps(this.chart.key).tableAdapter || null;
      if (s && c)
        try {
          s = c(this.chart, this.filters, s);
        } catch (f) {
          throw String(
            "There was an error in the formatted text from your tableAdapter function: " + String(f)
          );
        }
      return s;
    },
    chartData() {
      let s = this.tableAdaptedData;
      if (s) {
        if (this.isSearchable && (s = s.filter((c) => Object.values(c).reduce((f, z) => f || (z ? z.toLowerCase().includes(this.searchQuery.toLowerCase()) : !1), !1))), this.isSortable && (this.columnSort === "asc" ? s = s.sort((c, f) => c[this.columnSelector].toString().localeCompare(f[this.columnSelector], "en", {
          sensitivity: "base"
        })) : this.columnSort === "desc" && (s = s.sort((c, f) => f[this.columnSelector].toString().localeCompare(c[this.columnSelector], "en", {
          sensitivity: "base"
        })))), this.isPaginated) {
          let c = this.pageNumber, f = s.length, z = parseInt(this.paginationAmount), V = c * z > f ? f : c * z, H = (c - 1) * z;
          s = s.slice(H, V);
        }
        return s;
      }
      return s;
    },
    isSearchable() {
      return this.local ? !this.local.hasOwnProperty("search") || this.local.hasOwnProperty("search") && this.local.search !== !1 : !0;
    },
    isSortable() {
      return this.local ? !this.local.hasOwnProperty("sort") || this.local.hasOwnProperty("sort") && this.local.sort !== !1 : !0;
    },
    isPaginated() {
      return this.local ? !this.local.hasOwnProperty("paginate") || this.local.hasOwnProperty("paginate") && this.local.paginate !== !1 : !0;
    },
    numberOfPages() {
      let s = this.tableAdaptedData;
      s && (s = s.filter((H) => Object.values(H).reduce((P, A) => P || (A ? A.toLowerCase().includes(this.searchQuery.toLowerCase()) : !1), !1)));
      let c = [1], f = parseInt(this.paginationAmount), z = this.validateChartData(s, this.chart.key) ? this.validateChartData(s, this.chart.key).length : 0, V = Math.ceil(z / f);
      for (let H = 2; H <= V; H++)
        c.push(H);
      return c;
    },
    searchText: {
      get() {
        return this.searchQuery;
      },
      set(s) {
        this.searchQuery = s, this.pageNumber = 1, this.tableOptions.length && this.setFilter(this.chart.key + "TableOptions", {
          pageNumber: this.pageNumber,
          searchQuery: this.searchQuery,
          columnSelector: this.columnSelector,
          columnSort: this.columnSort,
          paginationAmount: this.paginationAmount,
          numberOfPages: this.numberOfPages
        }), (!this.isSearchable || !this.isSortable || !this.isPaginated) && this.loadData();
      }
    },
    paginationOptions() {
      return this.pageNumber <= this.numPaginationOptions ? this.numberOfPages.slice(0, this.numPaginationOptions) : this.numberOfPages.slice(
        this.pageNumber - this.numPaginationOptions,
        this.pageNumber
      );
    }
  },
  beforeUpdate() {
    this.pageNumber > this.numberOfPages.length && (this.pageNumber = 1, this.tableOptions.length && this.setFilter(this.chart.key + "TableOptions", {
      pageNumber: this.pageNumber,
      searchQuery: this.searchQuery,
      columnSelector: this.columnSelector,
      columnSort: this.columnSort,
      paginationAmount: this.paginationAmount,
      numberOfPages: this.numberOfPages
    }), this.loadData());
  }
}, Jt = (s) => (vn("data-v-2483a85a"), s = s(), mn(), s), zs = { class: "row py-2" }, Vs = { class: "col-sm-3" }, Ws = { class: "row form-row" }, Us = { class: "offset-1 col-4" }, Gs = ["id"], Qs = ["value"], Xs = { class: "col-sm-4 offset-sm-5 text-right" }, Ks = { class: "row form-row" }, Js = { class: "offset-4 col-8 pr-4" }, Ys = ["id"], Zs = ["id"], ea = ["onClick"], ta = { class: "harness-vue-bootstrap-interactivetable-column-header" }, ra = {
  key: 0,
  class: /* @__PURE__ */ R(["activeCol"])
}, na = {
  key: 1,
  class: /* @__PURE__ */ R(["activeCol"])
}, ia = ["innerHTML"], sa = ["innerHTML"], aa = { class: "row justify-content-center" }, oa = { class: "col-md-2 text-center" }, la = {
  "aria-label": "Table pagination navigation",
  class: "navigation text-center harness-vue-bootstrap-interactivetable-pagination-navigation"
}, ua = { class: "pagination harness-vue-bootstrap-interactivetable-pagination" }, fa = /* @__PURE__ */ Jt(() => /* @__PURE__ */ T("i", { class: "bi-chevron-double-left" }, null, -1)), ca = [
  fa
], da = /* @__PURE__ */ Jt(() => /* @__PURE__ */ T("i", { class: "bi-chevron-left" }, null, -1)), ha = [
  da
], pa = ["onClick"], ga = /* @__PURE__ */ Jt(() => /* @__PURE__ */ T("i", { class: "bi-chevron-right" }, null, -1)), ya = [
  ga
], ba = /* @__PURE__ */ Jt(() => /* @__PURE__ */ T("i", { class: "bi-chevron-double-right" }, null, -1)), va = [
  ba
];
function ma(s, c, f, z, V, H) {
  return C(), x("div", null, [
    T("div", null, [
      T("div", zs, [
        T("div", Vs, [
          T("div", Ws, [
            T("div", Us, [
              $e(T("select", {
                class: "form-control harness-vue-bootstrap-interactivetable-select",
                id: s.chart.key + "NumRowsSelect",
                "aria-label": "Amount of rows to paginate by",
                "onUpdate:modelValue": c[0] || (c[0] = (P) => V.paginationAmount = P)
              }, [
                (C(!0), x(he, null, ye(f.numRowOptions, (P) => (C(), x("option", {
                  key: P,
                  value: P
                }, we(P), 9, Qs))), 128))
              ], 8, Gs), [
                [Kt, V.paginationAmount]
              ])
            ])
          ])
        ]),
        T("div", Xs, [
          T("div", Ks, [
            T("div", Js, [
              $e(T("input", {
                type: "text",
                class: "form-control harness-vue-bootstrap-interactivetable-text-input",
                id: s.chart.key + "SearchQueryInput",
                "aria-label": "Table search",
                "onUpdate:modelValue": c[1] || (c[1] = (P) => H.searchText = P),
                placeholder: "Search..."
              }, null, 8, Ys), [
                [kn, H.searchText]
              ])
            ])
          ])
        ])
      ]),
      s.validatedChartData && s.validatedChartData.length ? (C(), x("div", {
        key: 0,
        id: s.chart.key + "_data_table",
        class: "harness-vue-bootstrap-interactivetable-datatable"
      }, [
        T("table", {
          class: R("harness-vue-bootstrap-interactivetable-table table " + s.tableClass)
        }, [
          T("thead", {
            class: R(s.headerClass)
          }, [
            T("tr", null, [
              (C(!0), x(he, null, ye(s.columnHeaders, (P, A) => (C(), x("th", {
                scope: "col",
                key: A,
                class: R("table-header " + s.labelClass),
                onClick: (te) => H.setColumnFilter(P)
              }, [
                T("button", ta, we(P), 1),
                H.isActiveAndDescending(P) ? (C(), x("span", ra, "\u25BC")) : G("", !0),
                H.isActiveAndAscending(P) ? (C(), x("span", na, "\u25B2")) : G("", !0)
              ], 10, ea))), 128))
            ])
          ], 2),
          T("tbody", null, [
            (C(!0), x(he, null, ye(s.validatedChartData, (P, A) => (C(), x("tr", {
              key: A,
              class: R(s.rowClass)
            }, [
              (C(!0), x(he, null, ye(s.columnHeaders, (te, le) => (C(), x(he, null, [
                le === 0 && s.rowHeaderCol ? (C(), x("th", {
                  key: le,
                  class: R(s.cellClass),
                  innerHTML: P[te],
                  scope: "row"
                }, null, 10, ia)) : (C(), x("td", {
                  key: `${le}-else`,
                  class: R(s.cellClass),
                  innerHTML: P[te]
                }, null, 10, sa))
              ], 64))), 256))
            ], 2))), 128))
          ])
        ], 2)
      ], 8, Zs)) : G("", !0)
    ]),
    T("div", aa, [
      T("div", oa, [
        T("nav", la, [
          T("ul", ua, [
            T("li", {
              class: R(`page-link ${V.pageNumber <= 1 ? "disabled" : ""}`),
              onClick: c[2] || (c[2] = (P) => H.setPageNum(1))
            }, ca, 2),
            T("li", {
              class: R(`page-link ${V.pageNumber <= 1 ? "disabled" : ""}`),
              onClick: c[3] || (c[3] = (P) => V.pageNumber != 1 ? H.setPageNum(V.pageNumber - 1) : "")
            }, ha, 2),
            (C(!0), x(he, null, ye(H.paginationOptions, (P) => (C(), x("li", {
              key: P,
              class: R([
                "page-item",
                "harness-vue-bootstrap-interactivetable-pagination-pageitem",
                P === V.pageNumber ? " active" : ""
              ])
            }, [
              T("button", {
                class: R("page-link"),
                onClick: (A) => H.setPageNum(P)
              }, we(P), 9, pa)
            ], 2))), 128)),
            T("li", {
              class: R(`page-link ${V.pageNumber <= 1 ? "disabled" : ""}`),
              onClick: c[4] || (c[4] = (P) => V.pageNumber < H.numberOfPages.length ? H.setPageNum(V.pageNumber + 1) : "")
            }, ya, 2),
            T("li", {
              class: R(`page-link ${V.pageNumber <= 1 ? "disabled" : ""}`),
              onClick: c[5] || (c[5] = (P) => H.setPageNum(H.numberOfPages.length))
            }, va, 2)
          ])
        ])
      ])
    ])
  ]);
}
const ka = /* @__PURE__ */ Te(Is, [["render", ma], ["__scopeId", "data-v-2483a85a"]]), Ta = {
  name: "filter-picker",
  props: {
    validFilters: {
      required: !0,
      type: Array
    },
    removeButtonPosition: {
      type: String,
      required: !1,
      default: "center",
      validator: function(s) {
        return ["left", "center", "right"].includes(s);
      }
    },
    columnSize: {
      type: Number,
      required: !1,
      default: 12,
      validator: function(s) {
        return 12 % s === 0;
      }
    }
  },
  data() {
    return {
      active: []
    };
  },
  computed: {
    inactive() {
      return this.validFilters.filter(
        function(s) {
          return !this.active.includes(s);
        }.bind(this)
      );
    }
  },
  methods: {
    addFilter(s) {
      s.target.value && this.active.push(s.target.value);
    },
    removeFilter(s) {
      s.target.value && (this.active = this.active.filter((c) => c !== s.target.value), this.setFilter(
        s.target.value,
        this.getFilterDefault(s.target.value)
      ), this.loadData());
    }
  }
}, Ca = { class: "harness-vue-bootstrap-filterpicker" }, wa = { class: "row" }, Sa = { class: "row harness-vue-bootstrap-filtergrid-row" }, xa = { class: "col" }, _a = /* @__PURE__ */ wr("Add Filter"), Da = /* @__PURE__ */ T("option", null, null, -1), La = ["value"], qa = { class: "col" }, Aa = /* @__PURE__ */ wr("Remove Filter"), Na = /* @__PURE__ */ T("option", null, null, -1), Pa = ["value"], Ea = { class: "row button-row harness-vue-bootstrap-filtergrid-row harness-vue-bootstrap-filtergrid-buttonrow pt-3" }, Oa = /* @__PURE__ */ T("hr", null, null, -1);
function Ha(s, c, f, z, V, H) {
  const P = Ke("FilterGrid");
  return C(), x("div", Ca, [
    T("div", wa, [
      T("div", {
        class: R("col-" + f.columnSize)
      }, [
        T("div", Sa, [
          T("div", xa, [
            et(s.$slots, "default", { class: "harness-vue-bootstrap-filterpicker-label" }, () => [
              _a
            ]),
            T("select", {
              class: "form-control harness-vue-bootstrap-filterpicker-select",
              name: "filterPicker",
              id: "filterPicker",
              onChange: c[0] || (c[0] = (...A) => H.addFilter && H.addFilter(...A))
            }, [
              Da,
              (C(!0), x(he, null, ye(H.inactive, (A) => (C(), x("option", {
                key: A,
                value: A
              }, we(s.getLabel(A)), 9, La))), 128))
            ], 32)
          ]),
          T("div", qa, [
            et(s.$slots, "default", { class: "harness-vue-bootstrap-filterpicker-label" }, () => [
              Aa
            ]),
            T("select", {
              class: "form-control harness-vue-bootstrap-filterpicker-select",
              name: "filterPicker",
              id: "filterPicker",
              onChange: c[1] || (c[1] = (...A) => H.removeFilter && H.removeFilter(...A))
            }, [
              Na,
              (C(!0), x(he, null, ye(V.active, (A) => (C(), x("option", {
                key: A,
                value: A
              }, we(s.getLabel(A)), 9, Pa))), 128))
            ], 32)
          ])
        ]),
        T("div", Ea, [
          T("div", {
            class: R("col-md-12 text-" + f.removeButtonPosition)
          }, [
            T("button", {
              role: "button",
              class: "btn btn-primary btn-sm harness-vue-bootstrap-filtergrid-clearbutton",
              onClick: c[2] || (c[2] = (A) => {
                V.active = [], s.initializeDefaults(), s.loadData();
              })
            }, " Remove All Filters ")
          ], 2)
        ]),
        Oa,
        Se(P, ut({ only: V.active }, { ...s.$attrs }), null, 16, ["only"])
      ], 2)
    ])
  ]);
}
const Fa = /* @__PURE__ */ Te(Ta, [["render", Ha]]), Ma = {
  name: "FiltersAccordion",
  props: {
    validFilters: {
      type: Array,
      required: !0
    },
    mappingFunction: {
      type: Function,
      required: !1
    },
    filterLayout: {
      type: Object,
      required: !1
    }
  },
  computed: {
    filterTypes() {
      return Object.keys(this.filters).reduce((s, c) => (c = this.filters[c], c.props && !s.includes(c.props.filterType) && c.props.filterType !== "internal" && c.props.filterType && s.push(c.props.filterType), s), []);
    }
  },
  methods: {
    subsetFiltersByType(s) {
      return Object.keys(this.filters).filter(
        function(c) {
          if (this.filters[c].props)
            return this.filters[c].props.filterType === s && this.validFilters.includes(c);
        }.bind(this)
      );
    },
    filterMapping(s) {
      return this.mappingFunction ? this.mappingFunction(s) : `${s.replace("_", " ")}s`;
    },
    toggle(s) {
      s.preventDefault();
      let c = s.target.id.split("-")[0], f = document.getElementById(c + "-icon");
      if (f.classList.contains("bi-caret-down-square"))
        f.classList.remove("bi-caret-down-square"), f.classList.add("bi-caret-up-square"), this.filterTypes.filter((z) => z !== c).forEach((z) => {
          let V = document.getElementById(z + "-icon");
          V.classList.contains("bi-caret-up-square") && (V.classList.remove("bi-caret-up-square"), V.classList.add("bi-caret-down-square"));
        });
      else if (f.classList.contains("bi-caret-up-square")) {
        let z = document.getElementById(c + "-icon");
        z.classList.remove("bi-caret-up-square"), z.classList.add("bi-caret-down-square");
      }
    },
    dirtyFilterString(s) {
      return this.subsetFiltersByType(s).filter((c) => this.isFilterDirty(c)).map((c) => this.getLabel(c)).join(", ");
    },
    clearFilterTypeFilters(s) {
      let c = this.subsetFiltersByType(s);
      this.initializeDefaults(c), this.loadData();
    },
    filterGridLayout(s) {
      return this.filterLayout ? this.filterLayout[s] : {
        columns: 4,
        labelPosition: "vertical",
        spread: !0
      };
    }
  }
}, ja = { class: "row" }, Ba = {
  class: "accordion col-12",
  id: "filters-accordion"
}, $a = ["id"], Ra = ["id", "data-target"], Ia = { class: "mb-0" }, za = { class: "row" }, Va = ["id"], Wa = ["id"], Ua = ["id", "aria-controls"], Ga = ["id"], Qa = ["id"], Xa = ["id"], Ka = ["id"], Ja = ["id", "aria-labelledby"], Ya = { class: "card-body" }, Za = { class: "row button-row harness-vue-bootstrap-filtergrid-row harness-vue-bootstrap-filtergrid-buttonrow" }, eo = { class: "col-md-12 text-center" }, to = ["onClick"];
function ro(s, c, f, z, V, H) {
  const P = Ke("FilterGrid");
  return C(), x("div", ja, [
    T("div", Ba, [
      (C(!0), x(he, null, ye(H.filterTypes, (A, te) => (C(), x("div", {
        class: "card",
        id: A + "-card",
        key: te
      }, [
        T("div", {
          class: "card-header",
          id: A + "-heading",
          onClick: c[2] || (c[2] = (...le) => H.toggle && H.toggle(...le)),
          "data-toggle": "collapse",
          "data-target": "#collapse-" + A
        }, [
          T("h2", Ia, [
            T("div", za, [
              T("div", {
                class: "col-6",
                id: A + "-col1"
              }, [
                T("i", {
                  class: R(
                    "bi bi-ui-checks " + (H.dirtyFilterString(A).length ? "active" : "")
                  ),
                  id: A + "-checks"
                }, null, 10, Wa),
                T("button", {
                  class: "btn btn-link",
                  id: A + "-button",
                  type: "button",
                  "aria-expanded": "false",
                  "aria-controls": "collapse-" + A
                }, we(H.filterMapping(A)), 9, Ua),
                H.dirtyFilterString(A).length ? (C(), x("small", {
                  key: 0,
                  id: A + "-small"
                }, we(H.dirtyFilterString(A)), 9, Ga)) : G("", !0)
              ], 8, Va),
              T("div", {
                class: "col-6 text-right",
                id: A + "-col2"
              }, [
                T("button", {
                  class: "btn btn-link text-right",
                  id: A + "-collapsebutton",
                  onClick: c[1] || (c[1] = (...le) => H.toggle && H.toggle(...le))
                }, [
                  T("i", {
                    class: "bi bi-caret-down-square",
                    id: A + "-icon",
                    onClick: c[0] || (c[0] = (...le) => H.toggle && H.toggle(...le))
                  }, null, 8, Ka)
                ], 8, Xa)
              ], 8, Qa)
            ])
          ])
        ], 8, Ra),
        T("div", {
          id: "collapse-" + A,
          class: "collapse",
          "aria-labelledby": A + "-heading",
          "data-parent": "#filters-accordion"
        }, [
          T("div", Ya, [
            Se(P, {
              columns: H.filterGridLayout(A).columns,
              "label-position": H.filterGridLayout(A).labelPosition,
              spread: H.filterGridLayout(A).spread,
              only: H.subsetFiltersByType(A),
              "clear-button": !1
            }, null, 8, ["columns", "label-position", "spread", "only"]),
            T("div", Za, [
              T("div", eo, [
                T("button", {
                  class: "btn btn-primary btn-sm harness-vue-bootstrap-filtergrid-clearbutton",
                  role: "button",
                  onClick: (le) => H.clearFilterTypeFilters(A)
                }, " Clear Filters ", 8, to)
              ])
            ])
          ])
        ], 8, Ja)
      ], 8, $a))), 128))
    ])
  ]);
}
const no = /* @__PURE__ */ Te(Ma, [["render", ro]]), Je = {
  props: {
    filter: {
      type: Object,
      required: !0,
      validator: function(s) {
        return Object.keys(s).includes("key");
      }
    }
  }
}, io = {
  name: "InputPartial",
  mixins: [Ve, Je],
  props: {
    type: {
      required: !0,
      type: String
    },
    strictError: {
      type: Boolean,
      required: !0
    },
    prependComponent: {
      required: !1,
      type: Object
    },
    prependHTML: {
      required: !1,
      type: String
    },
    appendComponent: {
      required: !1,
      type: Object
    },
    appendHTML: {
      required: !1,
      type: String
    },
    placeholder: {
      required: !1,
      type: String,
      default: ""
    },
    inputClearButton: {
      required: !1,
      type: Boolean,
      default: !1
    }
  },
  methods: {
    initDefault() {
      this.INITIALIZE_DEFAULTS([this.filter.key]), this.synchronous || this.loadData();
    }
  }
}, so = { class: "input-group" }, ao = {
  key: 1,
  class: "input-group-prepend"
}, oo = ["innerHTML"], lo = ["type", "placeholder", "id", "aria-labelledby"], uo = {
  key: 3,
  class: "input-group-append"
}, fo = ["innerHTML"], co = /* @__PURE__ */ T("i", { class: "bi bi-x" }, null, -1), ho = [
  co
];
function po(s, c, f, z, V, H) {
  return C(), x("div", so, [
    f.prependComponent ? (C(), kt(Et(f.prependComponent), Oe(ut({ key: 0 }, { ...s.$props, ...s.$attrs, strictError: f.strictError })), null, 16)) : f.prependHTML ? (C(), x("div", ao, [
      T("span", {
        class: "input-group-text",
        innerHTML: f.prependHTML
      }, null, 8, oo)
    ])) : G("", !0),
    $e(T("input", {
      type: f.type,
      class: R(`form-control harness-vue-bootstrap-${f.type}-input ${s.isFilterDirty(s.filter.key) ? "dirty-filter-input" : ""} ${f.strictError ? "typeahead-strict-error" : ""}`),
      placeholder: f.placeholder,
      "onUpdate:modelValue": c[0] || (c[0] = (P) => s.boundValue = P),
      id: `${s.filter.key}-${f.type}-input`,
      "aria-labelledby": `${s.filter.key}-label`
    }, null, 10, lo), [
      [Fi, s.boundValue]
    ]),
    f.appendComponent ? (C(), kt(Et(f.appendComponent), Oe(ut({ key: 2 }, { ...s.$props, ...s.$attrs, strictError: f.strictError })), null, 16)) : f.appendHTML || f.inputClearButton ? (C(), x("div", uo, [
      f.appendHTML ? (C(), x("span", {
        key: 0,
        class: "input-group-text",
        innerHTML: f.appendHTML
      }, null, 8, fo)) : G("", !0),
      f.inputClearButton ? (C(), x("button", {
        key: 1,
        class: "btn btn-outline-secondary harness-vue-bootstrap-input-group-clear-button",
        onClick: c[1] || (c[1] = (P) => H.initDefault())
      }, ho)) : G("", !0)
    ])) : G("", !0)
  ]);
}
const go = /* @__PURE__ */ Te(io, [["render", po]]);
var wn = typeof globalThis < "u" ? globalThis : typeof window < "u" ? window : typeof global < "u" ? global : typeof self < "u" ? self : {}, Sr = { exports: {} };
/*!
 * jQuery JavaScript Library v3.6.1
 * https://jquery.com/
 *
 * Includes Sizzle.js
 * https://sizzlejs.com/
 *
 * Copyright OpenJS Foundation and other contributors
 * Released under the MIT license
 * https://jquery.org/license
 *
 * Date: 2022-08-26T17:52Z
 */
(function(s) {
  (function(c, f) {
    s.exports = c.document ? f(c, !0) : function(z) {
      if (!z.document)
        throw new Error("jQuery requires a window with a document");
      return f(z);
    };
  })(typeof window < "u" ? window : wn, function(c, f) {
    var z = [], V = Object.getPrototypeOf, H = z.slice, P = z.flat ? function(e) {
      return z.flat.call(e);
    } : function(e) {
      return z.concat.apply([], e);
    }, A = z.push, te = z.indexOf, le = {}, Ot = le.toString, ft = le.hasOwnProperty, Ht = ft.toString, F = Ht.call(Object), M = {}, w = function(t) {
      return typeof t == "function" && typeof t.nodeType != "number" && typeof t.item != "function";
    }, j = function(t) {
      return t != null && t === t.window;
    }, m = c.document, N = {
      type: !0,
      src: !0,
      nonce: !0,
      noModule: !0
    };
    function L(e, t, r) {
      r = r || m;
      var n, a, o = r.createElement("script");
      if (o.text = e, t)
        for (n in N)
          a = t[n] || t.getAttribute && t.getAttribute(n), a && o.setAttribute(n, a);
      r.head.appendChild(o).parentNode.removeChild(o);
    }
    function _(e) {
      return e == null ? e + "" : typeof e == "object" || typeof e == "function" ? le[Ot.call(e)] || "object" : typeof e;
    }
    var I = "3.6.1", i = function(e, t) {
      return new i.fn.init(e, t);
    };
    i.fn = i.prototype = {
      jquery: I,
      constructor: i,
      length: 0,
      toArray: function() {
        return H.call(this);
      },
      get: function(e) {
        return e == null ? H.call(this) : e < 0 ? this[e + this.length] : this[e];
      },
      pushStack: function(e) {
        var t = i.merge(this.constructor(), e);
        return t.prevObject = this, t;
      },
      each: function(e) {
        return i.each(this, e);
      },
      map: function(e) {
        return this.pushStack(i.map(this, function(t, r) {
          return e.call(t, r, t);
        }));
      },
      slice: function() {
        return this.pushStack(H.apply(this, arguments));
      },
      first: function() {
        return this.eq(0);
      },
      last: function() {
        return this.eq(-1);
      },
      even: function() {
        return this.pushStack(i.grep(this, function(e, t) {
          return (t + 1) % 2;
        }));
      },
      odd: function() {
        return this.pushStack(i.grep(this, function(e, t) {
          return t % 2;
        }));
      },
      eq: function(e) {
        var t = this.length, r = +e + (e < 0 ? t : 0);
        return this.pushStack(r >= 0 && r < t ? [this[r]] : []);
      },
      end: function() {
        return this.prevObject || this.constructor();
      },
      push: A,
      sort: z.sort,
      splice: z.splice
    }, i.extend = i.fn.extend = function() {
      var e, t, r, n, a, o, l = arguments[0] || {}, p = 1, d = arguments.length, b = !1;
      for (typeof l == "boolean" && (b = l, l = arguments[p] || {}, p++), typeof l != "object" && !w(l) && (l = {}), p === d && (l = this, p--); p < d; p++)
        if ((e = arguments[p]) != null)
          for (t in e)
            n = e[t], !(t === "__proto__" || l === n) && (b && n && (i.isPlainObject(n) || (a = Array.isArray(n))) ? (r = l[t], a && !Array.isArray(r) ? o = [] : !a && !i.isPlainObject(r) ? o = {} : o = r, a = !1, l[t] = i.extend(b, o, n)) : n !== void 0 && (l[t] = n));
      return l;
    }, i.extend({
      expando: "jQuery" + (I + Math.random()).replace(/\D/g, ""),
      isReady: !0,
      error: function(e) {
        throw new Error(e);
      },
      noop: function() {
      },
      isPlainObject: function(e) {
        var t, r;
        return !e || Ot.call(e) !== "[object Object]" ? !1 : (t = V(e), t ? (r = ft.call(t, "constructor") && t.constructor, typeof r == "function" && Ht.call(r) === F) : !0);
      },
      isEmptyObject: function(e) {
        var t;
        for (t in e)
          return !1;
        return !0;
      },
      globalEval: function(e, t, r) {
        L(e, { nonce: t && t.nonce }, r);
      },
      each: function(e, t) {
        var r, n = 0;
        if (re(e))
          for (r = e.length; n < r && t.call(e[n], n, e[n]) !== !1; n++)
            ;
        else
          for (n in e)
            if (t.call(e[n], n, e[n]) === !1)
              break;
        return e;
      },
      makeArray: function(e, t) {
        var r = t || [];
        return e != null && (re(Object(e)) ? i.merge(
          r,
          typeof e == "string" ? [e] : e
        ) : A.call(r, e)), r;
      },
      inArray: function(e, t, r) {
        return t == null ? -1 : te.call(t, e, r);
      },
      merge: function(e, t) {
        for (var r = +t.length, n = 0, a = e.length; n < r; n++)
          e[a++] = t[n];
        return e.length = a, e;
      },
      grep: function(e, t, r) {
        for (var n, a = [], o = 0, l = e.length, p = !r; o < l; o++)
          n = !t(e[o], o), n !== p && a.push(e[o]);
        return a;
      },
      map: function(e, t, r) {
        var n, a, o = 0, l = [];
        if (re(e))
          for (n = e.length; o < n; o++)
            a = t(e[o], o, r), a != null && l.push(a);
        else
          for (o in e)
            a = t(e[o], o, r), a != null && l.push(a);
        return P(l);
      },
      guid: 1,
      support: M
    }), typeof Symbol == "function" && (i.fn[Symbol.iterator] = z[Symbol.iterator]), i.each(
      "Boolean Number String Function Array Date RegExp Object Error Symbol".split(" "),
      function(e, t) {
        le["[object " + t + "]"] = t.toLowerCase();
      }
    );
    function re(e) {
      var t = !!e && "length" in e && e.length, r = _(e);
      return w(e) || j(e) ? !1 : r === "array" || t === 0 || typeof t == "number" && t > 0 && t - 1 in e;
    }
    var ne = function(e) {
      var t, r, n, a, o, l, p, d, b, k, E, v, S, W, ee, U, me, be, Ae, ue = "sizzle" + 1 * new Date(), Z = e.document, Le = 0, se = 0, ge = Ut(), qt = Ut(), zt = Ut(), Ne = Ut(), it = function(u, h) {
        return u === h && (E = !0), 0;
      }, st = {}.hasOwnProperty, qe = [], Ye = qe.pop, Fe = qe.push, Ze = qe.push, on = qe.slice, at = function(u, h) {
        for (var g = 0, D = u.length; g < D; g++)
          if (u[g] === h)
            return g;
        return -1;
      }, pr = "checked|selected|async|autofocus|autoplay|controls|defer|disabled|hidden|ismap|loop|multiple|open|readonly|required|scoped", oe = "[\\x20\\t\\r\\n\\f]", ot = "(?:\\\\[\\da-fA-F]{1,6}" + oe + "?|\\\\[^\\r\\n\\f]|[\\w-]|[^\0-\\x7f])+", ln = "\\[" + oe + "*(" + ot + ")(?:" + oe + "*([*^$|!~]?=)" + oe + `*(?:'((?:\\\\.|[^\\\\'])*)'|"((?:\\\\.|[^\\\\"])*)"|(` + ot + "))|)" + oe + "*\\]", gr = ":(" + ot + `)(?:\\((('((?:\\\\.|[^\\\\'])*)'|"((?:\\\\.|[^\\\\"])*)")|((?:\\\\.|[^\\\\()[\\]]|` + ln + ")*)|.*)\\)|)", Ci = new RegExp(oe + "+", "g"), Vt = new RegExp("^" + oe + "+|((?:^|[^\\\\])(?:\\\\.)*)" + oe + "+$", "g"), wi = new RegExp("^" + oe + "*," + oe + "*"), un = new RegExp("^" + oe + "*([>+~]|" + oe + ")" + oe + "*"), Si = new RegExp(oe + "|>"), xi = new RegExp(gr), _i = new RegExp("^" + ot + "$"), Wt = {
        ID: new RegExp("^#(" + ot + ")"),
        CLASS: new RegExp("^\\.(" + ot + ")"),
        TAG: new RegExp("^(" + ot + "|[*])"),
        ATTR: new RegExp("^" + ln),
        PSEUDO: new RegExp("^" + gr),
        CHILD: new RegExp("^:(only|first|last|nth|nth-last)-(child|of-type)(?:\\(" + oe + "*(even|odd|(([+-]|)(\\d*)n|)" + oe + "*(?:([+-]|)" + oe + "*(\\d+)|))" + oe + "*\\)|)", "i"),
        bool: new RegExp("^(?:" + pr + ")$", "i"),
        needsContext: new RegExp("^" + oe + "*[>+~]|:(even|odd|eq|gt|lt|nth|first|last)(?:\\(" + oe + "*((?:-\\d)?\\d*)" + oe + "*\\)|)(?=[^-]|$)", "i")
      }, Di = /HTML$/i, Li = /^(?:input|select|textarea|button)$/i, qi = /^h\d$/i, At = /^[^{]+\{\s*\[native \w/, Ai = /^(?:#([\w-]+)|(\w+)|\.([\w-]+))$/, yr = /[+~]/, Qe = new RegExp("\\\\[\\da-fA-F]{1,6}" + oe + "?|\\\\([^\\r\\n\\f])", "g"), Xe = function(u, h) {
        var g = "0x" + u.slice(1) - 65536;
        return h || (g < 0 ? String.fromCharCode(g + 65536) : String.fromCharCode(g >> 10 | 55296, g & 1023 | 56320));
      }, fn = /([\0-\x1f\x7f]|^-?\d)|^-$|[^\0-\x1f\x7f-\uFFFF\w-]/g, cn = function(u, h) {
        return h ? u === "\0" ? "\uFFFD" : u.slice(0, -1) + "\\" + u.charCodeAt(u.length - 1).toString(16) + " " : "\\" + u;
      }, dn = function() {
        v();
      }, Ni = Qt(
        function(u) {
          return u.disabled === !0 && u.nodeName.toLowerCase() === "fieldset";
        },
        { dir: "parentNode", next: "legend" }
      );
      try {
        Ze.apply(
          qe = on.call(Z.childNodes),
          Z.childNodes
        ), qe[Z.childNodes.length].nodeType;
      } catch {
        Ze = {
          apply: qe.length ? function(h, g) {
            Fe.apply(h, on.call(g));
          } : function(h, g) {
            for (var D = h.length, y = 0; h[D++] = g[y++]; )
              ;
            h.length = D - 1;
          }
        };
      }
      function fe(u, h, g, D) {
        var y, q, O, B, $, K, Q, Y = h && h.ownerDocument, ie = h ? h.nodeType : 9;
        if (g = g || [], typeof u != "string" || !u || ie !== 1 && ie !== 9 && ie !== 11)
          return g;
        if (!D && (v(h), h = h || S, ee)) {
          if (ie !== 11 && ($ = Ai.exec(u)))
            if (y = $[1]) {
              if (ie === 9)
                if (O = h.getElementById(y)) {
                  if (O.id === y)
                    return g.push(O), g;
                } else
                  return g;
              else if (Y && (O = Y.getElementById(y)) && Ae(h, O) && O.id === y)
                return g.push(O), g;
            } else {
              if ($[2])
                return Ze.apply(g, h.getElementsByTagName(u)), g;
              if ((y = $[3]) && r.getElementsByClassName && h.getElementsByClassName)
                return Ze.apply(g, h.getElementsByClassName(y)), g;
            }
          if (r.qsa && !Ne[u + " "] && (!U || !U.test(u)) && (ie !== 1 || h.nodeName.toLowerCase() !== "object")) {
            if (Q = u, Y = h, ie === 1 && (Si.test(u) || un.test(u))) {
              for (Y = yr.test(u) && vr(h.parentNode) || h, (Y !== h || !r.scope) && ((B = h.getAttribute("id")) ? B = B.replace(fn, cn) : h.setAttribute("id", B = ue)), K = l(u), q = K.length; q--; )
                K[q] = (B ? "#" + B : ":scope") + " " + Gt(K[q]);
              Q = K.join(",");
            }
            try {
              return Ze.apply(
                g,
                Y.querySelectorAll(Q)
              ), g;
            } catch {
              Ne(u, !0);
            } finally {
              B === ue && h.removeAttribute("id");
            }
          }
        }
        return d(u.replace(Vt, "$1"), h, g, D);
      }
      function Ut() {
        var u = [];
        function h(g, D) {
          return u.push(g + " ") > n.cacheLength && delete h[u.shift()], h[g + " "] = D;
        }
        return h;
      }
      function je(u) {
        return u[ue] = !0, u;
      }
      function Be(u) {
        var h = S.createElement("fieldset");
        try {
          return !!u(h);
        } catch {
          return !1;
        } finally {
          h.parentNode && h.parentNode.removeChild(h), h = null;
        }
      }
      function br(u, h) {
        for (var g = u.split("|"), D = g.length; D--; )
          n.attrHandle[g[D]] = h;
      }
      function hn(u, h) {
        var g = h && u, D = g && u.nodeType === 1 && h.nodeType === 1 && u.sourceIndex - h.sourceIndex;
        if (D)
          return D;
        if (g) {
          for (; g = g.nextSibling; )
            if (g === h)
              return -1;
        }
        return u ? 1 : -1;
      }
      function Pi(u) {
        return function(h) {
          var g = h.nodeName.toLowerCase();
          return g === "input" && h.type === u;
        };
      }
      function Ei(u) {
        return function(h) {
          var g = h.nodeName.toLowerCase();
          return (g === "input" || g === "button") && h.type === u;
        };
      }
      function pn(u) {
        return function(h) {
          return "form" in h ? h.parentNode && h.disabled === !1 ? "label" in h ? "label" in h.parentNode ? h.parentNode.disabled === u : h.disabled === u : h.isDisabled === u || h.isDisabled !== !u && Ni(h) === u : h.disabled === u : "label" in h ? h.disabled === u : !1;
        };
      }
      function lt(u) {
        return je(function(h) {
          return h = +h, je(function(g, D) {
            for (var y, q = u([], g.length, h), O = q.length; O--; )
              g[y = q[O]] && (g[y] = !(D[y] = g[y]));
          });
        });
      }
      function vr(u) {
        return u && typeof u.getElementsByTagName < "u" && u;
      }
      r = fe.support = {}, o = fe.isXML = function(u) {
        var h = u && u.namespaceURI, g = u && (u.ownerDocument || u).documentElement;
        return !Di.test(h || g && g.nodeName || "HTML");
      }, v = fe.setDocument = function(u) {
        var h, g, D = u ? u.ownerDocument || u : Z;
        return D == S || D.nodeType !== 9 || !D.documentElement || (S = D, W = S.documentElement, ee = !o(S), Z != S && (g = S.defaultView) && g.top !== g && (g.addEventListener ? g.addEventListener("unload", dn, !1) : g.attachEvent && g.attachEvent("onunload", dn)), r.scope = Be(function(y) {
          return W.appendChild(y).appendChild(S.createElement("div")), typeof y.querySelectorAll < "u" && !y.querySelectorAll(":scope fieldset div").length;
        }), r.attributes = Be(function(y) {
          return y.className = "i", !y.getAttribute("className");
        }), r.getElementsByTagName = Be(function(y) {
          return y.appendChild(S.createComment("")), !y.getElementsByTagName("*").length;
        }), r.getElementsByClassName = At.test(S.getElementsByClassName), r.getById = Be(function(y) {
          return W.appendChild(y).id = ue, !S.getElementsByName || !S.getElementsByName(ue).length;
        }), r.getById ? (n.filter.ID = function(y) {
          var q = y.replace(Qe, Xe);
          return function(O) {
            return O.getAttribute("id") === q;
          };
        }, n.find.ID = function(y, q) {
          if (typeof q.getElementById < "u" && ee) {
            var O = q.getElementById(y);
            return O ? [O] : [];
          }
        }) : (n.filter.ID = function(y) {
          var q = y.replace(Qe, Xe);
          return function(O) {
            var B = typeof O.getAttributeNode < "u" && O.getAttributeNode("id");
            return B && B.value === q;
          };
        }, n.find.ID = function(y, q) {
          if (typeof q.getElementById < "u" && ee) {
            var O, B, $, K = q.getElementById(y);
            if (K) {
              if (O = K.getAttributeNode("id"), O && O.value === y)
                return [K];
              for ($ = q.getElementsByName(y), B = 0; K = $[B++]; )
                if (O = K.getAttributeNode("id"), O && O.value === y)
                  return [K];
            }
            return [];
          }
        }), n.find.TAG = r.getElementsByTagName ? function(y, q) {
          if (typeof q.getElementsByTagName < "u")
            return q.getElementsByTagName(y);
          if (r.qsa)
            return q.querySelectorAll(y);
        } : function(y, q) {
          var O, B = [], $ = 0, K = q.getElementsByTagName(y);
          if (y === "*") {
            for (; O = K[$++]; )
              O.nodeType === 1 && B.push(O);
            return B;
          }
          return K;
        }, n.find.CLASS = r.getElementsByClassName && function(y, q) {
          if (typeof q.getElementsByClassName < "u" && ee)
            return q.getElementsByClassName(y);
        }, me = [], U = [], (r.qsa = At.test(S.querySelectorAll)) && (Be(function(y) {
          var q;
          W.appendChild(y).innerHTML = "<a id='" + ue + "'></a><select id='" + ue + "-\r\\' msallowcapture=''><option selected=''></option></select>", y.querySelectorAll("[msallowcapture^='']").length && U.push("[*^$]=" + oe + `*(?:''|"")`), y.querySelectorAll("[selected]").length || U.push("\\[" + oe + "*(?:value|" + pr + ")"), y.querySelectorAll("[id~=" + ue + "-]").length || U.push("~="), q = S.createElement("input"), q.setAttribute("name", ""), y.appendChild(q), y.querySelectorAll("[name='']").length || U.push("\\[" + oe + "*name" + oe + "*=" + oe + `*(?:''|"")`), y.querySelectorAll(":checked").length || U.push(":checked"), y.querySelectorAll("a#" + ue + "+*").length || U.push(".#.+[+~]"), y.querySelectorAll("\\\f"), U.push("[\\r\\n\\f]");
        }), Be(function(y) {
          y.innerHTML = "<a href='' disabled='disabled'></a><select disabled='disabled'><option/></select>";
          var q = S.createElement("input");
          q.setAttribute("type", "hidden"), y.appendChild(q).setAttribute("name", "D"), y.querySelectorAll("[name=d]").length && U.push("name" + oe + "*[*^$|!~]?="), y.querySelectorAll(":enabled").length !== 2 && U.push(":enabled", ":disabled"), W.appendChild(y).disabled = !0, y.querySelectorAll(":disabled").length !== 2 && U.push(":enabled", ":disabled"), y.querySelectorAll("*,:x"), U.push(",.*:");
        })), (r.matchesSelector = At.test(be = W.matches || W.webkitMatchesSelector || W.mozMatchesSelector || W.oMatchesSelector || W.msMatchesSelector)) && Be(function(y) {
          r.disconnectedMatch = be.call(y, "*"), be.call(y, "[s!='']:x"), me.push("!=", gr);
        }), U = U.length && new RegExp(U.join("|")), me = me.length && new RegExp(me.join("|")), h = At.test(W.compareDocumentPosition), Ae = h || At.test(W.contains) ? function(y, q) {
          var O = y.nodeType === 9 ? y.documentElement : y, B = q && q.parentNode;
          return y === B || !!(B && B.nodeType === 1 && (O.contains ? O.contains(B) : y.compareDocumentPosition && y.compareDocumentPosition(B) & 16));
        } : function(y, q) {
          if (q) {
            for (; q = q.parentNode; )
              if (q === y)
                return !0;
          }
          return !1;
        }, it = h ? function(y, q) {
          if (y === q)
            return E = !0, 0;
          var O = !y.compareDocumentPosition - !q.compareDocumentPosition;
          return O || (O = (y.ownerDocument || y) == (q.ownerDocument || q) ? y.compareDocumentPosition(q) : 1, O & 1 || !r.sortDetached && q.compareDocumentPosition(y) === O ? y == S || y.ownerDocument == Z && Ae(Z, y) ? -1 : q == S || q.ownerDocument == Z && Ae(Z, q) ? 1 : k ? at(k, y) - at(k, q) : 0 : O & 4 ? -1 : 1);
        } : function(y, q) {
          if (y === q)
            return E = !0, 0;
          var O, B = 0, $ = y.parentNode, K = q.parentNode, Q = [y], Y = [q];
          if (!$ || !K)
            return y == S ? -1 : q == S ? 1 : $ ? -1 : K ? 1 : k ? at(k, y) - at(k, q) : 0;
          if ($ === K)
            return hn(y, q);
          for (O = y; O = O.parentNode; )
            Q.unshift(O);
          for (O = q; O = O.parentNode; )
            Y.unshift(O);
          for (; Q[B] === Y[B]; )
            B++;
          return B ? hn(Q[B], Y[B]) : Q[B] == Z ? -1 : Y[B] == Z ? 1 : 0;
        }), S;
      }, fe.matches = function(u, h) {
        return fe(u, null, null, h);
      }, fe.matchesSelector = function(u, h) {
        if (v(u), r.matchesSelector && ee && !Ne[h + " "] && (!me || !me.test(h)) && (!U || !U.test(h)))
          try {
            var g = be.call(u, h);
            if (g || r.disconnectedMatch || u.document && u.document.nodeType !== 11)
              return g;
          } catch {
            Ne(h, !0);
          }
        return fe(h, S, null, [u]).length > 0;
      }, fe.contains = function(u, h) {
        return (u.ownerDocument || u) != S && v(u), Ae(u, h);
      }, fe.attr = function(u, h) {
        (u.ownerDocument || u) != S && v(u);
        var g = n.attrHandle[h.toLowerCase()], D = g && st.call(n.attrHandle, h.toLowerCase()) ? g(u, h, !ee) : void 0;
        return D !== void 0 ? D : r.attributes || !ee ? u.getAttribute(h) : (D = u.getAttributeNode(h)) && D.specified ? D.value : null;
      }, fe.escape = function(u) {
        return (u + "").replace(fn, cn);
      }, fe.error = function(u) {
        throw new Error("Syntax error, unrecognized expression: " + u);
      }, fe.uniqueSort = function(u) {
        var h, g = [], D = 0, y = 0;
        if (E = !r.detectDuplicates, k = !r.sortStable && u.slice(0), u.sort(it), E) {
          for (; h = u[y++]; )
            h === u[y] && (D = g.push(y));
          for (; D--; )
            u.splice(g[D], 1);
        }
        return k = null, u;
      }, a = fe.getText = function(u) {
        var h, g = "", D = 0, y = u.nodeType;
        if (y) {
          if (y === 1 || y === 9 || y === 11) {
            if (typeof u.textContent == "string")
              return u.textContent;
            for (u = u.firstChild; u; u = u.nextSibling)
              g += a(u);
          } else if (y === 3 || y === 4)
            return u.nodeValue;
        } else
          for (; h = u[D++]; )
            g += a(h);
        return g;
      }, n = fe.selectors = {
        cacheLength: 50,
        createPseudo: je,
        match: Wt,
        attrHandle: {},
        find: {},
        relative: {
          ">": { dir: "parentNode", first: !0 },
          " ": { dir: "parentNode" },
          "+": { dir: "previousSibling", first: !0 },
          "~": { dir: "previousSibling" }
        },
        preFilter: {
          ATTR: function(u) {
            return u[1] = u[1].replace(Qe, Xe), u[3] = (u[3] || u[4] || u[5] || "").replace(Qe, Xe), u[2] === "~=" && (u[3] = " " + u[3] + " "), u.slice(0, 4);
          },
          CHILD: function(u) {
            return u[1] = u[1].toLowerCase(), u[1].slice(0, 3) === "nth" ? (u[3] || fe.error(u[0]), u[4] = +(u[4] ? u[5] + (u[6] || 1) : 2 * (u[3] === "even" || u[3] === "odd")), u[5] = +(u[7] + u[8] || u[3] === "odd")) : u[3] && fe.error(u[0]), u;
          },
          PSEUDO: function(u) {
            var h, g = !u[6] && u[2];
            return Wt.CHILD.test(u[0]) ? null : (u[3] ? u[2] = u[4] || u[5] || "" : g && xi.test(g) && (h = l(g, !0)) && (h = g.indexOf(")", g.length - h) - g.length) && (u[0] = u[0].slice(0, h), u[2] = g.slice(0, h)), u.slice(0, 3));
          }
        },
        filter: {
          TAG: function(u) {
            var h = u.replace(Qe, Xe).toLowerCase();
            return u === "*" ? function() {
              return !0;
            } : function(g) {
              return g.nodeName && g.nodeName.toLowerCase() === h;
            };
          },
          CLASS: function(u) {
            var h = ge[u + " "];
            return h || (h = new RegExp("(^|" + oe + ")" + u + "(" + oe + "|$)")) && ge(
              u,
              function(g) {
                return h.test(
                  typeof g.className == "string" && g.className || typeof g.getAttribute < "u" && g.getAttribute("class") || ""
                );
              }
            );
          },
          ATTR: function(u, h, g) {
            return function(D) {
              var y = fe.attr(D, u);
              return y == null ? h === "!=" : h ? (y += "", h === "=" ? y === g : h === "!=" ? y !== g : h === "^=" ? g && y.indexOf(g) === 0 : h === "*=" ? g && y.indexOf(g) > -1 : h === "$=" ? g && y.slice(-g.length) === g : h === "~=" ? (" " + y.replace(Ci, " ") + " ").indexOf(g) > -1 : h === "|=" ? y === g || y.slice(0, g.length + 1) === g + "-" : !1) : !0;
            };
          },
          CHILD: function(u, h, g, D, y) {
            var q = u.slice(0, 3) !== "nth", O = u.slice(-4) !== "last", B = h === "of-type";
            return D === 1 && y === 0 ? function($) {
              return !!$.parentNode;
            } : function($, K, Q) {
              var Y, ie, ce, J, ke, Ce, Pe = q !== O ? "nextSibling" : "previousSibling", pe = $.parentNode, Nt = B && $.nodeName.toLowerCase(), Pt = !Q && !B, Ee = !1;
              if (pe) {
                if (q) {
                  for (; Pe; ) {
                    for (J = $; J = J[Pe]; )
                      if (B ? J.nodeName.toLowerCase() === Nt : J.nodeType === 1)
                        return !1;
                    Ce = Pe = u === "only" && !Ce && "nextSibling";
                  }
                  return !0;
                }
                if (Ce = [O ? pe.firstChild : pe.lastChild], O && Pt) {
                  for (J = pe, ce = J[ue] || (J[ue] = {}), ie = ce[J.uniqueID] || (ce[J.uniqueID] = {}), Y = ie[u] || [], ke = Y[0] === Le && Y[1], Ee = ke && Y[2], J = ke && pe.childNodes[ke]; J = ++ke && J && J[Pe] || (Ee = ke = 0) || Ce.pop(); )
                    if (J.nodeType === 1 && ++Ee && J === $) {
                      ie[u] = [Le, ke, Ee];
                      break;
                    }
                } else if (Pt && (J = $, ce = J[ue] || (J[ue] = {}), ie = ce[J.uniqueID] || (ce[J.uniqueID] = {}), Y = ie[u] || [], ke = Y[0] === Le && Y[1], Ee = ke), Ee === !1)
                  for (; (J = ++ke && J && J[Pe] || (Ee = ke = 0) || Ce.pop()) && !((B ? J.nodeName.toLowerCase() === Nt : J.nodeType === 1) && ++Ee && (Pt && (ce = J[ue] || (J[ue] = {}), ie = ce[J.uniqueID] || (ce[J.uniqueID] = {}), ie[u] = [Le, Ee]), J === $)); )
                    ;
                return Ee -= y, Ee === D || Ee % D === 0 && Ee / D >= 0;
              }
            };
          },
          PSEUDO: function(u, h) {
            var g, D = n.pseudos[u] || n.setFilters[u.toLowerCase()] || fe.error("unsupported pseudo: " + u);
            return D[ue] ? D(h) : D.length > 1 ? (g = [u, u, "", h], n.setFilters.hasOwnProperty(u.toLowerCase()) ? je(function(y, q) {
              for (var O, B = D(y, h), $ = B.length; $--; )
                O = at(y, B[$]), y[O] = !(q[O] = B[$]);
            }) : function(y) {
              return D(y, 0, g);
            }) : D;
          }
        },
        pseudos: {
          not: je(function(u) {
            var h = [], g = [], D = p(u.replace(Vt, "$1"));
            return D[ue] ? je(function(y, q, O, B) {
              for (var $, K = D(y, null, B, []), Q = y.length; Q--; )
                ($ = K[Q]) && (y[Q] = !(q[Q] = $));
            }) : function(y, q, O) {
              return h[0] = y, D(h, null, O, g), h[0] = null, !g.pop();
            };
          }),
          has: je(function(u) {
            return function(h) {
              return fe(u, h).length > 0;
            };
          }),
          contains: je(function(u) {
            return u = u.replace(Qe, Xe), function(h) {
              return (h.textContent || a(h)).indexOf(u) > -1;
            };
          }),
          lang: je(function(u) {
            return _i.test(u || "") || fe.error("unsupported lang: " + u), u = u.replace(Qe, Xe).toLowerCase(), function(h) {
              var g;
              do
                if (g = ee ? h.lang : h.getAttribute("xml:lang") || h.getAttribute("lang"))
                  return g = g.toLowerCase(), g === u || g.indexOf(u + "-") === 0;
              while ((h = h.parentNode) && h.nodeType === 1);
              return !1;
            };
          }),
          target: function(u) {
            var h = e.location && e.location.hash;
            return h && h.slice(1) === u.id;
          },
          root: function(u) {
            return u === W;
          },
          focus: function(u) {
            return u === S.activeElement && (!S.hasFocus || S.hasFocus()) && !!(u.type || u.href || ~u.tabIndex);
          },
          enabled: pn(!1),
          disabled: pn(!0),
          checked: function(u) {
            var h = u.nodeName.toLowerCase();
            return h === "input" && !!u.checked || h === "option" && !!u.selected;
          },
          selected: function(u) {
            return u.parentNode && u.parentNode.selectedIndex, u.selected === !0;
          },
          empty: function(u) {
            for (u = u.firstChild; u; u = u.nextSibling)
              if (u.nodeType < 6)
                return !1;
            return !0;
          },
          parent: function(u) {
            return !n.pseudos.empty(u);
          },
          header: function(u) {
            return qi.test(u.nodeName);
          },
          input: function(u) {
            return Li.test(u.nodeName);
          },
          button: function(u) {
            var h = u.nodeName.toLowerCase();
            return h === "input" && u.type === "button" || h === "button";
          },
          text: function(u) {
            var h;
            return u.nodeName.toLowerCase() === "input" && u.type === "text" && ((h = u.getAttribute("type")) == null || h.toLowerCase() === "text");
          },
          first: lt(function() {
            return [0];
          }),
          last: lt(function(u, h) {
            return [h - 1];
          }),
          eq: lt(function(u, h, g) {
            return [g < 0 ? g + h : g];
          }),
          even: lt(function(u, h) {
            for (var g = 0; g < h; g += 2)
              u.push(g);
            return u;
          }),
          odd: lt(function(u, h) {
            for (var g = 1; g < h; g += 2)
              u.push(g);
            return u;
          }),
          lt: lt(function(u, h, g) {
            for (var D = g < 0 ? g + h : g > h ? h : g; --D >= 0; )
              u.push(D);
            return u;
          }),
          gt: lt(function(u, h, g) {
            for (var D = g < 0 ? g + h : g; ++D < h; )
              u.push(D);
            return u;
          })
        }
      }, n.pseudos.nth = n.pseudos.eq;
      for (t in { radio: !0, checkbox: !0, file: !0, password: !0, image: !0 })
        n.pseudos[t] = Pi(t);
      for (t in { submit: !0, reset: !0 })
        n.pseudos[t] = Ei(t);
      function gn() {
      }
      gn.prototype = n.filters = n.pseudos, n.setFilters = new gn(), l = fe.tokenize = function(u, h) {
        var g, D, y, q, O, B, $, K = qt[u + " "];
        if (K)
          return h ? 0 : K.slice(0);
        for (O = u, B = [], $ = n.preFilter; O; ) {
          (!g || (D = wi.exec(O))) && (D && (O = O.slice(D[0].length) || O), B.push(y = [])), g = !1, (D = un.exec(O)) && (g = D.shift(), y.push({
            value: g,
            type: D[0].replace(Vt, " ")
          }), O = O.slice(g.length));
          for (q in n.filter)
            (D = Wt[q].exec(O)) && (!$[q] || (D = $[q](D))) && (g = D.shift(), y.push({
              value: g,
              type: q,
              matches: D
            }), O = O.slice(g.length));
          if (!g)
            break;
        }
        return h ? O.length : O ? fe.error(u) : qt(u, B).slice(0);
      };
      function Gt(u) {
        for (var h = 0, g = u.length, D = ""; h < g; h++)
          D += u[h].value;
        return D;
      }
      function Qt(u, h, g) {
        var D = h.dir, y = h.next, q = y || D, O = g && q === "parentNode", B = se++;
        return h.first ? function($, K, Q) {
          for (; $ = $[D]; )
            if ($.nodeType === 1 || O)
              return u($, K, Q);
          return !1;
        } : function($, K, Q) {
          var Y, ie, ce, J = [Le, B];
          if (Q) {
            for (; $ = $[D]; )
              if (($.nodeType === 1 || O) && u($, K, Q))
                return !0;
          } else
            for (; $ = $[D]; )
              if ($.nodeType === 1 || O)
                if (ce = $[ue] || ($[ue] = {}), ie = ce[$.uniqueID] || (ce[$.uniqueID] = {}), y && y === $.nodeName.toLowerCase())
                  $ = $[D] || $;
                else {
                  if ((Y = ie[q]) && Y[0] === Le && Y[1] === B)
                    return J[2] = Y[2];
                  if (ie[q] = J, J[2] = u($, K, Q))
                    return !0;
                }
          return !1;
        };
      }
      function mr(u) {
        return u.length > 1 ? function(h, g, D) {
          for (var y = u.length; y--; )
            if (!u[y](h, g, D))
              return !1;
          return !0;
        } : u[0];
      }
      function Oi(u, h, g) {
        for (var D = 0, y = h.length; D < y; D++)
          fe(u, h[D], g);
        return g;
      }
      function Xt(u, h, g, D, y) {
        for (var q, O = [], B = 0, $ = u.length, K = h != null; B < $; B++)
          (q = u[B]) && (!g || g(q, D, y)) && (O.push(q), K && h.push(B));
        return O;
      }
      function kr(u, h, g, D, y, q) {
        return D && !D[ue] && (D = kr(D)), y && !y[ue] && (y = kr(y, q)), je(function(O, B, $, K) {
          var Q, Y, ie, ce = [], J = [], ke = B.length, Ce = O || Oi(
            h || "*",
            $.nodeType ? [$] : $,
            []
          ), Pe = u && (O || !h) ? Xt(Ce, ce, u, $, K) : Ce, pe = g ? y || (O ? u : ke || D) ? [] : B : Pe;
          if (g && g(Pe, pe, $, K), D)
            for (Q = Xt(pe, J), D(Q, [], $, K), Y = Q.length; Y--; )
              (ie = Q[Y]) && (pe[J[Y]] = !(Pe[J[Y]] = ie));
          if (O) {
            if (y || u) {
              if (y) {
                for (Q = [], Y = pe.length; Y--; )
                  (ie = pe[Y]) && Q.push(Pe[Y] = ie);
                y(null, pe = [], Q, K);
              }
              for (Y = pe.length; Y--; )
                (ie = pe[Y]) && (Q = y ? at(O, ie) : ce[Y]) > -1 && (O[Q] = !(B[Q] = ie));
            }
          } else
            pe = Xt(
              pe === B ? pe.splice(ke, pe.length) : pe
            ), y ? y(null, B, pe, K) : Ze.apply(B, pe);
        });
      }
      function Tr(u) {
        for (var h, g, D, y = u.length, q = n.relative[u[0].type], O = q || n.relative[" "], B = q ? 1 : 0, $ = Qt(function(Y) {
          return Y === h;
        }, O, !0), K = Qt(function(Y) {
          return at(h, Y) > -1;
        }, O, !0), Q = [function(Y, ie, ce) {
          var J = !q && (ce || ie !== b) || ((h = ie).nodeType ? $(Y, ie, ce) : K(Y, ie, ce));
          return h = null, J;
        }]; B < y; B++)
          if (g = n.relative[u[B].type])
            Q = [Qt(mr(Q), g)];
          else {
            if (g = n.filter[u[B].type].apply(null, u[B].matches), g[ue]) {
              for (D = ++B; D < y && !n.relative[u[D].type]; D++)
                ;
              return kr(
                B > 1 && mr(Q),
                B > 1 && Gt(
                  u.slice(0, B - 1).concat({ value: u[B - 2].type === " " ? "*" : "" })
                ).replace(Vt, "$1"),
                g,
                B < D && Tr(u.slice(B, D)),
                D < y && Tr(u = u.slice(D)),
                D < y && Gt(u)
              );
            }
            Q.push(g);
          }
        return mr(Q);
      }
      function Hi(u, h) {
        var g = h.length > 0, D = u.length > 0, y = function(q, O, B, $, K) {
          var Q, Y, ie, ce = 0, J = "0", ke = q && [], Ce = [], Pe = b, pe = q || D && n.find.TAG("*", K), Nt = Le += Pe == null ? 1 : Math.random() || 0.1, Pt = pe.length;
          for (K && (b = O == S || O || K); J !== Pt && (Q = pe[J]) != null; J++) {
            if (D && Q) {
              for (Y = 0, !O && Q.ownerDocument != S && (v(Q), B = !ee); ie = u[Y++]; )
                if (ie(Q, O || S, B)) {
                  $.push(Q);
                  break;
                }
              K && (Le = Nt);
            }
            g && ((Q = !ie && Q) && ce--, q && ke.push(Q));
          }
          if (ce += J, g && J !== ce) {
            for (Y = 0; ie = h[Y++]; )
              ie(ke, Ce, O, B);
            if (q) {
              if (ce > 0)
                for (; J--; )
                  ke[J] || Ce[J] || (Ce[J] = Ye.call($));
              Ce = Xt(Ce);
            }
            Ze.apply($, Ce), K && !q && Ce.length > 0 && ce + h.length > 1 && fe.uniqueSort($);
          }
          return K && (Le = Nt, b = Pe), ke;
        };
        return g ? je(y) : y;
      }
      return p = fe.compile = function(u, h) {
        var g, D = [], y = [], q = zt[u + " "];
        if (!q) {
          for (h || (h = l(u)), g = h.length; g--; )
            q = Tr(h[g]), q[ue] ? D.push(q) : y.push(q);
          q = zt(
            u,
            Hi(y, D)
          ), q.selector = u;
        }
        return q;
      }, d = fe.select = function(u, h, g, D) {
        var y, q, O, B, $, K = typeof u == "function" && u, Q = !D && l(u = K.selector || u);
        if (g = g || [], Q.length === 1) {
          if (q = Q[0] = Q[0].slice(0), q.length > 2 && (O = q[0]).type === "ID" && h.nodeType === 9 && ee && n.relative[q[1].type]) {
            if (h = (n.find.ID(O.matches[0].replace(Qe, Xe), h) || [])[0], h)
              K && (h = h.parentNode);
            else
              return g;
            u = u.slice(q.shift().value.length);
          }
          for (y = Wt.needsContext.test(u) ? 0 : q.length; y-- && (O = q[y], !n.relative[B = O.type]); )
            if (($ = n.find[B]) && (D = $(
              O.matches[0].replace(Qe, Xe),
              yr.test(q[0].type) && vr(h.parentNode) || h
            ))) {
              if (q.splice(y, 1), u = D.length && Gt(q), !u)
                return Ze.apply(g, D), g;
              break;
            }
        }
        return (K || p(u, Q))(
          D,
          h,
          !ee,
          g,
          !h || yr.test(u) && vr(h.parentNode) || h
        ), g;
      }, r.sortStable = ue.split("").sort(it).join("") === ue, r.detectDuplicates = !!E, v(), r.sortDetached = Be(function(u) {
        return u.compareDocumentPosition(S.createElement("fieldset")) & 1;
      }), Be(function(u) {
        return u.innerHTML = "<a href='#'></a>", u.firstChild.getAttribute("href") === "#";
      }) || br("type|href|height|width", function(u, h, g) {
        if (!g)
          return u.getAttribute(h, h.toLowerCase() === "type" ? 1 : 2);
      }), (!r.attributes || !Be(function(u) {
        return u.innerHTML = "<input/>", u.firstChild.setAttribute("value", ""), u.firstChild.getAttribute("value") === "";
      })) && br("value", function(u, h, g) {
        if (!g && u.nodeName.toLowerCase() === "input")
          return u.defaultValue;
      }), Be(function(u) {
        return u.getAttribute("disabled") == null;
      }) || br(pr, function(u, h, g) {
        var D;
        if (!g)
          return u[h] === !0 ? h.toLowerCase() : (D = u.getAttributeNode(h)) && D.specified ? D.value : null;
      }), fe;
    }(c);
    i.find = ne, i.expr = ne.selectors, i.expr[":"] = i.expr.pseudos, i.uniqueSort = i.unique = ne.uniqueSort, i.text = ne.getText, i.isXMLDoc = ne.isXML, i.contains = ne.contains, i.escapeSelector = ne.escape;
    var de = function(e, t, r) {
      for (var n = [], a = r !== void 0; (e = e[t]) && e.nodeType !== 9; )
        if (e.nodeType === 1) {
          if (a && i(e).is(r))
            break;
          n.push(e);
        }
      return n;
    }, ae = function(e, t) {
      for (var r = []; e; e = e.nextSibling)
        e.nodeType === 1 && e !== t && r.push(e);
      return r;
    }, We = i.expr.match.needsContext;
    function ve(e, t) {
      return e.nodeName && e.nodeName.toLowerCase() === t.toLowerCase();
    }
    var ct = /^<([a-z][^\/\0>:\x20\t\r\n\f]*)[\x20\t\r\n\f]*\/?>(?:<\/\1>|)$/i;
    function Yt(e, t, r) {
      return w(t) ? i.grep(e, function(n, a) {
        return !!t.call(n, a, n) !== r;
      }) : t.nodeType ? i.grep(e, function(n) {
        return n === t !== r;
      }) : typeof t != "string" ? i.grep(e, function(n) {
        return te.call(t, n) > -1 !== r;
      }) : i.filter(t, e, r);
    }
    i.filter = function(e, t, r) {
      var n = t[0];
      return r && (e = ":not(" + e + ")"), t.length === 1 && n.nodeType === 1 ? i.find.matchesSelector(n, e) ? [n] : [] : i.find.matches(e, i.grep(t, function(a) {
        return a.nodeType === 1;
      }));
    }, i.fn.extend({
      find: function(e) {
        var t, r, n = this.length, a = this;
        if (typeof e != "string")
          return this.pushStack(i(e).filter(function() {
            for (t = 0; t < n; t++)
              if (i.contains(a[t], this))
                return !0;
          }));
        for (r = this.pushStack([]), t = 0; t < n; t++)
          i.find(e, a[t], r);
        return n > 1 ? i.uniqueSort(r) : r;
      },
      filter: function(e) {
        return this.pushStack(Yt(this, e || [], !1));
      },
      not: function(e) {
        return this.pushStack(Yt(this, e || [], !0));
      },
      is: function(e) {
        return !!Yt(
          this,
          typeof e == "string" && We.test(e) ? i(e) : e || [],
          !1
        ).length;
      }
    });
    var xr, xn = /^(?:\s*(<[\w\W]+>)[^>]*|#([\w-]+))$/, _n = i.fn.init = function(e, t, r) {
      var n, a;
      if (!e)
        return this;
      if (r = r || xr, typeof e == "string")
        if (e[0] === "<" && e[e.length - 1] === ">" && e.length >= 3 ? n = [null, e, null] : n = xn.exec(e), n && (n[1] || !t))
          if (n[1]) {
            if (t = t instanceof i ? t[0] : t, i.merge(this, i.parseHTML(
              n[1],
              t && t.nodeType ? t.ownerDocument || t : m,
              !0
            )), ct.test(n[1]) && i.isPlainObject(t))
              for (n in t)
                w(this[n]) ? this[n](t[n]) : this.attr(n, t[n]);
            return this;
          } else
            return a = m.getElementById(n[2]), a && (this[0] = a, this.length = 1), this;
        else
          return !t || t.jquery ? (t || r).find(e) : this.constructor(t).find(e);
      else {
        if (e.nodeType)
          return this[0] = e, this.length = 1, this;
        if (w(e))
          return r.ready !== void 0 ? r.ready(e) : e(i);
      }
      return i.makeArray(e, this);
    };
    _n.prototype = i.fn, xr = i(m);
    var Dn = /^(?:parents|prev(?:Until|All))/, Ln = {
      children: !0,
      contents: !0,
      next: !0,
      prev: !0
    };
    i.fn.extend({
      has: function(e) {
        var t = i(e, this), r = t.length;
        return this.filter(function() {
          for (var n = 0; n < r; n++)
            if (i.contains(this, t[n]))
              return !0;
        });
      },
      closest: function(e, t) {
        var r, n = 0, a = this.length, o = [], l = typeof e != "string" && i(e);
        if (!We.test(e)) {
          for (; n < a; n++)
            for (r = this[n]; r && r !== t; r = r.parentNode)
              if (r.nodeType < 11 && (l ? l.index(r) > -1 : r.nodeType === 1 && i.find.matchesSelector(r, e))) {
                o.push(r);
                break;
              }
        }
        return this.pushStack(o.length > 1 ? i.uniqueSort(o) : o);
      },
      index: function(e) {
        return e ? typeof e == "string" ? te.call(i(e), this[0]) : te.call(
          this,
          e.jquery ? e[0] : e
        ) : this[0] && this[0].parentNode ? this.first().prevAll().length : -1;
      },
      add: function(e, t) {
        return this.pushStack(
          i.uniqueSort(
            i.merge(this.get(), i(e, t))
          )
        );
      },
      addBack: function(e) {
        return this.add(
          e == null ? this.prevObject : this.prevObject.filter(e)
        );
      }
    });
    function _r(e, t) {
      for (; (e = e[t]) && e.nodeType !== 1; )
        ;
      return e;
    }
    i.each({
      parent: function(e) {
        var t = e.parentNode;
        return t && t.nodeType !== 11 ? t : null;
      },
      parents: function(e) {
        return de(e, "parentNode");
      },
      parentsUntil: function(e, t, r) {
        return de(e, "parentNode", r);
      },
      next: function(e) {
        return _r(e, "nextSibling");
      },
      prev: function(e) {
        return _r(e, "previousSibling");
      },
      nextAll: function(e) {
        return de(e, "nextSibling");
      },
      prevAll: function(e) {
        return de(e, "previousSibling");
      },
      nextUntil: function(e, t, r) {
        return de(e, "nextSibling", r);
      },
      prevUntil: function(e, t, r) {
        return de(e, "previousSibling", r);
      },
      siblings: function(e) {
        return ae((e.parentNode || {}).firstChild, e);
      },
      children: function(e) {
        return ae(e.firstChild);
      },
      contents: function(e) {
        return e.contentDocument != null && V(e.contentDocument) ? e.contentDocument : (ve(e, "template") && (e = e.content || e), i.merge([], e.childNodes));
      }
    }, function(e, t) {
      i.fn[e] = function(r, n) {
        var a = i.map(this, t, r);
        return e.slice(-5) !== "Until" && (n = r), n && typeof n == "string" && (a = i.filter(n, a)), this.length > 1 && (Ln[e] || i.uniqueSort(a), Dn.test(e) && a.reverse()), this.pushStack(a);
      };
    });
    var Ie = /[^\x20\t\r\n\f]+/g;
    function qn(e) {
      var t = {};
      return i.each(e.match(Ie) || [], function(r, n) {
        t[n] = !0;
      }), t;
    }
    i.Callbacks = function(e) {
      e = typeof e == "string" ? qn(e) : i.extend({}, e);
      var t, r, n, a, o = [], l = [], p = -1, d = function() {
        for (a = a || e.once, n = t = !0; l.length; p = -1)
          for (r = l.shift(); ++p < o.length; )
            o[p].apply(r[0], r[1]) === !1 && e.stopOnFalse && (p = o.length, r = !1);
        e.memory || (r = !1), t = !1, a && (r ? o = [] : o = "");
      }, b = {
        add: function() {
          return o && (r && !t && (p = o.length - 1, l.push(r)), function k(E) {
            i.each(E, function(v, S) {
              w(S) ? (!e.unique || !b.has(S)) && o.push(S) : S && S.length && _(S) !== "string" && k(S);
            });
          }(arguments), r && !t && d()), this;
        },
        remove: function() {
          return i.each(arguments, function(k, E) {
            for (var v; (v = i.inArray(E, o, v)) > -1; )
              o.splice(v, 1), v <= p && p--;
          }), this;
        },
        has: function(k) {
          return k ? i.inArray(k, o) > -1 : o.length > 0;
        },
        empty: function() {
          return o && (o = []), this;
        },
        disable: function() {
          return a = l = [], o = r = "", this;
        },
        disabled: function() {
          return !o;
        },
        lock: function() {
          return a = l = [], !r && !t && (o = r = ""), this;
        },
        locked: function() {
          return !!a;
        },
        fireWith: function(k, E) {
          return a || (E = E || [], E = [k, E.slice ? E.slice() : E], l.push(E), t || d()), this;
        },
        fire: function() {
          return b.fireWith(this, arguments), this;
        },
        fired: function() {
          return !!n;
        }
      };
      return b;
    };
    function dt(e) {
      return e;
    }
    function Ft(e) {
      throw e;
    }
    function Dr(e, t, r, n) {
      var a;
      try {
        e && w(a = e.promise) ? a.call(e).done(t).fail(r) : e && w(a = e.then) ? a.call(e, t, r) : t.apply(void 0, [e].slice(n));
      } catch (o) {
        r.apply(void 0, [o]);
      }
    }
    i.extend({
      Deferred: function(e) {
        var t = [
          [
            "notify",
            "progress",
            i.Callbacks("memory"),
            i.Callbacks("memory"),
            2
          ],
          [
            "resolve",
            "done",
            i.Callbacks("once memory"),
            i.Callbacks("once memory"),
            0,
            "resolved"
          ],
          [
            "reject",
            "fail",
            i.Callbacks("once memory"),
            i.Callbacks("once memory"),
            1,
            "rejected"
          ]
        ], r = "pending", n = {
          state: function() {
            return r;
          },
          always: function() {
            return a.done(arguments).fail(arguments), this;
          },
          catch: function(o) {
            return n.then(null, o);
          },
          pipe: function() {
            var o = arguments;
            return i.Deferred(function(l) {
              i.each(t, function(p, d) {
                var b = w(o[d[4]]) && o[d[4]];
                a[d[1]](function() {
                  var k = b && b.apply(this, arguments);
                  k && w(k.promise) ? k.promise().progress(l.notify).done(l.resolve).fail(l.reject) : l[d[0] + "With"](
                    this,
                    b ? [k] : arguments
                  );
                });
              }), o = null;
            }).promise();
          },
          then: function(o, l, p) {
            var d = 0;
            function b(k, E, v, S) {
              return function() {
                var W = this, ee = arguments, U = function() {
                  var be, Ae;
                  if (!(k < d)) {
                    if (be = v.apply(W, ee), be === E.promise())
                      throw new TypeError("Thenable self-resolution");
                    Ae = be && (typeof be == "object" || typeof be == "function") && be.then, w(Ae) ? S ? Ae.call(
                      be,
                      b(d, E, dt, S),
                      b(d, E, Ft, S)
                    ) : (d++, Ae.call(
                      be,
                      b(d, E, dt, S),
                      b(d, E, Ft, S),
                      b(
                        d,
                        E,
                        dt,
                        E.notifyWith
                      )
                    )) : (v !== dt && (W = void 0, ee = [be]), (S || E.resolveWith)(W, ee));
                  }
                }, me = S ? U : function() {
                  try {
                    U();
                  } catch (be) {
                    i.Deferred.exceptionHook && i.Deferred.exceptionHook(
                      be,
                      me.stackTrace
                    ), k + 1 >= d && (v !== Ft && (W = void 0, ee = [be]), E.rejectWith(W, ee));
                  }
                };
                k ? me() : (i.Deferred.getStackHook && (me.stackTrace = i.Deferred.getStackHook()), c.setTimeout(me));
              };
            }
            return i.Deferred(function(k) {
              t[0][3].add(
                b(
                  0,
                  k,
                  w(p) ? p : dt,
                  k.notifyWith
                )
              ), t[1][3].add(
                b(
                  0,
                  k,
                  w(o) ? o : dt
                )
              ), t[2][3].add(
                b(
                  0,
                  k,
                  w(l) ? l : Ft
                )
              );
            }).promise();
          },
          promise: function(o) {
            return o != null ? i.extend(o, n) : n;
          }
        }, a = {};
        return i.each(t, function(o, l) {
          var p = l[2], d = l[5];
          n[l[1]] = p.add, d && p.add(
            function() {
              r = d;
            },
            t[3 - o][2].disable,
            t[3 - o][3].disable,
            t[0][2].lock,
            t[0][3].lock
          ), p.add(l[3].fire), a[l[0]] = function() {
            return a[l[0] + "With"](this === a ? void 0 : this, arguments), this;
          }, a[l[0] + "With"] = p.fireWith;
        }), n.promise(a), e && e.call(a, a), a;
      },
      when: function(e) {
        var t = arguments.length, r = t, n = Array(r), a = H.call(arguments), o = i.Deferred(), l = function(p) {
          return function(d) {
            n[p] = this, a[p] = arguments.length > 1 ? H.call(arguments) : d, --t || o.resolveWith(n, a);
          };
        };
        if (t <= 1 && (Dr(
          e,
          o.done(l(r)).resolve,
          o.reject,
          !t
        ), o.state() === "pending" || w(a[r] && a[r].then)))
          return o.then();
        for (; r--; )
          Dr(a[r], l(r), o.reject);
        return o.promise();
      }
    });
    var An = /^(Eval|Internal|Range|Reference|Syntax|Type|URI)Error$/;
    i.Deferred.exceptionHook = function(e, t) {
      c.console && c.console.warn && e && An.test(e.name) && c.console.warn("jQuery.Deferred exception: " + e.message, e.stack, t);
    }, i.readyException = function(e) {
      c.setTimeout(function() {
        throw e;
      });
    };
    var Zt = i.Deferred();
    i.fn.ready = function(e) {
      return Zt.then(e).catch(function(t) {
        i.readyException(t);
      }), this;
    }, i.extend({
      isReady: !1,
      readyWait: 1,
      ready: function(e) {
        (e === !0 ? --i.readyWait : i.isReady) || (i.isReady = !0, !(e !== !0 && --i.readyWait > 0) && Zt.resolveWith(m, [i]));
      }
    }), i.ready.then = Zt.then;
    function Mt() {
      m.removeEventListener("DOMContentLoaded", Mt), c.removeEventListener("load", Mt), i.ready();
    }
    m.readyState === "complete" || m.readyState !== "loading" && !m.documentElement.doScroll ? c.setTimeout(i.ready) : (m.addEventListener("DOMContentLoaded", Mt), c.addEventListener("load", Mt));
    var Ue = function(e, t, r, n, a, o, l) {
      var p = 0, d = e.length, b = r == null;
      if (_(r) === "object") {
        a = !0;
        for (p in r)
          Ue(e, t, p, r[p], !0, o, l);
      } else if (n !== void 0 && (a = !0, w(n) || (l = !0), b && (l ? (t.call(e, n), t = null) : (b = t, t = function(k, E, v) {
        return b.call(i(k), v);
      })), t))
        for (; p < d; p++)
          t(
            e[p],
            r,
            l ? n : n.call(e[p], p, t(e[p], r))
          );
      return a ? e : b ? t.call(e) : d ? t(e[0], r) : o;
    }, Nn = /^-ms-/, Pn = /-([a-z])/g;
    function En(e, t) {
      return t.toUpperCase();
    }
    function ze(e) {
      return e.replace(Nn, "ms-").replace(Pn, En);
    }
    var Tt = function(e) {
      return e.nodeType === 1 || e.nodeType === 9 || !+e.nodeType;
    };
    function Ct() {
      this.expando = i.expando + Ct.uid++;
    }
    Ct.uid = 1, Ct.prototype = {
      cache: function(e) {
        var t = e[this.expando];
        return t || (t = {}, Tt(e) && (e.nodeType ? e[this.expando] = t : Object.defineProperty(e, this.expando, {
          value: t,
          configurable: !0
        }))), t;
      },
      set: function(e, t, r) {
        var n, a = this.cache(e);
        if (typeof t == "string")
          a[ze(t)] = r;
        else
          for (n in t)
            a[ze(n)] = t[n];
        return a;
      },
      get: function(e, t) {
        return t === void 0 ? this.cache(e) : e[this.expando] && e[this.expando][ze(t)];
      },
      access: function(e, t, r) {
        return t === void 0 || t && typeof t == "string" && r === void 0 ? this.get(e, t) : (this.set(e, t, r), r !== void 0 ? r : t);
      },
      remove: function(e, t) {
        var r, n = e[this.expando];
        if (n !== void 0) {
          if (t !== void 0)
            for (Array.isArray(t) ? t = t.map(ze) : (t = ze(t), t = t in n ? [t] : t.match(Ie) || []), r = t.length; r--; )
              delete n[t[r]];
          (t === void 0 || i.isEmptyObject(n)) && (e.nodeType ? e[this.expando] = void 0 : delete e[this.expando]);
        }
      },
      hasData: function(e) {
        var t = e[this.expando];
        return t !== void 0 && !i.isEmptyObject(t);
      }
    };
    var X = new Ct(), xe = new Ct(), On = /^(?:\{[\w\W]*\}|\[[\w\W]*\])$/, Hn = /[A-Z]/g;
    function Fn(e) {
      return e === "true" ? !0 : e === "false" ? !1 : e === "null" ? null : e === +e + "" ? +e : On.test(e) ? JSON.parse(e) : e;
    }
    function Lr(e, t, r) {
      var n;
      if (r === void 0 && e.nodeType === 1)
        if (n = "data-" + t.replace(Hn, "-$&").toLowerCase(), r = e.getAttribute(n), typeof r == "string") {
          try {
            r = Fn(r);
          } catch {
          }
          xe.set(e, t, r);
        } else
          r = void 0;
      return r;
    }
    i.extend({
      hasData: function(e) {
        return xe.hasData(e) || X.hasData(e);
      },
      data: function(e, t, r) {
        return xe.access(e, t, r);
      },
      removeData: function(e, t) {
        xe.remove(e, t);
      },
      _data: function(e, t, r) {
        return X.access(e, t, r);
      },
      _removeData: function(e, t) {
        X.remove(e, t);
      }
    }), i.fn.extend({
      data: function(e, t) {
        var r, n, a, o = this[0], l = o && o.attributes;
        if (e === void 0) {
          if (this.length && (a = xe.get(o), o.nodeType === 1 && !X.get(o, "hasDataAttrs"))) {
            for (r = l.length; r--; )
              l[r] && (n = l[r].name, n.indexOf("data-") === 0 && (n = ze(n.slice(5)), Lr(o, n, a[n])));
            X.set(o, "hasDataAttrs", !0);
          }
          return a;
        }
        return typeof e == "object" ? this.each(function() {
          xe.set(this, e);
        }) : Ue(this, function(p) {
          var d;
          if (o && p === void 0)
            return d = xe.get(o, e), d !== void 0 || (d = Lr(o, e), d !== void 0) ? d : void 0;
          this.each(function() {
            xe.set(this, e, p);
          });
        }, null, t, arguments.length > 1, null, !0);
      },
      removeData: function(e) {
        return this.each(function() {
          xe.remove(this, e);
        });
      }
    }), i.extend({
      queue: function(e, t, r) {
        var n;
        if (e)
          return t = (t || "fx") + "queue", n = X.get(e, t), r && (!n || Array.isArray(r) ? n = X.access(e, t, i.makeArray(r)) : n.push(r)), n || [];
      },
      dequeue: function(e, t) {
        t = t || "fx";
        var r = i.queue(e, t), n = r.length, a = r.shift(), o = i._queueHooks(e, t), l = function() {
          i.dequeue(e, t);
        };
        a === "inprogress" && (a = r.shift(), n--), a && (t === "fx" && r.unshift("inprogress"), delete o.stop, a.call(e, l, o)), !n && o && o.empty.fire();
      },
      _queueHooks: function(e, t) {
        var r = t + "queueHooks";
        return X.get(e, r) || X.access(e, r, {
          empty: i.Callbacks("once memory").add(function() {
            X.remove(e, [t + "queue", r]);
          })
        });
      }
    }), i.fn.extend({
      queue: function(e, t) {
        var r = 2;
        return typeof e != "string" && (t = e, e = "fx", r--), arguments.length < r ? i.queue(this[0], e) : t === void 0 ? this : this.each(function() {
          var n = i.queue(this, e, t);
          i._queueHooks(this, e), e === "fx" && n[0] !== "inprogress" && i.dequeue(this, e);
        });
      },
      dequeue: function(e) {
        return this.each(function() {
          i.dequeue(this, e);
        });
      },
      clearQueue: function(e) {
        return this.queue(e || "fx", []);
      },
      promise: function(e, t) {
        var r, n = 1, a = i.Deferred(), o = this, l = this.length, p = function() {
          --n || a.resolveWith(o, [o]);
        };
        for (typeof e != "string" && (t = e, e = void 0), e = e || "fx"; l--; )
          r = X.get(o[l], e + "queueHooks"), r && r.empty && (n++, r.empty.add(p));
        return p(), a.promise(t);
      }
    });
    var qr = /[+-]?(?:\d*\.|)\d+(?:[eE][+-]?\d+|)/.source, wt = new RegExp("^(?:([+-])=|)(" + qr + ")([a-z%]*)$", "i"), Ge = ["Top", "Right", "Bottom", "Left"], tt = m.documentElement, ht = function(e) {
      return i.contains(e.ownerDocument, e);
    }, Mn = { composed: !0 };
    tt.getRootNode && (ht = function(e) {
      return i.contains(e.ownerDocument, e) || e.getRootNode(Mn) === e.ownerDocument;
    });
    var jt = function(e, t) {
      return e = t || e, e.style.display === "none" || e.style.display === "" && ht(e) && i.css(e, "display") === "none";
    };
    function Ar(e, t, r, n) {
      var a, o, l = 20, p = n ? function() {
        return n.cur();
      } : function() {
        return i.css(e, t, "");
      }, d = p(), b = r && r[3] || (i.cssNumber[t] ? "" : "px"), k = e.nodeType && (i.cssNumber[t] || b !== "px" && +d) && wt.exec(i.css(e, t));
      if (k && k[3] !== b) {
        for (d = d / 2, b = b || k[3], k = +d || 1; l--; )
          i.style(e, t, k + b), (1 - o) * (1 - (o = p() / d || 0.5)) <= 0 && (l = 0), k = k / o;
        k = k * 2, i.style(e, t, k + b), r = r || [];
      }
      return r && (k = +k || +d || 0, a = r[1] ? k + (r[1] + 1) * r[2] : +r[2], n && (n.unit = b, n.start = k, n.end = a)), a;
    }
    var Nr = {};
    function jn(e) {
      var t, r = e.ownerDocument, n = e.nodeName, a = Nr[n];
      return a || (t = r.body.appendChild(r.createElement(n)), a = i.css(t, "display"), t.parentNode.removeChild(t), a === "none" && (a = "block"), Nr[n] = a, a);
    }
    function pt(e, t) {
      for (var r, n, a = [], o = 0, l = e.length; o < l; o++)
        n = e[o], n.style && (r = n.style.display, t ? (r === "none" && (a[o] = X.get(n, "display") || null, a[o] || (n.style.display = "")), n.style.display === "" && jt(n) && (a[o] = jn(n))) : r !== "none" && (a[o] = "none", X.set(n, "display", r)));
      for (o = 0; o < l; o++)
        a[o] != null && (e[o].style.display = a[o]);
      return e;
    }
    i.fn.extend({
      show: function() {
        return pt(this, !0);
      },
      hide: function() {
        return pt(this);
      },
      toggle: function(e) {
        return typeof e == "boolean" ? e ? this.show() : this.hide() : this.each(function() {
          jt(this) ? i(this).show() : i(this).hide();
        });
      }
    });
    var St = /^(?:checkbox|radio)$/i, Pr = /<([a-z][^\/\0>\x20\t\r\n\f]*)/i, Er = /^$|^module$|\/(?:java|ecma)script/i;
    (function() {
      var e = m.createDocumentFragment(), t = e.appendChild(m.createElement("div")), r = m.createElement("input");
      r.setAttribute("type", "radio"), r.setAttribute("checked", "checked"), r.setAttribute("name", "t"), t.appendChild(r), M.checkClone = t.cloneNode(!0).cloneNode(!0).lastChild.checked, t.innerHTML = "<textarea>x</textarea>", M.noCloneChecked = !!t.cloneNode(!0).lastChild.defaultValue, t.innerHTML = "<option></option>", M.option = !!t.lastChild;
    })();
    var He = {
      thead: [1, "<table>", "</table>"],
      col: [2, "<table><colgroup>", "</colgroup></table>"],
      tr: [2, "<table><tbody>", "</tbody></table>"],
      td: [3, "<table><tbody><tr>", "</tr></tbody></table>"],
      _default: [0, "", ""]
    };
    He.tbody = He.tfoot = He.colgroup = He.caption = He.thead, He.th = He.td, M.option || (He.optgroup = He.option = [1, "<select multiple='multiple'>", "</select>"]);
    function _e(e, t) {
      var r;
      return typeof e.getElementsByTagName < "u" ? r = e.getElementsByTagName(t || "*") : typeof e.querySelectorAll < "u" ? r = e.querySelectorAll(t || "*") : r = [], t === void 0 || t && ve(e, t) ? i.merge([e], r) : r;
    }
    function er(e, t) {
      for (var r = 0, n = e.length; r < n; r++)
        X.set(
          e[r],
          "globalEval",
          !t || X.get(t[r], "globalEval")
        );
    }
    var Bn = /<|&#?\w+;/;
    function Or(e, t, r, n, a) {
      for (var o, l, p, d, b, k, E = t.createDocumentFragment(), v = [], S = 0, W = e.length; S < W; S++)
        if (o = e[S], o || o === 0)
          if (_(o) === "object")
            i.merge(v, o.nodeType ? [o] : o);
          else if (!Bn.test(o))
            v.push(t.createTextNode(o));
          else {
            for (l = l || E.appendChild(t.createElement("div")), p = (Pr.exec(o) || ["", ""])[1].toLowerCase(), d = He[p] || He._default, l.innerHTML = d[1] + i.htmlPrefilter(o) + d[2], k = d[0]; k--; )
              l = l.lastChild;
            i.merge(v, l.childNodes), l = E.firstChild, l.textContent = "";
          }
      for (E.textContent = "", S = 0; o = v[S++]; ) {
        if (n && i.inArray(o, n) > -1) {
          a && a.push(o);
          continue;
        }
        if (b = ht(o), l = _e(E.appendChild(o), "script"), b && er(l), r)
          for (k = 0; o = l[k++]; )
            Er.test(o.type || "") && r.push(o);
      }
      return E;
    }
    var Hr = /^([^.]*)(?:\.(.+)|)/;
    function gt() {
      return !0;
    }
    function yt() {
      return !1;
    }
    function $n(e, t) {
      return e === Rn() == (t === "focus");
    }
    function Rn() {
      try {
        return m.activeElement;
      } catch {
      }
    }
    function tr(e, t, r, n, a, o) {
      var l, p;
      if (typeof t == "object") {
        typeof r != "string" && (n = n || r, r = void 0);
        for (p in t)
          tr(e, p, r, n, t[p], o);
        return e;
      }
      if (n == null && a == null ? (a = r, n = r = void 0) : a == null && (typeof r == "string" ? (a = n, n = void 0) : (a = n, n = r, r = void 0)), a === !1)
        a = yt;
      else if (!a)
        return e;
      return o === 1 && (l = a, a = function(d) {
        return i().off(d), l.apply(this, arguments);
      }, a.guid = l.guid || (l.guid = i.guid++)), e.each(function() {
        i.event.add(this, t, a, n, r);
      });
    }
    i.event = {
      global: {},
      add: function(e, t, r, n, a) {
        var o, l, p, d, b, k, E, v, S, W, ee, U = X.get(e);
        if (!!Tt(e))
          for (r.handler && (o = r, r = o.handler, a = o.selector), a && i.find.matchesSelector(tt, a), r.guid || (r.guid = i.guid++), (d = U.events) || (d = U.events = /* @__PURE__ */ Object.create(null)), (l = U.handle) || (l = U.handle = function(me) {
            return typeof i < "u" && i.event.triggered !== me.type ? i.event.dispatch.apply(e, arguments) : void 0;
          }), t = (t || "").match(Ie) || [""], b = t.length; b--; )
            p = Hr.exec(t[b]) || [], S = ee = p[1], W = (p[2] || "").split(".").sort(), S && (E = i.event.special[S] || {}, S = (a ? E.delegateType : E.bindType) || S, E = i.event.special[S] || {}, k = i.extend({
              type: S,
              origType: ee,
              data: n,
              handler: r,
              guid: r.guid,
              selector: a,
              needsContext: a && i.expr.match.needsContext.test(a),
              namespace: W.join(".")
            }, o), (v = d[S]) || (v = d[S] = [], v.delegateCount = 0, (!E.setup || E.setup.call(e, n, W, l) === !1) && e.addEventListener && e.addEventListener(S, l)), E.add && (E.add.call(e, k), k.handler.guid || (k.handler.guid = r.guid)), a ? v.splice(v.delegateCount++, 0, k) : v.push(k), i.event.global[S] = !0);
      },
      remove: function(e, t, r, n, a) {
        var o, l, p, d, b, k, E, v, S, W, ee, U = X.hasData(e) && X.get(e);
        if (!(!U || !(d = U.events))) {
          for (t = (t || "").match(Ie) || [""], b = t.length; b--; ) {
            if (p = Hr.exec(t[b]) || [], S = ee = p[1], W = (p[2] || "").split(".").sort(), !S) {
              for (S in d)
                i.event.remove(e, S + t[b], r, n, !0);
              continue;
            }
            for (E = i.event.special[S] || {}, S = (n ? E.delegateType : E.bindType) || S, v = d[S] || [], p = p[2] && new RegExp("(^|\\.)" + W.join("\\.(?:.*\\.|)") + "(\\.|$)"), l = o = v.length; o--; )
              k = v[o], (a || ee === k.origType) && (!r || r.guid === k.guid) && (!p || p.test(k.namespace)) && (!n || n === k.selector || n === "**" && k.selector) && (v.splice(o, 1), k.selector && v.delegateCount--, E.remove && E.remove.call(e, k));
            l && !v.length && ((!E.teardown || E.teardown.call(e, W, U.handle) === !1) && i.removeEvent(e, S, U.handle), delete d[S]);
          }
          i.isEmptyObject(d) && X.remove(e, "handle events");
        }
      },
      dispatch: function(e) {
        var t, r, n, a, o, l, p = new Array(arguments.length), d = i.event.fix(e), b = (X.get(this, "events") || /* @__PURE__ */ Object.create(null))[d.type] || [], k = i.event.special[d.type] || {};
        for (p[0] = d, t = 1; t < arguments.length; t++)
          p[t] = arguments[t];
        if (d.delegateTarget = this, !(k.preDispatch && k.preDispatch.call(this, d) === !1)) {
          for (l = i.event.handlers.call(this, d, b), t = 0; (a = l[t++]) && !d.isPropagationStopped(); )
            for (d.currentTarget = a.elem, r = 0; (o = a.handlers[r++]) && !d.isImmediatePropagationStopped(); )
              (!d.rnamespace || o.namespace === !1 || d.rnamespace.test(o.namespace)) && (d.handleObj = o, d.data = o.data, n = ((i.event.special[o.origType] || {}).handle || o.handler).apply(a.elem, p), n !== void 0 && (d.result = n) === !1 && (d.preventDefault(), d.stopPropagation()));
          return k.postDispatch && k.postDispatch.call(this, d), d.result;
        }
      },
      handlers: function(e, t) {
        var r, n, a, o, l, p = [], d = t.delegateCount, b = e.target;
        if (d && b.nodeType && !(e.type === "click" && e.button >= 1)) {
          for (; b !== this; b = b.parentNode || this)
            if (b.nodeType === 1 && !(e.type === "click" && b.disabled === !0)) {
              for (o = [], l = {}, r = 0; r < d; r++)
                n = t[r], a = n.selector + " ", l[a] === void 0 && (l[a] = n.needsContext ? i(a, this).index(b) > -1 : i.find(a, this, null, [b]).length), l[a] && o.push(n);
              o.length && p.push({ elem: b, handlers: o });
            }
        }
        return b = this, d < t.length && p.push({ elem: b, handlers: t.slice(d) }), p;
      },
      addProp: function(e, t) {
        Object.defineProperty(i.Event.prototype, e, {
          enumerable: !0,
          configurable: !0,
          get: w(t) ? function() {
            if (this.originalEvent)
              return t(this.originalEvent);
          } : function() {
            if (this.originalEvent)
              return this.originalEvent[e];
          },
          set: function(r) {
            Object.defineProperty(this, e, {
              enumerable: !0,
              configurable: !0,
              writable: !0,
              value: r
            });
          }
        });
      },
      fix: function(e) {
        return e[i.expando] ? e : new i.Event(e);
      },
      special: {
        load: {
          noBubble: !0
        },
        click: {
          setup: function(e) {
            var t = this || e;
            return St.test(t.type) && t.click && ve(t, "input") && Bt(t, "click", gt), !1;
          },
          trigger: function(e) {
            var t = this || e;
            return St.test(t.type) && t.click && ve(t, "input") && Bt(t, "click"), !0;
          },
          _default: function(e) {
            var t = e.target;
            return St.test(t.type) && t.click && ve(t, "input") && X.get(t, "click") || ve(t, "a");
          }
        },
        beforeunload: {
          postDispatch: function(e) {
            e.result !== void 0 && e.originalEvent && (e.originalEvent.returnValue = e.result);
          }
        }
      }
    };
    function Bt(e, t, r) {
      if (!r) {
        X.get(e, t) === void 0 && i.event.add(e, t, gt);
        return;
      }
      X.set(e, t, !1), i.event.add(e, t, {
        namespace: !1,
        handler: function(n) {
          var a, o, l = X.get(this, t);
          if (n.isTrigger & 1 && this[t]) {
            if (l.length)
              (i.event.special[t] || {}).delegateType && n.stopPropagation();
            else if (l = H.call(arguments), X.set(this, t, l), a = r(this, t), this[t](), o = X.get(this, t), l !== o || a ? X.set(this, t, !1) : o = {}, l !== o)
              return n.stopImmediatePropagation(), n.preventDefault(), o && o.value;
          } else
            l.length && (X.set(this, t, {
              value: i.event.trigger(
                i.extend(l[0], i.Event.prototype),
                l.slice(1),
                this
              )
            }), n.stopImmediatePropagation());
        }
      });
    }
    i.removeEvent = function(e, t, r) {
      e.removeEventListener && e.removeEventListener(t, r);
    }, i.Event = function(e, t) {
      if (!(this instanceof i.Event))
        return new i.Event(e, t);
      e && e.type ? (this.originalEvent = e, this.type = e.type, this.isDefaultPrevented = e.defaultPrevented || e.defaultPrevented === void 0 && e.returnValue === !1 ? gt : yt, this.target = e.target && e.target.nodeType === 3 ? e.target.parentNode : e.target, this.currentTarget = e.currentTarget, this.relatedTarget = e.relatedTarget) : this.type = e, t && i.extend(this, t), this.timeStamp = e && e.timeStamp || Date.now(), this[i.expando] = !0;
    }, i.Event.prototype = {
      constructor: i.Event,
      isDefaultPrevented: yt,
      isPropagationStopped: yt,
      isImmediatePropagationStopped: yt,
      isSimulated: !1,
      preventDefault: function() {
        var e = this.originalEvent;
        this.isDefaultPrevented = gt, e && !this.isSimulated && e.preventDefault();
      },
      stopPropagation: function() {
        var e = this.originalEvent;
        this.isPropagationStopped = gt, e && !this.isSimulated && e.stopPropagation();
      },
      stopImmediatePropagation: function() {
        var e = this.originalEvent;
        this.isImmediatePropagationStopped = gt, e && !this.isSimulated && e.stopImmediatePropagation(), this.stopPropagation();
      }
    }, i.each({
      altKey: !0,
      bubbles: !0,
      cancelable: !0,
      changedTouches: !0,
      ctrlKey: !0,
      detail: !0,
      eventPhase: !0,
      metaKey: !0,
      pageX: !0,
      pageY: !0,
      shiftKey: !0,
      view: !0,
      char: !0,
      code: !0,
      charCode: !0,
      key: !0,
      keyCode: !0,
      button: !0,
      buttons: !0,
      clientX: !0,
      clientY: !0,
      offsetX: !0,
      offsetY: !0,
      pointerId: !0,
      pointerType: !0,
      screenX: !0,
      screenY: !0,
      targetTouches: !0,
      toElement: !0,
      touches: !0,
      which: !0
    }, i.event.addProp), i.each({ focus: "focusin", blur: "focusout" }, function(e, t) {
      i.event.special[e] = {
        setup: function() {
          return Bt(this, e, $n), !1;
        },
        trigger: function() {
          return Bt(this, e), !0;
        },
        _default: function(r) {
          return X.get(r.target, e);
        },
        delegateType: t
      };
    }), i.each({
      mouseenter: "mouseover",
      mouseleave: "mouseout",
      pointerenter: "pointerover",
      pointerleave: "pointerout"
    }, function(e, t) {
      i.event.special[e] = {
        delegateType: t,
        bindType: t,
        handle: function(r) {
          var n, a = this, o = r.relatedTarget, l = r.handleObj;
          return (!o || o !== a && !i.contains(a, o)) && (r.type = l.origType, n = l.handler.apply(this, arguments), r.type = t), n;
        }
      };
    }), i.fn.extend({
      on: function(e, t, r, n) {
        return tr(this, e, t, r, n);
      },
      one: function(e, t, r, n) {
        return tr(this, e, t, r, n, 1);
      },
      off: function(e, t, r) {
        var n, a;
        if (e && e.preventDefault && e.handleObj)
          return n = e.handleObj, i(e.delegateTarget).off(
            n.namespace ? n.origType + "." + n.namespace : n.origType,
            n.selector,
            n.handler
          ), this;
        if (typeof e == "object") {
          for (a in e)
            this.off(a, t, e[a]);
          return this;
        }
        return (t === !1 || typeof t == "function") && (r = t, t = void 0), r === !1 && (r = yt), this.each(function() {
          i.event.remove(this, e, r, t);
        });
      }
    });
    var In = /<script|<style|<link/i, zn = /checked\s*(?:[^=]|=\s*.checked.)/i, Vn = /^\s*<!\[CDATA\[|\]\]>\s*$/g;
    function Fr(e, t) {
      return ve(e, "table") && ve(t.nodeType !== 11 ? t : t.firstChild, "tr") && i(e).children("tbody")[0] || e;
    }
    function Wn(e) {
      return e.type = (e.getAttribute("type") !== null) + "/" + e.type, e;
    }
    function Un(e) {
      return (e.type || "").slice(0, 5) === "true/" ? e.type = e.type.slice(5) : e.removeAttribute("type"), e;
    }
    function Mr(e, t) {
      var r, n, a, o, l, p, d;
      if (t.nodeType === 1) {
        if (X.hasData(e) && (o = X.get(e), d = o.events, d)) {
          X.remove(t, "handle events");
          for (a in d)
            for (r = 0, n = d[a].length; r < n; r++)
              i.event.add(t, a, d[a][r]);
        }
        xe.hasData(e) && (l = xe.access(e), p = i.extend({}, l), xe.set(t, p));
      }
    }
    function Gn(e, t) {
      var r = t.nodeName.toLowerCase();
      r === "input" && St.test(e.type) ? t.checked = e.checked : (r === "input" || r === "textarea") && (t.defaultValue = e.defaultValue);
    }
    function bt(e, t, r, n) {
      t = P(t);
      var a, o, l, p, d, b, k = 0, E = e.length, v = E - 1, S = t[0], W = w(S);
      if (W || E > 1 && typeof S == "string" && !M.checkClone && zn.test(S))
        return e.each(function(ee) {
          var U = e.eq(ee);
          W && (t[0] = S.call(this, ee, U.html())), bt(U, t, r, n);
        });
      if (E && (a = Or(t, e[0].ownerDocument, !1, e, n), o = a.firstChild, a.childNodes.length === 1 && (a = o), o || n)) {
        for (l = i.map(_e(a, "script"), Wn), p = l.length; k < E; k++)
          d = a, k !== v && (d = i.clone(d, !0, !0), p && i.merge(l, _e(d, "script"))), r.call(e[k], d, k);
        if (p)
          for (b = l[l.length - 1].ownerDocument, i.map(l, Un), k = 0; k < p; k++)
            d = l[k], Er.test(d.type || "") && !X.access(d, "globalEval") && i.contains(b, d) && (d.src && (d.type || "").toLowerCase() !== "module" ? i._evalUrl && !d.noModule && i._evalUrl(d.src, {
              nonce: d.nonce || d.getAttribute("nonce")
            }, b) : L(d.textContent.replace(Vn, ""), d, b));
      }
      return e;
    }
    function jr(e, t, r) {
      for (var n, a = t ? i.filter(t, e) : e, o = 0; (n = a[o]) != null; o++)
        !r && n.nodeType === 1 && i.cleanData(_e(n)), n.parentNode && (r && ht(n) && er(_e(n, "script")), n.parentNode.removeChild(n));
      return e;
    }
    i.extend({
      htmlPrefilter: function(e) {
        return e;
      },
      clone: function(e, t, r) {
        var n, a, o, l, p = e.cloneNode(!0), d = ht(e);
        if (!M.noCloneChecked && (e.nodeType === 1 || e.nodeType === 11) && !i.isXMLDoc(e))
          for (l = _e(p), o = _e(e), n = 0, a = o.length; n < a; n++)
            Gn(o[n], l[n]);
        if (t)
          if (r)
            for (o = o || _e(e), l = l || _e(p), n = 0, a = o.length; n < a; n++)
              Mr(o[n], l[n]);
          else
            Mr(e, p);
        return l = _e(p, "script"), l.length > 0 && er(l, !d && _e(e, "script")), p;
      },
      cleanData: function(e) {
        for (var t, r, n, a = i.event.special, o = 0; (r = e[o]) !== void 0; o++)
          if (Tt(r)) {
            if (t = r[X.expando]) {
              if (t.events)
                for (n in t.events)
                  a[n] ? i.event.remove(r, n) : i.removeEvent(r, n, t.handle);
              r[X.expando] = void 0;
            }
            r[xe.expando] && (r[xe.expando] = void 0);
          }
      }
    }), i.fn.extend({
      detach: function(e) {
        return jr(this, e, !0);
      },
      remove: function(e) {
        return jr(this, e);
      },
      text: function(e) {
        return Ue(this, function(t) {
          return t === void 0 ? i.text(this) : this.empty().each(function() {
            (this.nodeType === 1 || this.nodeType === 11 || this.nodeType === 9) && (this.textContent = t);
          });
        }, null, e, arguments.length);
      },
      append: function() {
        return bt(this, arguments, function(e) {
          if (this.nodeType === 1 || this.nodeType === 11 || this.nodeType === 9) {
            var t = Fr(this, e);
            t.appendChild(e);
          }
        });
      },
      prepend: function() {
        return bt(this, arguments, function(e) {
          if (this.nodeType === 1 || this.nodeType === 11 || this.nodeType === 9) {
            var t = Fr(this, e);
            t.insertBefore(e, t.firstChild);
          }
        });
      },
      before: function() {
        return bt(this, arguments, function(e) {
          this.parentNode && this.parentNode.insertBefore(e, this);
        });
      },
      after: function() {
        return bt(this, arguments, function(e) {
          this.parentNode && this.parentNode.insertBefore(e, this.nextSibling);
        });
      },
      empty: function() {
        for (var e, t = 0; (e = this[t]) != null; t++)
          e.nodeType === 1 && (i.cleanData(_e(e, !1)), e.textContent = "");
        return this;
      },
      clone: function(e, t) {
        return e = e == null ? !1 : e, t = t == null ? e : t, this.map(function() {
          return i.clone(this, e, t);
        });
      },
      html: function(e) {
        return Ue(this, function(t) {
          var r = this[0] || {}, n = 0, a = this.length;
          if (t === void 0 && r.nodeType === 1)
            return r.innerHTML;
          if (typeof t == "string" && !In.test(t) && !He[(Pr.exec(t) || ["", ""])[1].toLowerCase()]) {
            t = i.htmlPrefilter(t);
            try {
              for (; n < a; n++)
                r = this[n] || {}, r.nodeType === 1 && (i.cleanData(_e(r, !1)), r.innerHTML = t);
              r = 0;
            } catch {
            }
          }
          r && this.empty().append(t);
        }, null, e, arguments.length);
      },
      replaceWith: function() {
        var e = [];
        return bt(this, arguments, function(t) {
          var r = this.parentNode;
          i.inArray(this, e) < 0 && (i.cleanData(_e(this)), r && r.replaceChild(t, this));
        }, e);
      }
    }), i.each({
      appendTo: "append",
      prependTo: "prepend",
      insertBefore: "before",
      insertAfter: "after",
      replaceAll: "replaceWith"
    }, function(e, t) {
      i.fn[e] = function(r) {
        for (var n, a = [], o = i(r), l = o.length - 1, p = 0; p <= l; p++)
          n = p === l ? this : this.clone(!0), i(o[p])[t](n), A.apply(a, n.get());
        return this.pushStack(a);
      };
    });
    var rr = new RegExp("^(" + qr + ")(?!px)[a-z%]+$", "i"), nr = /^--/, $t = function(e) {
      var t = e.ownerDocument.defaultView;
      return (!t || !t.opener) && (t = c), t.getComputedStyle(e);
    }, Br = function(e, t, r) {
      var n, a, o = {};
      for (a in t)
        o[a] = e.style[a], e.style[a] = t[a];
      n = r.call(e);
      for (a in t)
        e.style[a] = o[a];
      return n;
    }, Qn = new RegExp(Ge.join("|"), "i"), $r = "[\\x20\\t\\r\\n\\f]", Xn = new RegExp(
      "^" + $r + "+|((?:^|[^\\\\])(?:\\\\.)*)" + $r + "+$",
      "g"
    );
    (function() {
      function e() {
        if (!!b) {
          d.style.cssText = "position:absolute;left:-11111px;width:60px;margin-top:1px;padding:0;border:0", b.style.cssText = "position:relative;display:block;box-sizing:border-box;overflow:scroll;margin:auto;border:1px;padding:1px;width:60%;top:1%", tt.appendChild(d).appendChild(b);
          var k = c.getComputedStyle(b);
          r = k.top !== "1%", p = t(k.marginLeft) === 12, b.style.right = "60%", o = t(k.right) === 36, n = t(k.width) === 36, b.style.position = "absolute", a = t(b.offsetWidth / 3) === 12, tt.removeChild(d), b = null;
        }
      }
      function t(k) {
        return Math.round(parseFloat(k));
      }
      var r, n, a, o, l, p, d = m.createElement("div"), b = m.createElement("div");
      !b.style || (b.style.backgroundClip = "content-box", b.cloneNode(!0).style.backgroundClip = "", M.clearCloneStyle = b.style.backgroundClip === "content-box", i.extend(M, {
        boxSizingReliable: function() {
          return e(), n;
        },
        pixelBoxStyles: function() {
          return e(), o;
        },
        pixelPosition: function() {
          return e(), r;
        },
        reliableMarginLeft: function() {
          return e(), p;
        },
        scrollboxSize: function() {
          return e(), a;
        },
        reliableTrDimensions: function() {
          var k, E, v, S;
          return l == null && (k = m.createElement("table"), E = m.createElement("tr"), v = m.createElement("div"), k.style.cssText = "position:absolute;left:-11111px;border-collapse:separate", E.style.cssText = "border:1px solid", E.style.height = "1px", v.style.height = "9px", v.style.display = "block", tt.appendChild(k).appendChild(E).appendChild(v), S = c.getComputedStyle(E), l = parseInt(S.height, 10) + parseInt(S.borderTopWidth, 10) + parseInt(S.borderBottomWidth, 10) === E.offsetHeight, tt.removeChild(k)), l;
        }
      }));
    })();
    function xt(e, t, r) {
      var n, a, o, l, p = nr.test(t), d = e.style;
      return r = r || $t(e), r && (l = r.getPropertyValue(t) || r[t], p && (l = l.replace(Xn, "$1")), l === "" && !ht(e) && (l = i.style(e, t)), !M.pixelBoxStyles() && rr.test(l) && Qn.test(t) && (n = d.width, a = d.minWidth, o = d.maxWidth, d.minWidth = d.maxWidth = d.width = l, l = r.width, d.width = n, d.minWidth = a, d.maxWidth = o)), l !== void 0 ? l + "" : l;
    }
    function Rr(e, t) {
      return {
        get: function() {
          if (e()) {
            delete this.get;
            return;
          }
          return (this.get = t).apply(this, arguments);
        }
      };
    }
    var Ir = ["Webkit", "Moz", "ms"], zr = m.createElement("div").style, Vr = {};
    function Kn(e) {
      for (var t = e[0].toUpperCase() + e.slice(1), r = Ir.length; r--; )
        if (e = Ir[r] + t, e in zr)
          return e;
    }
    function ir(e) {
      var t = i.cssProps[e] || Vr[e];
      return t || (e in zr ? e : Vr[e] = Kn(e) || e);
    }
    var Jn = /^(none|table(?!-c[ea]).+)/, Yn = { position: "absolute", visibility: "hidden", display: "block" }, Wr = {
      letterSpacing: "0",
      fontWeight: "400"
    };
    function Ur(e, t, r) {
      var n = wt.exec(t);
      return n ? Math.max(0, n[2] - (r || 0)) + (n[3] || "px") : t;
    }
    function sr(e, t, r, n, a, o) {
      var l = t === "width" ? 1 : 0, p = 0, d = 0;
      if (r === (n ? "border" : "content"))
        return 0;
      for (; l < 4; l += 2)
        r === "margin" && (d += i.css(e, r + Ge[l], !0, a)), n ? (r === "content" && (d -= i.css(e, "padding" + Ge[l], !0, a)), r !== "margin" && (d -= i.css(e, "border" + Ge[l] + "Width", !0, a))) : (d += i.css(e, "padding" + Ge[l], !0, a), r !== "padding" ? d += i.css(e, "border" + Ge[l] + "Width", !0, a) : p += i.css(e, "border" + Ge[l] + "Width", !0, a));
      return !n && o >= 0 && (d += Math.max(0, Math.ceil(
        e["offset" + t[0].toUpperCase() + t.slice(1)] - o - d - p - 0.5
      )) || 0), d;
    }
    function Gr(e, t, r) {
      var n = $t(e), a = !M.boxSizingReliable() || r, o = a && i.css(e, "boxSizing", !1, n) === "border-box", l = o, p = xt(e, t, n), d = "offset" + t[0].toUpperCase() + t.slice(1);
      if (rr.test(p)) {
        if (!r)
          return p;
        p = "auto";
      }
      return (!M.boxSizingReliable() && o || !M.reliableTrDimensions() && ve(e, "tr") || p === "auto" || !parseFloat(p) && i.css(e, "display", !1, n) === "inline") && e.getClientRects().length && (o = i.css(e, "boxSizing", !1, n) === "border-box", l = d in e, l && (p = e[d])), p = parseFloat(p) || 0, p + sr(
        e,
        t,
        r || (o ? "border" : "content"),
        l,
        n,
        p
      ) + "px";
    }
    i.extend({
      cssHooks: {
        opacity: {
          get: function(e, t) {
            if (t) {
              var r = xt(e, "opacity");
              return r === "" ? "1" : r;
            }
          }
        }
      },
      cssNumber: {
        animationIterationCount: !0,
        columnCount: !0,
        fillOpacity: !0,
        flexGrow: !0,
        flexShrink: !0,
        fontWeight: !0,
        gridArea: !0,
        gridColumn: !0,
        gridColumnEnd: !0,
        gridColumnStart: !0,
        gridRow: !0,
        gridRowEnd: !0,
        gridRowStart: !0,
        lineHeight: !0,
        opacity: !0,
        order: !0,
        orphans: !0,
        widows: !0,
        zIndex: !0,
        zoom: !0
      },
      cssProps: {},
      style: function(e, t, r, n) {
        if (!(!e || e.nodeType === 3 || e.nodeType === 8 || !e.style)) {
          var a, o, l, p = ze(t), d = nr.test(t), b = e.style;
          if (d || (t = ir(p)), l = i.cssHooks[t] || i.cssHooks[p], r !== void 0) {
            if (o = typeof r, o === "string" && (a = wt.exec(r)) && a[1] && (r = Ar(e, t, a), o = "number"), r == null || r !== r)
              return;
            o === "number" && !d && (r += a && a[3] || (i.cssNumber[p] ? "" : "px")), !M.clearCloneStyle && r === "" && t.indexOf("background") === 0 && (b[t] = "inherit"), (!l || !("set" in l) || (r = l.set(e, r, n)) !== void 0) && (d ? b.setProperty(t, r) : b[t] = r);
          } else
            return l && "get" in l && (a = l.get(e, !1, n)) !== void 0 ? a : b[t];
        }
      },
      css: function(e, t, r, n) {
        var a, o, l, p = ze(t), d = nr.test(t);
        return d || (t = ir(p)), l = i.cssHooks[t] || i.cssHooks[p], l && "get" in l && (a = l.get(e, !0, r)), a === void 0 && (a = xt(e, t, n)), a === "normal" && t in Wr && (a = Wr[t]), r === "" || r ? (o = parseFloat(a), r === !0 || isFinite(o) ? o || 0 : a) : a;
      }
    }), i.each(["height", "width"], function(e, t) {
      i.cssHooks[t] = {
        get: function(r, n, a) {
          if (n)
            return Jn.test(i.css(r, "display")) && (!r.getClientRects().length || !r.getBoundingClientRect().width) ? Br(r, Yn, function() {
              return Gr(r, t, a);
            }) : Gr(r, t, a);
        },
        set: function(r, n, a) {
          var o, l = $t(r), p = !M.scrollboxSize() && l.position === "absolute", d = p || a, b = d && i.css(r, "boxSizing", !1, l) === "border-box", k = a ? sr(
            r,
            t,
            a,
            b,
            l
          ) : 0;
          return b && p && (k -= Math.ceil(
            r["offset" + t[0].toUpperCase() + t.slice(1)] - parseFloat(l[t]) - sr(r, t, "border", !1, l) - 0.5
          )), k && (o = wt.exec(n)) && (o[3] || "px") !== "px" && (r.style[t] = n, n = i.css(r, t)), Ur(r, n, k);
        }
      };
    }), i.cssHooks.marginLeft = Rr(
      M.reliableMarginLeft,
      function(e, t) {
        if (t)
          return (parseFloat(xt(e, "marginLeft")) || e.getBoundingClientRect().left - Br(e, { marginLeft: 0 }, function() {
            return e.getBoundingClientRect().left;
          })) + "px";
      }
    ), i.each({
      margin: "",
      padding: "",
      border: "Width"
    }, function(e, t) {
      i.cssHooks[e + t] = {
        expand: function(r) {
          for (var n = 0, a = {}, o = typeof r == "string" ? r.split(" ") : [r]; n < 4; n++)
            a[e + Ge[n] + t] = o[n] || o[n - 2] || o[0];
          return a;
        }
      }, e !== "margin" && (i.cssHooks[e + t].set = Ur);
    }), i.fn.extend({
      css: function(e, t) {
        return Ue(this, function(r, n, a) {
          var o, l, p = {}, d = 0;
          if (Array.isArray(n)) {
            for (o = $t(r), l = n.length; d < l; d++)
              p[n[d]] = i.css(r, n[d], !1, o);
            return p;
          }
          return a !== void 0 ? i.style(r, n, a) : i.css(r, n);
        }, e, t, arguments.length > 1);
      }
    });
    function De(e, t, r, n, a) {
      return new De.prototype.init(e, t, r, n, a);
    }
    i.Tween = De, De.prototype = {
      constructor: De,
      init: function(e, t, r, n, a, o) {
        this.elem = e, this.prop = r, this.easing = a || i.easing._default, this.options = t, this.start = this.now = this.cur(), this.end = n, this.unit = o || (i.cssNumber[r] ? "" : "px");
      },
      cur: function() {
        var e = De.propHooks[this.prop];
        return e && e.get ? e.get(this) : De.propHooks._default.get(this);
      },
      run: function(e) {
        var t, r = De.propHooks[this.prop];
        return this.options.duration ? this.pos = t = i.easing[this.easing](
          e,
          this.options.duration * e,
          0,
          1,
          this.options.duration
        ) : this.pos = t = e, this.now = (this.end - this.start) * t + this.start, this.options.step && this.options.step.call(this.elem, this.now, this), r && r.set ? r.set(this) : De.propHooks._default.set(this), this;
      }
    }, De.prototype.init.prototype = De.prototype, De.propHooks = {
      _default: {
        get: function(e) {
          var t;
          return e.elem.nodeType !== 1 || e.elem[e.prop] != null && e.elem.style[e.prop] == null ? e.elem[e.prop] : (t = i.css(e.elem, e.prop, ""), !t || t === "auto" ? 0 : t);
        },
        set: function(e) {
          i.fx.step[e.prop] ? i.fx.step[e.prop](e) : e.elem.nodeType === 1 && (i.cssHooks[e.prop] || e.elem.style[ir(e.prop)] != null) ? i.style(e.elem, e.prop, e.now + e.unit) : e.elem[e.prop] = e.now;
        }
      }
    }, De.propHooks.scrollTop = De.propHooks.scrollLeft = {
      set: function(e) {
        e.elem.nodeType && e.elem.parentNode && (e.elem[e.prop] = e.now);
      }
    }, i.easing = {
      linear: function(e) {
        return e;
      },
      swing: function(e) {
        return 0.5 - Math.cos(e * Math.PI) / 2;
      },
      _default: "swing"
    }, i.fx = De.prototype.init, i.fx.step = {};
    var vt, Rt, Zn = /^(?:toggle|show|hide)$/, ei = /queueHooks$/;
    function ar() {
      Rt && (m.hidden === !1 && c.requestAnimationFrame ? c.requestAnimationFrame(ar) : c.setTimeout(ar, i.fx.interval), i.fx.tick());
    }
    function Qr() {
      return c.setTimeout(function() {
        vt = void 0;
      }), vt = Date.now();
    }
    function It(e, t) {
      var r, n = 0, a = { height: e };
      for (t = t ? 1 : 0; n < 4; n += 2 - t)
        r = Ge[n], a["margin" + r] = a["padding" + r] = e;
      return t && (a.opacity = a.width = e), a;
    }
    function Xr(e, t, r) {
      for (var n, a = (Me.tweeners[t] || []).concat(Me.tweeners["*"]), o = 0, l = a.length; o < l; o++)
        if (n = a[o].call(r, t, e))
          return n;
    }
    function ti(e, t, r) {
      var n, a, o, l, p, d, b, k, E = "width" in t || "height" in t, v = this, S = {}, W = e.style, ee = e.nodeType && jt(e), U = X.get(e, "fxshow");
      r.queue || (l = i._queueHooks(e, "fx"), l.unqueued == null && (l.unqueued = 0, p = l.empty.fire, l.empty.fire = function() {
        l.unqueued || p();
      }), l.unqueued++, v.always(function() {
        v.always(function() {
          l.unqueued--, i.queue(e, "fx").length || l.empty.fire();
        });
      }));
      for (n in t)
        if (a = t[n], Zn.test(a)) {
          if (delete t[n], o = o || a === "toggle", a === (ee ? "hide" : "show"))
            if (a === "show" && U && U[n] !== void 0)
              ee = !0;
            else
              continue;
          S[n] = U && U[n] || i.style(e, n);
        }
      if (d = !i.isEmptyObject(t), !(!d && i.isEmptyObject(S))) {
        E && e.nodeType === 1 && (r.overflow = [W.overflow, W.overflowX, W.overflowY], b = U && U.display, b == null && (b = X.get(e, "display")), k = i.css(e, "display"), k === "none" && (b ? k = b : (pt([e], !0), b = e.style.display || b, k = i.css(e, "display"), pt([e]))), (k === "inline" || k === "inline-block" && b != null) && i.css(e, "float") === "none" && (d || (v.done(function() {
          W.display = b;
        }), b == null && (k = W.display, b = k === "none" ? "" : k)), W.display = "inline-block")), r.overflow && (W.overflow = "hidden", v.always(function() {
          W.overflow = r.overflow[0], W.overflowX = r.overflow[1], W.overflowY = r.overflow[2];
        })), d = !1;
        for (n in S)
          d || (U ? "hidden" in U && (ee = U.hidden) : U = X.access(e, "fxshow", { display: b }), o && (U.hidden = !ee), ee && pt([e], !0), v.done(function() {
            ee || pt([e]), X.remove(e, "fxshow");
            for (n in S)
              i.style(e, n, S[n]);
          })), d = Xr(ee ? U[n] : 0, n, v), n in U || (U[n] = d.start, ee && (d.end = d.start, d.start = 0));
      }
    }
    function ri(e, t) {
      var r, n, a, o, l;
      for (r in e)
        if (n = ze(r), a = t[n], o = e[r], Array.isArray(o) && (a = o[1], o = e[r] = o[0]), r !== n && (e[n] = o, delete e[r]), l = i.cssHooks[n], l && "expand" in l) {
          o = l.expand(o), delete e[n];
          for (r in o)
            r in e || (e[r] = o[r], t[r] = a);
        } else
          t[n] = a;
    }
    function Me(e, t, r) {
      var n, a, o = 0, l = Me.prefilters.length, p = i.Deferred().always(function() {
        delete d.elem;
      }), d = function() {
        if (a)
          return !1;
        for (var E = vt || Qr(), v = Math.max(0, b.startTime + b.duration - E), S = v / b.duration || 0, W = 1 - S, ee = 0, U = b.tweens.length; ee < U; ee++)
          b.tweens[ee].run(W);
        return p.notifyWith(e, [b, W, v]), W < 1 && U ? v : (U || p.notifyWith(e, [b, 1, 0]), p.resolveWith(e, [b]), !1);
      }, b = p.promise({
        elem: e,
        props: i.extend({}, t),
        opts: i.extend(!0, {
          specialEasing: {},
          easing: i.easing._default
        }, r),
        originalProperties: t,
        originalOptions: r,
        startTime: vt || Qr(),
        duration: r.duration,
        tweens: [],
        createTween: function(E, v) {
          var S = i.Tween(
            e,
            b.opts,
            E,
            v,
            b.opts.specialEasing[E] || b.opts.easing
          );
          return b.tweens.push(S), S;
        },
        stop: function(E) {
          var v = 0, S = E ? b.tweens.length : 0;
          if (a)
            return this;
          for (a = !0; v < S; v++)
            b.tweens[v].run(1);
          return E ? (p.notifyWith(e, [b, 1, 0]), p.resolveWith(e, [b, E])) : p.rejectWith(e, [b, E]), this;
        }
      }), k = b.props;
      for (ri(k, b.opts.specialEasing); o < l; o++)
        if (n = Me.prefilters[o].call(b, e, k, b.opts), n)
          return w(n.stop) && (i._queueHooks(b.elem, b.opts.queue).stop = n.stop.bind(n)), n;
      return i.map(k, Xr, b), w(b.opts.start) && b.opts.start.call(e, b), b.progress(b.opts.progress).done(b.opts.done, b.opts.complete).fail(b.opts.fail).always(b.opts.always), i.fx.timer(
        i.extend(d, {
          elem: e,
          anim: b,
          queue: b.opts.queue
        })
      ), b;
    }
    i.Animation = i.extend(Me, {
      tweeners: {
        "*": [function(e, t) {
          var r = this.createTween(e, t);
          return Ar(r.elem, e, wt.exec(t), r), r;
        }]
      },
      tweener: function(e, t) {
        w(e) ? (t = e, e = ["*"]) : e = e.match(Ie);
        for (var r, n = 0, a = e.length; n < a; n++)
          r = e[n], Me.tweeners[r] = Me.tweeners[r] || [], Me.tweeners[r].unshift(t);
      },
      prefilters: [ti],
      prefilter: function(e, t) {
        t ? Me.prefilters.unshift(e) : Me.prefilters.push(e);
      }
    }), i.speed = function(e, t, r) {
      var n = e && typeof e == "object" ? i.extend({}, e) : {
        complete: r || !r && t || w(e) && e,
        duration: e,
        easing: r && t || t && !w(t) && t
      };
      return i.fx.off ? n.duration = 0 : typeof n.duration != "number" && (n.duration in i.fx.speeds ? n.duration = i.fx.speeds[n.duration] : n.duration = i.fx.speeds._default), (n.queue == null || n.queue === !0) && (n.queue = "fx"), n.old = n.complete, n.complete = function() {
        w(n.old) && n.old.call(this), n.queue && i.dequeue(this, n.queue);
      }, n;
    }, i.fn.extend({
      fadeTo: function(e, t, r, n) {
        return this.filter(jt).css("opacity", 0).show().end().animate({ opacity: t }, e, r, n);
      },
      animate: function(e, t, r, n) {
        var a = i.isEmptyObject(e), o = i.speed(t, r, n), l = function() {
          var p = Me(this, i.extend({}, e), o);
          (a || X.get(this, "finish")) && p.stop(!0);
        };
        return l.finish = l, a || o.queue === !1 ? this.each(l) : this.queue(o.queue, l);
      },
      stop: function(e, t, r) {
        var n = function(a) {
          var o = a.stop;
          delete a.stop, o(r);
        };
        return typeof e != "string" && (r = t, t = e, e = void 0), t && this.queue(e || "fx", []), this.each(function() {
          var a = !0, o = e != null && e + "queueHooks", l = i.timers, p = X.get(this);
          if (o)
            p[o] && p[o].stop && n(p[o]);
          else
            for (o in p)
              p[o] && p[o].stop && ei.test(o) && n(p[o]);
          for (o = l.length; o--; )
            l[o].elem === this && (e == null || l[o].queue === e) && (l[o].anim.stop(r), a = !1, l.splice(o, 1));
          (a || !r) && i.dequeue(this, e);
        });
      },
      finish: function(e) {
        return e !== !1 && (e = e || "fx"), this.each(function() {
          var t, r = X.get(this), n = r[e + "queue"], a = r[e + "queueHooks"], o = i.timers, l = n ? n.length : 0;
          for (r.finish = !0, i.queue(this, e, []), a && a.stop && a.stop.call(this, !0), t = o.length; t--; )
            o[t].elem === this && o[t].queue === e && (o[t].anim.stop(!0), o.splice(t, 1));
          for (t = 0; t < l; t++)
            n[t] && n[t].finish && n[t].finish.call(this);
          delete r.finish;
        });
      }
    }), i.each(["toggle", "show", "hide"], function(e, t) {
      var r = i.fn[t];
      i.fn[t] = function(n, a, o) {
        return n == null || typeof n == "boolean" ? r.apply(this, arguments) : this.animate(It(t, !0), n, a, o);
      };
    }), i.each({
      slideDown: It("show"),
      slideUp: It("hide"),
      slideToggle: It("toggle"),
      fadeIn: { opacity: "show" },
      fadeOut: { opacity: "hide" },
      fadeToggle: { opacity: "toggle" }
    }, function(e, t) {
      i.fn[e] = function(r, n, a) {
        return this.animate(t, r, n, a);
      };
    }), i.timers = [], i.fx.tick = function() {
      var e, t = 0, r = i.timers;
      for (vt = Date.now(); t < r.length; t++)
        e = r[t], !e() && r[t] === e && r.splice(t--, 1);
      r.length || i.fx.stop(), vt = void 0;
    }, i.fx.timer = function(e) {
      i.timers.push(e), i.fx.start();
    }, i.fx.interval = 13, i.fx.start = function() {
      Rt || (Rt = !0, ar());
    }, i.fx.stop = function() {
      Rt = null;
    }, i.fx.speeds = {
      slow: 600,
      fast: 200,
      _default: 400
    }, i.fn.delay = function(e, t) {
      return e = i.fx && i.fx.speeds[e] || e, t = t || "fx", this.queue(t, function(r, n) {
        var a = c.setTimeout(r, e);
        n.stop = function() {
          c.clearTimeout(a);
        };
      });
    }, function() {
      var e = m.createElement("input"), t = m.createElement("select"), r = t.appendChild(m.createElement("option"));
      e.type = "checkbox", M.checkOn = e.value !== "", M.optSelected = r.selected, e = m.createElement("input"), e.value = "t", e.type = "radio", M.radioValue = e.value === "t";
    }();
    var Kr, _t = i.expr.attrHandle;
    i.fn.extend({
      attr: function(e, t) {
        return Ue(this, i.attr, e, t, arguments.length > 1);
      },
      removeAttr: function(e) {
        return this.each(function() {
          i.removeAttr(this, e);
        });
      }
    }), i.extend({
      attr: function(e, t, r) {
        var n, a, o = e.nodeType;
        if (!(o === 3 || o === 8 || o === 2)) {
          if (typeof e.getAttribute > "u")
            return i.prop(e, t, r);
          if ((o !== 1 || !i.isXMLDoc(e)) && (a = i.attrHooks[t.toLowerCase()] || (i.expr.match.bool.test(t) ? Kr : void 0)), r !== void 0) {
            if (r === null) {
              i.removeAttr(e, t);
              return;
            }
            return a && "set" in a && (n = a.set(e, r, t)) !== void 0 ? n : (e.setAttribute(t, r + ""), r);
          }
          return a && "get" in a && (n = a.get(e, t)) !== null ? n : (n = i.find.attr(e, t), n == null ? void 0 : n);
        }
      },
      attrHooks: {
        type: {
          set: function(e, t) {
            if (!M.radioValue && t === "radio" && ve(e, "input")) {
              var r = e.value;
              return e.setAttribute("type", t), r && (e.value = r), t;
            }
          }
        }
      },
      removeAttr: function(e, t) {
        var r, n = 0, a = t && t.match(Ie);
        if (a && e.nodeType === 1)
          for (; r = a[n++]; )
            e.removeAttribute(r);
      }
    }), Kr = {
      set: function(e, t, r) {
        return t === !1 ? i.removeAttr(e, r) : e.setAttribute(r, r), r;
      }
    }, i.each(i.expr.match.bool.source.match(/\w+/g), function(e, t) {
      var r = _t[t] || i.find.attr;
      _t[t] = function(n, a, o) {
        var l, p, d = a.toLowerCase();
        return o || (p = _t[d], _t[d] = l, l = r(n, a, o) != null ? d : null, _t[d] = p), l;
      };
    });
    var ni = /^(?:input|select|textarea|button)$/i, ii = /^(?:a|area)$/i;
    i.fn.extend({
      prop: function(e, t) {
        return Ue(this, i.prop, e, t, arguments.length > 1);
      },
      removeProp: function(e) {
        return this.each(function() {
          delete this[i.propFix[e] || e];
        });
      }
    }), i.extend({
      prop: function(e, t, r) {
        var n, a, o = e.nodeType;
        if (!(o === 3 || o === 8 || o === 2))
          return (o !== 1 || !i.isXMLDoc(e)) && (t = i.propFix[t] || t, a = i.propHooks[t]), r !== void 0 ? a && "set" in a && (n = a.set(e, r, t)) !== void 0 ? n : e[t] = r : a && "get" in a && (n = a.get(e, t)) !== null ? n : e[t];
      },
      propHooks: {
        tabIndex: {
          get: function(e) {
            var t = i.find.attr(e, "tabindex");
            return t ? parseInt(t, 10) : ni.test(e.nodeName) || ii.test(e.nodeName) && e.href ? 0 : -1;
          }
        }
      },
      propFix: {
        for: "htmlFor",
        class: "className"
      }
    }), M.optSelected || (i.propHooks.selected = {
      get: function(e) {
        var t = e.parentNode;
        return t && t.parentNode && t.parentNode.selectedIndex, null;
      },
      set: function(e) {
        var t = e.parentNode;
        t && (t.selectedIndex, t.parentNode && t.parentNode.selectedIndex);
      }
    }), i.each([
      "tabIndex",
      "readOnly",
      "maxLength",
      "cellSpacing",
      "cellPadding",
      "rowSpan",
      "colSpan",
      "useMap",
      "frameBorder",
      "contentEditable"
    ], function() {
      i.propFix[this.toLowerCase()] = this;
    });
    function rt(e) {
      var t = e.match(Ie) || [];
      return t.join(" ");
    }
    function nt(e) {
      return e.getAttribute && e.getAttribute("class") || "";
    }
    function or(e) {
      return Array.isArray(e) ? e : typeof e == "string" ? e.match(Ie) || [] : [];
    }
    i.fn.extend({
      addClass: function(e) {
        var t, r, n, a, o, l;
        return w(e) ? this.each(function(p) {
          i(this).addClass(e.call(this, p, nt(this)));
        }) : (t = or(e), t.length ? this.each(function() {
          if (n = nt(this), r = this.nodeType === 1 && " " + rt(n) + " ", r) {
            for (o = 0; o < t.length; o++)
              a = t[o], r.indexOf(" " + a + " ") < 0 && (r += a + " ");
            l = rt(r), n !== l && this.setAttribute("class", l);
          }
        }) : this);
      },
      removeClass: function(e) {
        var t, r, n, a, o, l;
        return w(e) ? this.each(function(p) {
          i(this).removeClass(e.call(this, p, nt(this)));
        }) : arguments.length ? (t = or(e), t.length ? this.each(function() {
          if (n = nt(this), r = this.nodeType === 1 && " " + rt(n) + " ", r) {
            for (o = 0; o < t.length; o++)
              for (a = t[o]; r.indexOf(" " + a + " ") > -1; )
                r = r.replace(" " + a + " ", " ");
            l = rt(r), n !== l && this.setAttribute("class", l);
          }
        }) : this) : this.attr("class", "");
      },
      toggleClass: function(e, t) {
        var r, n, a, o, l = typeof e, p = l === "string" || Array.isArray(e);
        return w(e) ? this.each(function(d) {
          i(this).toggleClass(
            e.call(this, d, nt(this), t),
            t
          );
        }) : typeof t == "boolean" && p ? t ? this.addClass(e) : this.removeClass(e) : (r = or(e), this.each(function() {
          if (p)
            for (o = i(this), a = 0; a < r.length; a++)
              n = r[a], o.hasClass(n) ? o.removeClass(n) : o.addClass(n);
          else
            (e === void 0 || l === "boolean") && (n = nt(this), n && X.set(this, "__className__", n), this.setAttribute && this.setAttribute(
              "class",
              n || e === !1 ? "" : X.get(this, "__className__") || ""
            ));
        }));
      },
      hasClass: function(e) {
        var t, r, n = 0;
        for (t = " " + e + " "; r = this[n++]; )
          if (r.nodeType === 1 && (" " + rt(nt(r)) + " ").indexOf(t) > -1)
            return !0;
        return !1;
      }
    });
    var si = /\r/g;
    i.fn.extend({
      val: function(e) {
        var t, r, n, a = this[0];
        return arguments.length ? (n = w(e), this.each(function(o) {
          var l;
          this.nodeType === 1 && (n ? l = e.call(this, o, i(this).val()) : l = e, l == null ? l = "" : typeof l == "number" ? l += "" : Array.isArray(l) && (l = i.map(l, function(p) {
            return p == null ? "" : p + "";
          })), t = i.valHooks[this.type] || i.valHooks[this.nodeName.toLowerCase()], (!t || !("set" in t) || t.set(this, l, "value") === void 0) && (this.value = l));
        })) : a ? (t = i.valHooks[a.type] || i.valHooks[a.nodeName.toLowerCase()], t && "get" in t && (r = t.get(a, "value")) !== void 0 ? r : (r = a.value, typeof r == "string" ? r.replace(si, "") : r == null ? "" : r)) : void 0;
      }
    }), i.extend({
      valHooks: {
        option: {
          get: function(e) {
            var t = i.find.attr(e, "value");
            return t != null ? t : rt(i.text(e));
          }
        },
        select: {
          get: function(e) {
            var t, r, n, a = e.options, o = e.selectedIndex, l = e.type === "select-one", p = l ? null : [], d = l ? o + 1 : a.length;
            for (o < 0 ? n = d : n = l ? o : 0; n < d; n++)
              if (r = a[n], (r.selected || n === o) && !r.disabled && (!r.parentNode.disabled || !ve(r.parentNode, "optgroup"))) {
                if (t = i(r).val(), l)
                  return t;
                p.push(t);
              }
            return p;
          },
          set: function(e, t) {
            for (var r, n, a = e.options, o = i.makeArray(t), l = a.length; l--; )
              n = a[l], (n.selected = i.inArray(i.valHooks.option.get(n), o) > -1) && (r = !0);
            return r || (e.selectedIndex = -1), o;
          }
        }
      }
    }), i.each(["radio", "checkbox"], function() {
      i.valHooks[this] = {
        set: function(e, t) {
          if (Array.isArray(t))
            return e.checked = i.inArray(i(e).val(), t) > -1;
        }
      }, M.checkOn || (i.valHooks[this].get = function(e) {
        return e.getAttribute("value") === null ? "on" : e.value;
      });
    }), M.focusin = "onfocusin" in c;
    var Jr = /^(?:focusinfocus|focusoutblur)$/, Yr = function(e) {
      e.stopPropagation();
    };
    i.extend(i.event, {
      trigger: function(e, t, r, n) {
        var a, o, l, p, d, b, k, E, v = [r || m], S = ft.call(e, "type") ? e.type : e, W = ft.call(e, "namespace") ? e.namespace.split(".") : [];
        if (o = E = l = r = r || m, !(r.nodeType === 3 || r.nodeType === 8) && !Jr.test(S + i.event.triggered) && (S.indexOf(".") > -1 && (W = S.split("."), S = W.shift(), W.sort()), d = S.indexOf(":") < 0 && "on" + S, e = e[i.expando] ? e : new i.Event(S, typeof e == "object" && e), e.isTrigger = n ? 2 : 3, e.namespace = W.join("."), e.rnamespace = e.namespace ? new RegExp("(^|\\.)" + W.join("\\.(?:.*\\.|)") + "(\\.|$)") : null, e.result = void 0, e.target || (e.target = r), t = t == null ? [e] : i.makeArray(t, [e]), k = i.event.special[S] || {}, !(!n && k.trigger && k.trigger.apply(r, t) === !1))) {
          if (!n && !k.noBubble && !j(r)) {
            for (p = k.delegateType || S, Jr.test(p + S) || (o = o.parentNode); o; o = o.parentNode)
              v.push(o), l = o;
            l === (r.ownerDocument || m) && v.push(l.defaultView || l.parentWindow || c);
          }
          for (a = 0; (o = v[a++]) && !e.isPropagationStopped(); )
            E = o, e.type = a > 1 ? p : k.bindType || S, b = (X.get(o, "events") || /* @__PURE__ */ Object.create(null))[e.type] && X.get(o, "handle"), b && b.apply(o, t), b = d && o[d], b && b.apply && Tt(o) && (e.result = b.apply(o, t), e.result === !1 && e.preventDefault());
          return e.type = S, !n && !e.isDefaultPrevented() && (!k._default || k._default.apply(v.pop(), t) === !1) && Tt(r) && d && w(r[S]) && !j(r) && (l = r[d], l && (r[d] = null), i.event.triggered = S, e.isPropagationStopped() && E.addEventListener(S, Yr), r[S](), e.isPropagationStopped() && E.removeEventListener(S, Yr), i.event.triggered = void 0, l && (r[d] = l)), e.result;
        }
      },
      simulate: function(e, t, r) {
        var n = i.extend(
          new i.Event(),
          r,
          {
            type: e,
            isSimulated: !0
          }
        );
        i.event.trigger(n, null, t);
      }
    }), i.fn.extend({
      trigger: function(e, t) {
        return this.each(function() {
          i.event.trigger(e, t, this);
        });
      },
      triggerHandler: function(e, t) {
        var r = this[0];
        if (r)
          return i.event.trigger(e, t, r, !0);
      }
    }), M.focusin || i.each({ focus: "focusin", blur: "focusout" }, function(e, t) {
      var r = function(n) {
        i.event.simulate(t, n.target, i.event.fix(n));
      };
      i.event.special[t] = {
        setup: function() {
          var n = this.ownerDocument || this.document || this, a = X.access(n, t);
          a || n.addEventListener(e, r, !0), X.access(n, t, (a || 0) + 1);
        },
        teardown: function() {
          var n = this.ownerDocument || this.document || this, a = X.access(n, t) - 1;
          a ? X.access(n, t, a) : (n.removeEventListener(e, r, !0), X.remove(n, t));
        }
      };
    });
    var Dt = c.location, Zr = { guid: Date.now() }, lr = /\?/;
    i.parseXML = function(e) {
      var t, r;
      if (!e || typeof e != "string")
        return null;
      try {
        t = new c.DOMParser().parseFromString(e, "text/xml");
      } catch {
      }
      return r = t && t.getElementsByTagName("parsererror")[0], (!t || r) && i.error("Invalid XML: " + (r ? i.map(r.childNodes, function(n) {
        return n.textContent;
      }).join(`
`) : e)), t;
    };
    var ai = /\[\]$/, en = /\r?\n/g, oi = /^(?:submit|button|image|reset|file)$/i, li = /^(?:input|select|textarea|keygen)/i;
    function ur(e, t, r, n) {
      var a;
      if (Array.isArray(t))
        i.each(t, function(o, l) {
          r || ai.test(e) ? n(e, l) : ur(
            e + "[" + (typeof l == "object" && l != null ? o : "") + "]",
            l,
            r,
            n
          );
        });
      else if (!r && _(t) === "object")
        for (a in t)
          ur(e + "[" + a + "]", t[a], r, n);
      else
        n(e, t);
    }
    i.param = function(e, t) {
      var r, n = [], a = function(o, l) {
        var p = w(l) ? l() : l;
        n[n.length] = encodeURIComponent(o) + "=" + encodeURIComponent(p == null ? "" : p);
      };
      if (e == null)
        return "";
      if (Array.isArray(e) || e.jquery && !i.isPlainObject(e))
        i.each(e, function() {
          a(this.name, this.value);
        });
      else
        for (r in e)
          ur(r, e[r], t, a);
      return n.join("&");
    }, i.fn.extend({
      serialize: function() {
        return i.param(this.serializeArray());
      },
      serializeArray: function() {
        return this.map(function() {
          var e = i.prop(this, "elements");
          return e ? i.makeArray(e) : this;
        }).filter(function() {
          var e = this.type;
          return this.name && !i(this).is(":disabled") && li.test(this.nodeName) && !oi.test(e) && (this.checked || !St.test(e));
        }).map(function(e, t) {
          var r = i(this).val();
          return r == null ? null : Array.isArray(r) ? i.map(r, function(n) {
            return { name: t.name, value: n.replace(en, `\r
`) };
          }) : { name: t.name, value: r.replace(en, `\r
`) };
        }).get();
      }
    });
    var ui = /%20/g, fi = /#.*$/, ci = /([?&])_=[^&]*/, di = /^(.*?):[ \t]*([^\r\n]*)$/mg, hi = /^(?:about|app|app-storage|.+-extension|file|res|widget):$/, pi = /^(?:GET|HEAD)$/, gi = /^\/\//, tn = {}, fr = {}, rn = "*/".concat("*"), cr = m.createElement("a");
    cr.href = Dt.href;
    function nn(e) {
      return function(t, r) {
        typeof t != "string" && (r = t, t = "*");
        var n, a = 0, o = t.toLowerCase().match(Ie) || [];
        if (w(r))
          for (; n = o[a++]; )
            n[0] === "+" ? (n = n.slice(1) || "*", (e[n] = e[n] || []).unshift(r)) : (e[n] = e[n] || []).push(r);
      };
    }
    function sn(e, t, r, n) {
      var a = {}, o = e === fr;
      function l(p) {
        var d;
        return a[p] = !0, i.each(e[p] || [], function(b, k) {
          var E = k(t, r, n);
          if (typeof E == "string" && !o && !a[E])
            return t.dataTypes.unshift(E), l(E), !1;
          if (o)
            return !(d = E);
        }), d;
      }
      return l(t.dataTypes[0]) || !a["*"] && l("*");
    }
    function dr(e, t) {
      var r, n, a = i.ajaxSettings.flatOptions || {};
      for (r in t)
        t[r] !== void 0 && ((a[r] ? e : n || (n = {}))[r] = t[r]);
      return n && i.extend(!0, e, n), e;
    }
    function yi(e, t, r) {
      for (var n, a, o, l, p = e.contents, d = e.dataTypes; d[0] === "*"; )
        d.shift(), n === void 0 && (n = e.mimeType || t.getResponseHeader("Content-Type"));
      if (n) {
        for (a in p)
          if (p[a] && p[a].test(n)) {
            d.unshift(a);
            break;
          }
      }
      if (d[0] in r)
        o = d[0];
      else {
        for (a in r) {
          if (!d[0] || e.converters[a + " " + d[0]]) {
            o = a;
            break;
          }
          l || (l = a);
        }
        o = o || l;
      }
      if (o)
        return o !== d[0] && d.unshift(o), r[o];
    }
    function bi(e, t, r, n) {
      var a, o, l, p, d, b = {}, k = e.dataTypes.slice();
      if (k[1])
        for (l in e.converters)
          b[l.toLowerCase()] = e.converters[l];
      for (o = k.shift(); o; )
        if (e.responseFields[o] && (r[e.responseFields[o]] = t), !d && n && e.dataFilter && (t = e.dataFilter(t, e.dataType)), d = o, o = k.shift(), o) {
          if (o === "*")
            o = d;
          else if (d !== "*" && d !== o) {
            if (l = b[d + " " + o] || b["* " + o], !l) {
              for (a in b)
                if (p = a.split(" "), p[1] === o && (l = b[d + " " + p[0]] || b["* " + p[0]], l)) {
                  l === !0 ? l = b[a] : b[a] !== !0 && (o = p[0], k.unshift(p[1]));
                  break;
                }
            }
            if (l !== !0)
              if (l && e.throws)
                t = l(t);
              else
                try {
                  t = l(t);
                } catch (E) {
                  return {
                    state: "parsererror",
                    error: l ? E : "No conversion from " + d + " to " + o
                  };
                }
          }
        }
      return { state: "success", data: t };
    }
    i.extend({
      active: 0,
      lastModified: {},
      etag: {},
      ajaxSettings: {
        url: Dt.href,
        type: "GET",
        isLocal: hi.test(Dt.protocol),
        global: !0,
        processData: !0,
        async: !0,
        contentType: "application/x-www-form-urlencoded; charset=UTF-8",
        accepts: {
          "*": rn,
          text: "text/plain",
          html: "text/html",
          xml: "application/xml, text/xml",
          json: "application/json, text/javascript"
        },
        contents: {
          xml: /\bxml\b/,
          html: /\bhtml/,
          json: /\bjson\b/
        },
        responseFields: {
          xml: "responseXML",
          text: "responseText",
          json: "responseJSON"
        },
        converters: {
          "* text": String,
          "text html": !0,
          "text json": JSON.parse,
          "text xml": i.parseXML
        },
        flatOptions: {
          url: !0,
          context: !0
        }
      },
      ajaxSetup: function(e, t) {
        return t ? dr(dr(e, i.ajaxSettings), t) : dr(i.ajaxSettings, e);
      },
      ajaxPrefilter: nn(tn),
      ajaxTransport: nn(fr),
      ajax: function(e, t) {
        typeof e == "object" && (t = e, e = void 0), t = t || {};
        var r, n, a, o, l, p, d, b, k, E, v = i.ajaxSetup({}, t), S = v.context || v, W = v.context && (S.nodeType || S.jquery) ? i(S) : i.event, ee = i.Deferred(), U = i.Callbacks("once memory"), me = v.statusCode || {}, be = {}, Ae = {}, ue = "canceled", Z = {
          readyState: 0,
          getResponseHeader: function(se) {
            var ge;
            if (d) {
              if (!o)
                for (o = {}; ge = di.exec(a); )
                  o[ge[1].toLowerCase() + " "] = (o[ge[1].toLowerCase() + " "] || []).concat(ge[2]);
              ge = o[se.toLowerCase() + " "];
            }
            return ge == null ? null : ge.join(", ");
          },
          getAllResponseHeaders: function() {
            return d ? a : null;
          },
          setRequestHeader: function(se, ge) {
            return d == null && (se = Ae[se.toLowerCase()] = Ae[se.toLowerCase()] || se, be[se] = ge), this;
          },
          overrideMimeType: function(se) {
            return d == null && (v.mimeType = se), this;
          },
          statusCode: function(se) {
            var ge;
            if (se)
              if (d)
                Z.always(se[Z.status]);
              else
                for (ge in se)
                  me[ge] = [me[ge], se[ge]];
            return this;
          },
          abort: function(se) {
            var ge = se || ue;
            return r && r.abort(ge), Le(0, ge), this;
          }
        };
        if (ee.promise(Z), v.url = ((e || v.url || Dt.href) + "").replace(gi, Dt.protocol + "//"), v.type = t.method || t.type || v.method || v.type, v.dataTypes = (v.dataType || "*").toLowerCase().match(Ie) || [""], v.crossDomain == null) {
          p = m.createElement("a");
          try {
            p.href = v.url, p.href = p.href, v.crossDomain = cr.protocol + "//" + cr.host != p.protocol + "//" + p.host;
          } catch {
            v.crossDomain = !0;
          }
        }
        if (v.data && v.processData && typeof v.data != "string" && (v.data = i.param(v.data, v.traditional)), sn(tn, v, t, Z), d)
          return Z;
        b = i.event && v.global, b && i.active++ === 0 && i.event.trigger("ajaxStart"), v.type = v.type.toUpperCase(), v.hasContent = !pi.test(v.type), n = v.url.replace(fi, ""), v.hasContent ? v.data && v.processData && (v.contentType || "").indexOf("application/x-www-form-urlencoded") === 0 && (v.data = v.data.replace(ui, "+")) : (E = v.url.slice(n.length), v.data && (v.processData || typeof v.data == "string") && (n += (lr.test(n) ? "&" : "?") + v.data, delete v.data), v.cache === !1 && (n = n.replace(ci, "$1"), E = (lr.test(n) ? "&" : "?") + "_=" + Zr.guid++ + E), v.url = n + E), v.ifModified && (i.lastModified[n] && Z.setRequestHeader("If-Modified-Since", i.lastModified[n]), i.etag[n] && Z.setRequestHeader("If-None-Match", i.etag[n])), (v.data && v.hasContent && v.contentType !== !1 || t.contentType) && Z.setRequestHeader("Content-Type", v.contentType), Z.setRequestHeader(
          "Accept",
          v.dataTypes[0] && v.accepts[v.dataTypes[0]] ? v.accepts[v.dataTypes[0]] + (v.dataTypes[0] !== "*" ? ", " + rn + "; q=0.01" : "") : v.accepts["*"]
        );
        for (k in v.headers)
          Z.setRequestHeader(k, v.headers[k]);
        if (v.beforeSend && (v.beforeSend.call(S, Z, v) === !1 || d))
          return Z.abort();
        if (ue = "abort", U.add(v.complete), Z.done(v.success), Z.fail(v.error), r = sn(fr, v, t, Z), !r)
          Le(-1, "No Transport");
        else {
          if (Z.readyState = 1, b && W.trigger("ajaxSend", [Z, v]), d)
            return Z;
          v.async && v.timeout > 0 && (l = c.setTimeout(function() {
            Z.abort("timeout");
          }, v.timeout));
          try {
            d = !1, r.send(be, Le);
          } catch (se) {
            if (d)
              throw se;
            Le(-1, se);
          }
        }
        function Le(se, ge, qt, zt) {
          var Ne, it, st, qe, Ye, Fe = ge;
          d || (d = !0, l && c.clearTimeout(l), r = void 0, a = zt || "", Z.readyState = se > 0 ? 4 : 0, Ne = se >= 200 && se < 300 || se === 304, qt && (qe = yi(v, Z, qt)), !Ne && i.inArray("script", v.dataTypes) > -1 && i.inArray("json", v.dataTypes) < 0 && (v.converters["text script"] = function() {
          }), qe = bi(v, qe, Z, Ne), Ne ? (v.ifModified && (Ye = Z.getResponseHeader("Last-Modified"), Ye && (i.lastModified[n] = Ye), Ye = Z.getResponseHeader("etag"), Ye && (i.etag[n] = Ye)), se === 204 || v.type === "HEAD" ? Fe = "nocontent" : se === 304 ? Fe = "notmodified" : (Fe = qe.state, it = qe.data, st = qe.error, Ne = !st)) : (st = Fe, (se || !Fe) && (Fe = "error", se < 0 && (se = 0))), Z.status = se, Z.statusText = (ge || Fe) + "", Ne ? ee.resolveWith(S, [it, Fe, Z]) : ee.rejectWith(S, [Z, Fe, st]), Z.statusCode(me), me = void 0, b && W.trigger(
            Ne ? "ajaxSuccess" : "ajaxError",
            [Z, v, Ne ? it : st]
          ), U.fireWith(S, [Z, Fe]), b && (W.trigger("ajaxComplete", [Z, v]), --i.active || i.event.trigger("ajaxStop")));
        }
        return Z;
      },
      getJSON: function(e, t, r) {
        return i.get(e, t, r, "json");
      },
      getScript: function(e, t) {
        return i.get(e, void 0, t, "script");
      }
    }), i.each(["get", "post"], function(e, t) {
      i[t] = function(r, n, a, o) {
        return w(n) && (o = o || a, a = n, n = void 0), i.ajax(i.extend({
          url: r,
          type: t,
          dataType: o,
          data: n,
          success: a
        }, i.isPlainObject(r) && r));
      };
    }), i.ajaxPrefilter(function(e) {
      var t;
      for (t in e.headers)
        t.toLowerCase() === "content-type" && (e.contentType = e.headers[t] || "");
    }), i._evalUrl = function(e, t, r) {
      return i.ajax({
        url: e,
        type: "GET",
        dataType: "script",
        cache: !0,
        async: !1,
        global: !1,
        converters: {
          "text script": function() {
          }
        },
        dataFilter: function(n) {
          i.globalEval(n, t, r);
        }
      });
    }, i.fn.extend({
      wrapAll: function(e) {
        var t;
        return this[0] && (w(e) && (e = e.call(this[0])), t = i(e, this[0].ownerDocument).eq(0).clone(!0), this[0].parentNode && t.insertBefore(this[0]), t.map(function() {
          for (var r = this; r.firstElementChild; )
            r = r.firstElementChild;
          return r;
        }).append(this)), this;
      },
      wrapInner: function(e) {
        return w(e) ? this.each(function(t) {
          i(this).wrapInner(e.call(this, t));
        }) : this.each(function() {
          var t = i(this), r = t.contents();
          r.length ? r.wrapAll(e) : t.append(e);
        });
      },
      wrap: function(e) {
        var t = w(e);
        return this.each(function(r) {
          i(this).wrapAll(t ? e.call(this, r) : e);
        });
      },
      unwrap: function(e) {
        return this.parent(e).not("body").each(function() {
          i(this).replaceWith(this.childNodes);
        }), this;
      }
    }), i.expr.pseudos.hidden = function(e) {
      return !i.expr.pseudos.visible(e);
    }, i.expr.pseudos.visible = function(e) {
      return !!(e.offsetWidth || e.offsetHeight || e.getClientRects().length);
    }, i.ajaxSettings.xhr = function() {
      try {
        return new c.XMLHttpRequest();
      } catch {
      }
    };
    var vi = {
      0: 200,
      1223: 204
    }, Lt = i.ajaxSettings.xhr();
    M.cors = !!Lt && "withCredentials" in Lt, M.ajax = Lt = !!Lt, i.ajaxTransport(function(e) {
      var t, r;
      if (M.cors || Lt && !e.crossDomain)
        return {
          send: function(n, a) {
            var o, l = e.xhr();
            if (l.open(
              e.type,
              e.url,
              e.async,
              e.username,
              e.password
            ), e.xhrFields)
              for (o in e.xhrFields)
                l[o] = e.xhrFields[o];
            e.mimeType && l.overrideMimeType && l.overrideMimeType(e.mimeType), !e.crossDomain && !n["X-Requested-With"] && (n["X-Requested-With"] = "XMLHttpRequest");
            for (o in n)
              l.setRequestHeader(o, n[o]);
            t = function(p) {
              return function() {
                t && (t = r = l.onload = l.onerror = l.onabort = l.ontimeout = l.onreadystatechange = null, p === "abort" ? l.abort() : p === "error" ? typeof l.status != "number" ? a(0, "error") : a(
                  l.status,
                  l.statusText
                ) : a(
                  vi[l.status] || l.status,
                  l.statusText,
                  (l.responseType || "text") !== "text" || typeof l.responseText != "string" ? { binary: l.response } : { text: l.responseText },
                  l.getAllResponseHeaders()
                ));
              };
            }, l.onload = t(), r = l.onerror = l.ontimeout = t("error"), l.onabort !== void 0 ? l.onabort = r : l.onreadystatechange = function() {
              l.readyState === 4 && c.setTimeout(function() {
                t && r();
              });
            }, t = t("abort");
            try {
              l.send(e.hasContent && e.data || null);
            } catch (p) {
              if (t)
                throw p;
            }
          },
          abort: function() {
            t && t();
          }
        };
    }), i.ajaxPrefilter(function(e) {
      e.crossDomain && (e.contents.script = !1);
    }), i.ajaxSetup({
      accepts: {
        script: "text/javascript, application/javascript, application/ecmascript, application/x-ecmascript"
      },
      contents: {
        script: /\b(?:java|ecma)script\b/
      },
      converters: {
        "text script": function(e) {
          return i.globalEval(e), e;
        }
      }
    }), i.ajaxPrefilter("script", function(e) {
      e.cache === void 0 && (e.cache = !1), e.crossDomain && (e.type = "GET");
    }), i.ajaxTransport("script", function(e) {
      if (e.crossDomain || e.scriptAttrs) {
        var t, r;
        return {
          send: function(n, a) {
            t = i("<script>").attr(e.scriptAttrs || {}).prop({ charset: e.scriptCharset, src: e.url }).on("load error", r = function(o) {
              t.remove(), r = null, o && a(o.type === "error" ? 404 : 200, o.type);
            }), m.head.appendChild(t[0]);
          },
          abort: function() {
            r && r();
          }
        };
      }
    });
    var an = [], hr = /(=)\?(?=&|$)|\?\?/;
    i.ajaxSetup({
      jsonp: "callback",
      jsonpCallback: function() {
        var e = an.pop() || i.expando + "_" + Zr.guid++;
        return this[e] = !0, e;
      }
    }), i.ajaxPrefilter("json jsonp", function(e, t, r) {
      var n, a, o, l = e.jsonp !== !1 && (hr.test(e.url) ? "url" : typeof e.data == "string" && (e.contentType || "").indexOf("application/x-www-form-urlencoded") === 0 && hr.test(e.data) && "data");
      if (l || e.dataTypes[0] === "jsonp")
        return n = e.jsonpCallback = w(e.jsonpCallback) ? e.jsonpCallback() : e.jsonpCallback, l ? e[l] = e[l].replace(hr, "$1" + n) : e.jsonp !== !1 && (e.url += (lr.test(e.url) ? "&" : "?") + e.jsonp + "=" + n), e.converters["script json"] = function() {
          return o || i.error(n + " was not called"), o[0];
        }, e.dataTypes[0] = "json", a = c[n], c[n] = function() {
          o = arguments;
        }, r.always(function() {
          a === void 0 ? i(c).removeProp(n) : c[n] = a, e[n] && (e.jsonpCallback = t.jsonpCallback, an.push(n)), o && w(a) && a(o[0]), o = a = void 0;
        }), "script";
    }), M.createHTMLDocument = function() {
      var e = m.implementation.createHTMLDocument("").body;
      return e.innerHTML = "<form></form><form></form>", e.childNodes.length === 2;
    }(), i.parseHTML = function(e, t, r) {
      if (typeof e != "string")
        return [];
      typeof t == "boolean" && (r = t, t = !1);
      var n, a, o;
      return t || (M.createHTMLDocument ? (t = m.implementation.createHTMLDocument(""), n = t.createElement("base"), n.href = m.location.href, t.head.appendChild(n)) : t = m), a = ct.exec(e), o = !r && [], a ? [t.createElement(a[1])] : (a = Or([e], t, o), o && o.length && i(o).remove(), i.merge([], a.childNodes));
    }, i.fn.load = function(e, t, r) {
      var n, a, o, l = this, p = e.indexOf(" ");
      return p > -1 && (n = rt(e.slice(p)), e = e.slice(0, p)), w(t) ? (r = t, t = void 0) : t && typeof t == "object" && (a = "POST"), l.length > 0 && i.ajax({
        url: e,
        type: a || "GET",
        dataType: "html",
        data: t
      }).done(function(d) {
        o = arguments, l.html(n ? i("<div>").append(i.parseHTML(d)).find(n) : d);
      }).always(r && function(d, b) {
        l.each(function() {
          r.apply(this, o || [d.responseText, b, d]);
        });
      }), this;
    }, i.expr.pseudos.animated = function(e) {
      return i.grep(i.timers, function(t) {
        return e === t.elem;
      }).length;
    }, i.offset = {
      setOffset: function(e, t, r) {
        var n, a, o, l, p, d, b, k = i.css(e, "position"), E = i(e), v = {};
        k === "static" && (e.style.position = "relative"), p = E.offset(), o = i.css(e, "top"), d = i.css(e, "left"), b = (k === "absolute" || k === "fixed") && (o + d).indexOf("auto") > -1, b ? (n = E.position(), l = n.top, a = n.left) : (l = parseFloat(o) || 0, a = parseFloat(d) || 0), w(t) && (t = t.call(e, r, i.extend({}, p))), t.top != null && (v.top = t.top - p.top + l), t.left != null && (v.left = t.left - p.left + a), "using" in t ? t.using.call(e, v) : E.css(v);
      }
    }, i.fn.extend({
      offset: function(e) {
        if (arguments.length)
          return e === void 0 ? this : this.each(function(a) {
            i.offset.setOffset(this, e, a);
          });
        var t, r, n = this[0];
        if (!!n)
          return n.getClientRects().length ? (t = n.getBoundingClientRect(), r = n.ownerDocument.defaultView, {
            top: t.top + r.pageYOffset,
            left: t.left + r.pageXOffset
          }) : { top: 0, left: 0 };
      },
      position: function() {
        if (!!this[0]) {
          var e, t, r, n = this[0], a = { top: 0, left: 0 };
          if (i.css(n, "position") === "fixed")
            t = n.getBoundingClientRect();
          else {
            for (t = this.offset(), r = n.ownerDocument, e = n.offsetParent || r.documentElement; e && (e === r.body || e === r.documentElement) && i.css(e, "position") === "static"; )
              e = e.parentNode;
            e && e !== n && e.nodeType === 1 && (a = i(e).offset(), a.top += i.css(e, "borderTopWidth", !0), a.left += i.css(e, "borderLeftWidth", !0));
          }
          return {
            top: t.top - a.top - i.css(n, "marginTop", !0),
            left: t.left - a.left - i.css(n, "marginLeft", !0)
          };
        }
      },
      offsetParent: function() {
        return this.map(function() {
          for (var e = this.offsetParent; e && i.css(e, "position") === "static"; )
            e = e.offsetParent;
          return e || tt;
        });
      }
    }), i.each({ scrollLeft: "pageXOffset", scrollTop: "pageYOffset" }, function(e, t) {
      var r = t === "pageYOffset";
      i.fn[e] = function(n) {
        return Ue(this, function(a, o, l) {
          var p;
          if (j(a) ? p = a : a.nodeType === 9 && (p = a.defaultView), l === void 0)
            return p ? p[t] : a[o];
          p ? p.scrollTo(
            r ? p.pageXOffset : l,
            r ? l : p.pageYOffset
          ) : a[o] = l;
        }, e, n, arguments.length);
      };
    }), i.each(["top", "left"], function(e, t) {
      i.cssHooks[t] = Rr(
        M.pixelPosition,
        function(r, n) {
          if (n)
            return n = xt(r, t), rr.test(n) ? i(r).position()[t] + "px" : n;
        }
      );
    }), i.each({ Height: "height", Width: "width" }, function(e, t) {
      i.each({
        padding: "inner" + e,
        content: t,
        "": "outer" + e
      }, function(r, n) {
        i.fn[n] = function(a, o) {
          var l = arguments.length && (r || typeof a != "boolean"), p = r || (a === !0 || o === !0 ? "margin" : "border");
          return Ue(this, function(d, b, k) {
            var E;
            return j(d) ? n.indexOf("outer") === 0 ? d["inner" + e] : d.document.documentElement["client" + e] : d.nodeType === 9 ? (E = d.documentElement, Math.max(
              d.body["scroll" + e],
              E["scroll" + e],
              d.body["offset" + e],
              E["offset" + e],
              E["client" + e]
            )) : k === void 0 ? i.css(d, b, p) : i.style(d, b, k, p);
          }, t, l ? a : void 0, l);
        };
      });
    }), i.each([
      "ajaxStart",
      "ajaxStop",
      "ajaxComplete",
      "ajaxError",
      "ajaxSuccess",
      "ajaxSend"
    ], function(e, t) {
      i.fn[t] = function(r) {
        return this.on(t, r);
      };
    }), i.fn.extend({
      bind: function(e, t, r) {
        return this.on(e, null, t, r);
      },
      unbind: function(e, t) {
        return this.off(e, null, t);
      },
      delegate: function(e, t, r, n) {
        return this.on(t, e, r, n);
      },
      undelegate: function(e, t, r) {
        return arguments.length === 1 ? this.off(e, "**") : this.off(t, e || "**", r);
      },
      hover: function(e, t) {
        return this.mouseenter(e).mouseleave(t || e);
      }
    }), i.each(
      "blur focus focusin focusout resize scroll click dblclick mousedown mouseup mousemove mouseover mouseout mouseenter mouseleave change select submit keydown keypress keyup contextmenu".split(" "),
      function(e, t) {
        i.fn[t] = function(r, n) {
          return arguments.length > 0 ? this.on(t, null, r, n) : this.trigger(t);
        };
      }
    );
    var mi = /^[\s\uFEFF\xA0]+|([^\s\uFEFF\xA0])[\s\uFEFF\xA0]+$/g;
    i.proxy = function(e, t) {
      var r, n, a;
      if (typeof t == "string" && (r = e[t], t = e, e = r), !!w(e))
        return n = H.call(arguments, 2), a = function() {
          return e.apply(t || this, n.concat(H.call(arguments)));
        }, a.guid = e.guid = e.guid || i.guid++, a;
    }, i.holdReady = function(e) {
      e ? i.readyWait++ : i.ready(!0);
    }, i.isArray = Array.isArray, i.parseJSON = JSON.parse, i.nodeName = ve, i.isFunction = w, i.isWindow = j, i.camelCase = ze, i.type = _, i.now = Date.now, i.isNumeric = function(e) {
      var t = i.type(e);
      return (t === "number" || t === "string") && !isNaN(e - parseFloat(e));
    }, i.trim = function(e) {
      return e == null ? "" : (e + "").replace(mi, "$1");
    };
    var ki = c.jQuery, Ti = c.$;
    return i.noConflict = function(e) {
      return c.$ === i && (c.$ = Ti), e && c.jQuery === i && (c.jQuery = ki), i;
    }, typeof f > "u" && (c.jQuery = c.$ = i), i;
  });
})(Sr);
const Cr = Sr.exports;
var Sn = { exports: {} };
/*!
 * typeahead.js 1.3.1
 * https://github.com/corejavascript/typeahead.js
 * Copyright 2013-2020 Twitter, Inc. and other contributors; Licensed MIT
 */
(function(s) {
  (function(c, f) {
    s.exports ? s.exports = f(Sr.exports) : c.Bloodhound = f(c.jQuery);
  })(wn, function(c) {
    var f = function() {
      return {
        isMsie: function() {
          return /(msie|trident)/i.test(navigator.userAgent) ? navigator.userAgent.match(/(msie |rv:)(\d+(.\d+)?)/i)[2] : !1;
        },
        isBlankString: function(F) {
          return !F || /^\s*$/.test(F);
        },
        escapeRegExChars: function(F) {
          return F.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g, "\\$&");
        },
        isString: function(F) {
          return typeof F == "string";
        },
        isNumber: function(F) {
          return typeof F == "number";
        },
        isArray: c.isArray,
        isFunction: c.isFunction,
        isObject: c.isPlainObject,
        isUndefined: function(F) {
          return typeof F > "u";
        },
        isElement: function(F) {
          return !!(F && F.nodeType === 1);
        },
        isJQuery: function(F) {
          return F instanceof c;
        },
        toStr: function(M) {
          return f.isUndefined(M) || M === null ? "" : M + "";
        },
        bind: c.proxy,
        each: function(F, M) {
          c.each(F, w);
          function w(j, m) {
            return M(m, j);
          }
        },
        map: c.map,
        filter: c.grep,
        every: function(F, M) {
          var w = !0;
          return F ? (c.each(F, function(j, m) {
            if (!(w = M.call(null, m, j, F)))
              return !1;
          }), !!w) : w;
        },
        some: function(F, M) {
          var w = !1;
          return F ? (c.each(F, function(j, m) {
            if (w = M.call(null, m, j, F))
              return !1;
          }), !!w) : w;
        },
        mixin: c.extend,
        identity: function(F) {
          return F;
        },
        clone: function(F) {
          return c.extend(!0, {}, F);
        },
        getIdGenerator: function() {
          var F = 0;
          return function() {
            return F++;
          };
        },
        templatify: function(M) {
          return c.isFunction(M) ? M : w;
          function w() {
            return String(M);
          }
        },
        defer: function(F) {
          setTimeout(F, 0);
        },
        debounce: function(F, M, w) {
          var j, m;
          return function() {
            var N = this, L = arguments, _, I;
            return _ = function() {
              j = null, w || (m = F.apply(N, L));
            }, I = w && !j, clearTimeout(j), j = setTimeout(_, M), I && (m = F.apply(N, L)), m;
          };
        },
        throttle: function(F, M) {
          var w, j, m, N, L, _;
          return L = 0, _ = function() {
            L = new Date(), m = null, N = F.apply(w, j);
          }, function() {
            var I = new Date(), i = M - (I - L);
            return w = this, j = arguments, i <= 0 ? (clearTimeout(m), m = null, L = I, N = F.apply(w, j)) : m || (m = setTimeout(_, i)), N;
          };
        },
        stringify: function(F) {
          return f.isString(F) ? F : JSON.stringify(F);
        },
        guid: function() {
          function F(M) {
            var w = (Math.random().toString(16) + "000000000").substr(2, 8);
            return M ? "-" + w.substr(0, 4) + "-" + w.substr(4, 4) : w;
          }
          return "tt-" + F() + F(!0) + F(!0) + F();
        },
        noop: function() {
        }
      };
    }(), z = "1.3.1", V = function() {
      return {
        nonword: M,
        whitespace: F,
        ngram: w,
        obj: {
          nonword: j(M),
          whitespace: j(F),
          ngram: j(w)
        }
      };
      function F(m) {
        return m = f.toStr(m), m ? m.split(/\s+/) : [];
      }
      function M(m) {
        return m = f.toStr(m), m ? m.split(/\W+/) : [];
      }
      function w(m) {
        m = f.toStr(m);
        var N = [], L = "";
        return f.each(m.split(""), function(_) {
          _.match(/\s+/) ? L = "" : (N.push(L + _), L += _);
        }), N;
      }
      function j(m) {
        return function(L) {
          return L = f.isArray(L) ? L : [].slice.call(arguments, 0), function(I) {
            var i = [];
            return f.each(L, function(re) {
              i = i.concat(m(f.toStr(I[re])));
            }), i;
          };
        };
      }
    }(), H = function() {
      function F(j) {
        this.maxSize = f.isNumber(j) ? j : 100, this.reset(), this.maxSize <= 0 && (this.set = this.get = c.noop);
      }
      f.mixin(F.prototype, {
        set: function(m, N) {
          var L = this.list.tail, _;
          this.size >= this.maxSize && (this.list.remove(L), delete this.hash[L.key], this.size--), (_ = this.hash[m]) ? (_.val = N, this.list.moveToFront(_)) : (_ = new w(m, N), this.list.add(_), this.hash[m] = _, this.size++);
        },
        get: function(m) {
          var N = this.hash[m];
          if (N)
            return this.list.moveToFront(N), N.val;
        },
        reset: function() {
          this.size = 0, this.hash = {}, this.list = new M();
        }
      });
      function M() {
        this.head = this.tail = null;
      }
      f.mixin(M.prototype, {
        add: function(m) {
          this.head && (m.next = this.head, this.head.prev = m), this.head = m, this.tail = this.tail || m;
        },
        remove: function(m) {
          m.prev ? m.prev.next = m.next : this.head = m.next, m.next ? m.next.prev = m.prev : this.tail = m.prev;
        },
        moveToFront: function(j) {
          this.remove(j), this.add(j);
        }
      });
      function w(j, m) {
        this.key = j, this.val = m, this.prev = this.next = null;
      }
      return F;
    }(), P = function() {
      var F;
      try {
        F = window.localStorage, F.setItem("~~~", "!"), F.removeItem("~~~");
      } catch {
        F = null;
      }
      function M(L, _) {
        this.prefix = ["__", L, "__"].join(""), this.ttlKey = "__ttl__", this.keyMatcher = new RegExp("^" + f.escapeRegExChars(this.prefix)), this.ls = _ || F, !this.ls && this._noop();
      }
      return f.mixin(M.prototype, {
        _prefix: function(L) {
          return this.prefix + L;
        },
        _ttlKey: function(L) {
          return this._prefix(L) + this.ttlKey;
        },
        _noop: function() {
          this.get = this.set = this.remove = this.clear = this.isExpired = f.noop;
        },
        _safeSet: function(L, _) {
          try {
            this.ls.setItem(L, _);
          } catch (I) {
            I.name === "QuotaExceededError" && (this.clear(), this._noop());
          }
        },
        get: function(L) {
          return this.isExpired(L) && this.remove(L), m(this.ls.getItem(this._prefix(L)));
        },
        set: function(L, _, I) {
          return f.isNumber(I) ? this._safeSet(this._ttlKey(L), j(w() + I)) : this.ls.removeItem(this._ttlKey(L)), this._safeSet(this._prefix(L), j(_));
        },
        remove: function(L) {
          return this.ls.removeItem(this._ttlKey(L)), this.ls.removeItem(this._prefix(L)), this;
        },
        clear: function() {
          var L, _ = N(this.keyMatcher);
          for (L = _.length; L--; )
            this.remove(_[L]);
          return this;
        },
        isExpired: function(L) {
          var _ = m(this.ls.getItem(this._ttlKey(L)));
          return !!(f.isNumber(_) && w() > _);
        }
      }), M;
      function w() {
        return new Date().getTime();
      }
      function j(L) {
        return JSON.stringify(f.isUndefined(L) ? null : L);
      }
      function m(L) {
        return c.parseJSON(L);
      }
      function N(L) {
        var _, I, i = [], re = F.length;
        for (_ = 0; _ < re; _++)
          (I = F.key(_)).match(L) && i.push(I.replace(L, ""));
        return i;
      }
    }(), A = function() {
      var F = 0, M = {}, w = new H(10);
      function j(m) {
        m = m || {}, this.maxPendingRequests = m.maxPendingRequests || 6, this.cancelled = !1, this.lastReq = null, this._send = m.transport, this._get = m.limiter ? m.limiter(this._get) : this._get, this._cache = m.cache === !1 ? new H(0) : w;
      }
      return j.setMaxPendingRequests = function(N) {
        this.maxPendingRequests = N;
      }, j.resetCache = function() {
        w.reset();
      }, f.mixin(j.prototype, {
        _fingerprint: function(N) {
          return N = N || {}, N.url + N.type + c.param(N.data || {});
        },
        _get: function(m, N) {
          var L = this, _, I;
          if (_ = this._fingerprint(m), this.cancelled || _ !== this.lastReq)
            return;
          (I = M[_]) ? I.done(i).fail(re) : F < this.maxPendingRequests ? (F++, M[_] = this._send(m).done(i).fail(re).always(ne)) : this.onDeckRequestArgs = [].slice.call(arguments, 0);
          function i(de) {
            N(null, de), L._cache.set(_, de);
          }
          function re() {
            N(!0);
          }
          function ne() {
            F--, delete M[_], L.onDeckRequestArgs && (L._get.apply(L, L.onDeckRequestArgs), L.onDeckRequestArgs = null);
          }
        },
        get: function(m, N) {
          var L, _;
          N = N || c.noop, m = f.isString(m) ? {
            url: m
          } : m || {}, _ = this._fingerprint(m), this.cancelled = !1, this.lastReq = _, (L = this._cache.get(_)) ? N(null, L) : this._get(m, N);
        },
        cancel: function() {
          this.cancelled = !0;
        }
      }), j;
    }(), te = window.SearchIndex = function() {
      var F = "c", M = "i";
      function w(_) {
        _ = _ || {}, (!_.datumTokenizer || !_.queryTokenizer) && c.error("datumTokenizer and queryTokenizer are both required"), this.identify = _.identify || f.stringify, this.datumTokenizer = _.datumTokenizer, this.queryTokenizer = _.queryTokenizer, this.matchAnyQueryToken = _.matchAnyQueryToken, this.reset();
      }
      return f.mixin(w.prototype, {
        bootstrap: function(I) {
          this.datums = I.datums, this.trie = I.trie;
        },
        add: function(_) {
          var I = this;
          _ = f.isArray(_) ? _ : [_], f.each(_, function(i) {
            var re, ne;
            I.datums[re = I.identify(i)] = i, ne = j(I.datumTokenizer(i)), f.each(ne, function(de) {
              var ae, We, ve;
              for (ae = I.trie, We = de.split(""); ve = We.shift(); )
                ae = ae[F][ve] || (ae[F][ve] = m()), ae[M].push(re);
            });
          });
        },
        get: function(I) {
          var i = this;
          return f.map(I, function(re) {
            return i.datums[re];
          });
        },
        search: function(I) {
          var i = this, re, ne;
          return re = j(this.queryTokenizer(I)), f.each(re, function(de) {
            var ae, We, ve, ct;
            if (ne && ne.length === 0 && !i.matchAnyQueryToken)
              return !1;
            for (ae = i.trie, We = de.split(""); ae && (ve = We.shift()); )
              ae = ae[F][ve];
            if (ae && We.length === 0)
              ct = ae[M].slice(0), ne = ne ? L(ne, ct) : ct;
            else if (!i.matchAnyQueryToken)
              return ne = [], !1;
          }), ne ? f.map(N(ne), function(de) {
            return i.datums[de];
          }) : [];
        },
        all: function() {
          var I = [];
          for (var i in this.datums)
            I.push(this.datums[i]);
          return I;
        },
        reset: function() {
          this.datums = {}, this.trie = m();
        },
        serialize: function() {
          return {
            datums: this.datums,
            trie: this.trie
          };
        }
      }), w;
      function j(_) {
        return _ = f.filter(_, function(I) {
          return !!I;
        }), _ = f.map(_, function(I) {
          return I.toLowerCase();
        }), _;
      }
      function m() {
        var _ = {};
        return _[M] = [], _[F] = {}, _;
      }
      function N(_) {
        for (var I = {}, i = [], re = 0, ne = _.length; re < ne; re++)
          I[_[re]] || (I[_[re]] = !0, i.push(_[re]));
        return i;
      }
      function L(_, I) {
        var i = 0, re = 0, ne = [];
        _ = _.sort(), I = I.sort();
        for (var de = _.length, ae = I.length; i < de && re < ae; )
          _[i] < I[re] ? i++ : (_[i] > I[re] || (ne.push(_[i]), i++), re++);
        return ne;
      }
    }(), le = function() {
      var F;
      F = {
        data: "data",
        protocol: "protocol",
        thumbprint: "thumbprint"
      };
      function M(w) {
        this.url = w.url, this.ttl = w.ttl, this.cache = w.cache, this.prepare = w.prepare, this.transform = w.transform, this.transport = w.transport, this.thumbprint = w.thumbprint, this.storage = new P(w.cacheKey);
      }
      return f.mixin(M.prototype, {
        _settings: function() {
          return {
            url: this.url,
            type: "GET",
            dataType: "json"
          };
        },
        store: function(j) {
          !this.cache || (this.storage.set(F.data, j, this.ttl), this.storage.set(F.protocol, location.protocol, this.ttl), this.storage.set(F.thumbprint, this.thumbprint, this.ttl));
        },
        fromCache: function() {
          var j = {}, m;
          return this.cache ? (j.data = this.storage.get(F.data), j.protocol = this.storage.get(F.protocol), j.thumbprint = this.storage.get(F.thumbprint), m = j.thumbprint !== this.thumbprint || j.protocol !== location.protocol, j.data && !m ? j.data : null) : null;
        },
        fromNetwork: function(w) {
          var j = this, m;
          if (!w)
            return;
          m = this.prepare(this._settings()), this.transport(m).fail(N).done(L);
          function N() {
            w(!0);
          }
          function L(_) {
            w(null, j.transform(_));
          }
        },
        clear: function() {
          return this.storage.clear(), this;
        }
      }), M;
    }(), Ot = function() {
      function F(M) {
        this.url = M.url, this.prepare = M.prepare, this.transform = M.transform, this.indexResponse = M.indexResponse, this.transport = new A({
          cache: M.cache,
          limiter: M.limiter,
          transport: M.transport,
          maxPendingRequests: M.maxPendingRequests
        });
      }
      return f.mixin(F.prototype, {
        _settings: function() {
          return {
            url: this.url,
            type: "GET",
            dataType: "json"
          };
        },
        get: function(w, j) {
          var m = this, N;
          if (!j)
            return;
          return w = w || "", N = this.prepare(w, this._settings()), this.transport.get(N, L);
          function L(_, I) {
            j(_ ? [] : m.transform(I));
          }
        },
        cancelLastRequest: function() {
          this.transport.cancel();
        }
      }), F;
    }(), ft = function() {
      return function(L) {
        var _, I;
        return _ = {
          initialize: !0,
          identify: f.stringify,
          datumTokenizer: null,
          queryTokenizer: null,
          matchAnyQueryToken: !1,
          sufficient: 5,
          indexRemote: !1,
          sorter: null,
          local: [],
          prefetch: null,
          remote: null
        }, L = f.mixin(_, L || {}), !L.datumTokenizer && c.error("datumTokenizer is required"), !L.queryTokenizer && c.error("queryTokenizer is required"), I = L.sorter, L.sorter = I ? function(i) {
          return i.sort(I);
        } : f.identity, L.local = f.isFunction(L.local) ? L.local() : L.local, L.prefetch = F(L.prefetch), L.remote = M(L.remote), L;
      };
      function F(N) {
        var L;
        return N ? (L = {
          url: null,
          ttl: 24 * 60 * 60 * 1e3,
          cache: !0,
          cacheKey: null,
          thumbprint: "",
          prepare: f.identity,
          transform: f.identity,
          transport: null
        }, N = f.isString(N) ? {
          url: N
        } : N, N = f.mixin(L, N), !N.url && c.error("prefetch requires url to be set"), N.transform = N.filter || N.transform, N.cacheKey = N.cacheKey || N.url, N.thumbprint = z + N.thumbprint, N.transport = N.transport ? m(N.transport) : c.ajax, N) : null;
      }
      function M(N) {
        var L;
        if (!!N)
          return L = {
            url: null,
            cache: !0,
            prepare: null,
            replace: null,
            wildcard: null,
            limiter: null,
            rateLimitBy: "debounce",
            rateLimitWait: 300,
            transform: f.identity,
            transport: null
          }, N = f.isString(N) ? {
            url: N
          } : N, N = f.mixin(L, N), !N.url && c.error("remote requires url to be set"), N.transform = N.filter || N.transform, N.prepare = w(N), N.limiter = j(N), N.transport = N.transport ? m(N.transport) : c.ajax, delete N.replace, delete N.wildcard, delete N.rateLimitBy, delete N.rateLimitWait, N;
      }
      function w(N) {
        var L, _, I;
        if (L = N.prepare, _ = N.replace, I = N.wildcard, L)
          return L;
        return _ ? L = i : N.wildcard ? L = re : L = ne, L;
        function i(de, ae) {
          return ae.url = _(ae.url, de), ae;
        }
        function re(de, ae) {
          return ae.url = ae.url.replace(I, encodeURIComponent(de)), ae;
        }
        function ne(de, ae) {
          return ae;
        }
      }
      function j(N) {
        var L, _, I;
        return L = N.limiter, _ = N.rateLimitBy, I = N.rateLimitWait, L || (L = /^throttle$/i.test(_) ? re(I) : i(I)), L;
        function i(ne) {
          return function(ae) {
            return f.debounce(ae, ne);
          };
        }
        function re(ne) {
          return function(ae) {
            return f.throttle(ae, ne);
          };
        }
      }
      function m(N) {
        return function(_) {
          var I = c.Deferred();
          return N(_, i, re), I;
          function i(ne) {
            f.defer(function() {
              I.resolve(ne);
            });
          }
          function re(ne) {
            f.defer(function() {
              I.reject(ne);
            });
          }
        };
      }
    }(), Ht = function() {
      var F;
      F = window && window.Bloodhound;
      function M(w) {
        w = ft(w), this.sorter = w.sorter, this.identify = w.identify, this.sufficient = w.sufficient, this.indexRemote = w.indexRemote, this.local = w.local, this.remote = w.remote ? new Ot(w.remote) : null, this.prefetch = w.prefetch ? new le(w.prefetch) : null, this.index = new te({
          identify: this.identify,
          datumTokenizer: w.datumTokenizer,
          queryTokenizer: w.queryTokenizer
        }), w.initialize !== !1 && this.initialize();
      }
      return M.noConflict = function() {
        return window && (window.Bloodhound = F), M;
      }, M.tokenizers = V, f.mixin(M.prototype, {
        __ttAdapter: function() {
          var j = this;
          return this.remote ? m : N;
          function m(L, _, I) {
            return j.search(L, _, I);
          }
          function N(L, _) {
            return j.search(L, _);
          }
        },
        _loadPrefetch: function() {
          var j = this, m, N;
          return m = c.Deferred(), this.prefetch ? (N = this.prefetch.fromCache()) ? (this.index.bootstrap(N), m.resolve()) : this.prefetch.fromNetwork(L) : m.resolve(), m.promise();
          function L(_, I) {
            if (_)
              return m.reject();
            j.add(I), j.prefetch.store(j.index.serialize()), m.resolve();
          }
        },
        _initialize: function() {
          var j = this;
          return this.clear(), (this.initPromise = this._loadPrefetch()).done(m), this.initPromise;
          function m() {
            j.add(j.local);
          }
        },
        initialize: function(j) {
          return !this.initPromise || j ? this._initialize() : this.initPromise;
        },
        add: function(j) {
          return this.index.add(j), this;
        },
        get: function(j) {
          return j = f.isArray(j) ? j : [].slice.call(arguments), this.index.get(j);
        },
        search: function(j, m, N) {
          var L = this, _;
          return m = m || f.noop, N = N || f.noop, _ = this.sorter(this.index.search(j)), m(this.remote ? _.slice() : _), this.remote && _.length < this.sufficient ? this.remote.get(j, I) : this.remote && this.remote.cancelLastRequest(), this;
          function I(i) {
            var re = [];
            f.each(i, function(ne) {
              !f.some(_, function(de) {
                return L.identify(ne) === L.identify(de);
              }) && re.push(ne);
            }), L.indexRemote && L.add(re), N(re);
          }
        },
        all: function() {
          return this.index.all();
        },
        clear: function() {
          return this.index.reset(), this;
        },
        clearPrefetchCache: function() {
          return this.prefetch && this.prefetch.clear(), this;
        },
        clearRemoteCache: function() {
          return A.resetCache(), this;
        },
        ttAdapter: function() {
          return this.__ttAdapter();
        }
      }), M;
    }();
    return Ht;
  });
})(Sn);
const mt = Sn.exports;
const yo = {
  name: "harness-vue-bootstrap-input",
  mixins: [Ve, Je],
  components: { InputPartial: go },
  props: {
    type: {
      required: !1,
      type: String,
      default: "text",
      validator: function(s) {
        return [
          "date",
          "datetime-local",
          "email",
          "month",
          "number",
          "password",
          "search",
          "tel",
          "text",
          "time",
          "url",
          "week"
        ].includes(s);
      }
    },
    typeahead: {
      type: Boolean,
      required: !1,
      default: !1
    },
    strict: {
      type: Boolean,
      required: !1,
      default: !0
    },
    placeholder: {
      required: !1,
      type: String,
      default: ""
    },
    prependComponent: {
      required: !1,
      type: Object
    },
    prependHTML: {
      required: !1,
      type: String
    },
    appendComponent: {
      required: !1,
      type: Object
    },
    appendHTML: {
      required: !1,
      type: String
    }
  },
  data() {
    return {
      bloodhound: null,
      subscription: null,
      strictError: !1
    };
  },
  computed: {
    boundValue: {
      get() {
        return this.getFilter(this.filter.key);
      },
      set(s) {
        !this.strict || this.evaluateStrict ? (this.strictError = !1, this.setFilterLoadData(this.filter.key, s)) : this.strict && !this.evaluateStrict && (this.strictError = !0);
      }
    }
  },
  methods: {
    evaluateStrict(s) {
      return this.getOptionsForFilter(this.filter.key).map((c) => c.key).includes(s);
    },
    initTypeahead() {
      this.bloodhound = new mt({
        datumTokenizer: mt.tokenizers.ngram,
        queryTokenizer: mt.tokenizers.ngram,
        local: this.getOptionsForFilter(this.filter.key).map((c) => c.key)
      });
      const s = [
        "input",
        "hint",
        "menu",
        "dataset",
        "suggestion",
        "empty",
        "open",
        "cursor",
        "highlight"
      ].reduce((c, f) => (c[f] = `harness-vue-bootstrap-typeahead-${f}`, c), {});
      console.log(Cr(`#${this.filter.key}-${this.type}-input`)), Cr(`#${this.filter.key}-${this.type}-input`).typeahead(
        {
          highlight: !0,
          minLength: 1,
          classNames: s
        },
        {
          name: this.filter.key,
          limit: 10,
          source: this.bloodhound
        }
      ).bind("typeahead:select", (c, f) => {
        this.setFilter(this.filter.key, f);
      }).bind("typeahead:autocomplete", (c, f) => {
        this.setFilter(this.filter.key, f);
      });
    }
  },
  mounted() {
    this.typeahead && this.initTypeahead();
  },
  beforeUnmount() {
    this.typeahead && this.bloodhound.clear();
  }
}, bo = { class: "row form-row" }, vo = ["for", "id", "innerHTML"], mo = ["innerHTML"], ko = ["for", "id", "innerHTML"], To = ["innerHTML"], Co = ["innerHTML"];
function wo(s, c, f, z, V, H) {
  const P = Ke("InputPartial");
  return C(), x("div", null, [
    s.labelPosition == "horizontal" ? (C(), x("div", {
      key: 0,
      class: R(s.isFilterDirty(s.filter.key) ? "dirty-filter-wrapper" : "")
    }, [
      T("div", bo, [
        T("div", {
          class: R(
            "col-" + s.labelColumnSize + " " + (s.isFilterDirty(s.filter.key) ? "dirty-filter-label-wrapper" : "")
          )
        }, [
          T("label", {
            for: s.filter.key,
            class: R(
              "col-form-label harness-vue-bootstrap-select-label harness-vue-bootstrap-select-label-horizontal " + (s.isFilterDirty(s.filter.key) ? "dirty-filter-label" : "")
            ),
            id: s.filter.key + "-label",
            innerHTML: s.filter.label
          }, null, 10, vo)
        ], 2),
        T("div", {
          class: R(
            "col-" + (12 - s.labelColumnSize) + " " + (s.isFilterDirty(s.filter.key) ? "dirty-filter-input-wrapper" : "")
          )
        }, [
          Se(P, Oe(Re({ ...s.$props, ...s.$attrs, strictError: V.strictError })), null, 16),
          s.helperText ? (C(), x("small", {
            key: 0,
            innerHTML: s.helperText,
            class: R(
              "form-text harness-vue-bootstrap-helper-text harness-vue-bootstrap-input-helper-text " + s.helperTextClass
            )
          }, null, 10, mo)) : G("", !0)
        ], 2)
      ])
    ], 2)) : G("", !0),
    s.labelPosition == "vertical" ? (C(), x("div", {
      key: 1,
      class: R(s.isFilterDirty(s.filter.key) ? "dirty-filter-wrapper" : "")
    }, [
      T("label", {
        for: s.filter.key,
        class: R(
          "col-form-label harness-vue-bootstrap-select-label harness-vue-bootstrap-select-label-vertical " + (s.isFilterDirty(s.filter.key) ? "dirty-filter-label" : "")
        ),
        id: s.filter.key + "-label",
        innerHTML: s.filter.label
      }, null, 10, ko),
      Se(P, Oe(Re({ ...s.$props, ...s.$attrs, strictError: V.strictError })), null, 16),
      s.helperText ? (C(), x("small", {
        key: 0,
        innerHTML: s.helperText,
        class: R(
          "form-text harness-vue-bootstrap-helper-text harness-vue-bootstrap-input-helper-text " + s.helperTextClass
        )
      }, null, 10, To)) : G("", !0)
    ], 2)) : G("", !0),
    s.labelPosition == "none" ? (C(), x("div", {
      key: 2,
      class: R(
        "form-inline " + (s.isFilterDirty(s.filter.key) ? "dirty-filter-wrapper" : "")
      )
    }, [
      Se(P, Oe(Re({ ...s.$props, ...s.$attrs, strictError: V.strictError })), null, 16),
      s.helperText ? (C(), x("small", {
        key: 0,
        innerHTML: s.helperText,
        class: R(
          "form-text harness-vue-bootstrap-helper-text harness-vue-bootstrap-input-helper-text " + s.helperTextClass
        )
      }, null, 10, Co)) : G("", !0)
    ], 2)) : G("", !0)
  ]);
}
const So = /* @__PURE__ */ Te(yo, [["render", wo]]), xo = {
  name: "SelectPartial",
  mixins: [Ve, Je],
  props: {
    multiple: {
      type: Boolean,
      required: !1,
      default: !1
    }
  }
}, _o = ["multiple", "id", "aria-labelledby"], Do = ["value", "disabled", "hidden", "title", "innerHTML"];
function Lo(s, c, f, z, V, H) {
  return $e((C(), x("select", {
    multiple: f.multiple,
    class: R(
      "form-control harness-vue-bootstrap-select " + (s.isFilterDirty(s.filter.key) ? "dirty-filter-select" : "")
    ),
    "onUpdate:modelValue": c[0] || (c[0] = (P) => s.boundValue = P),
    id: s.filter.key + "-select",
    "aria-labelledby": s.filter.key + "-label"
  }, [
    (C(!0), x(he, null, ye(s.getOptionsForFilter(s.filter.key), (P) => (C(), x("option", {
      key: P.key,
      value: P.key,
      disabled: P.disabled,
      hidden: P.hidden,
      title: P.label,
      innerHTML: P.label
    }, null, 8, Do))), 128))
  ], 10, _o)), [
    [Kt, s.boundValue]
  ]);
}
const qo = /* @__PURE__ */ Te(xo, [["render", Lo]]), Ao = {
  name: "harness-vue-bootstrap-select",
  mixins: [Ve, Je],
  components: { SelectPartial: qo },
  props: {
    multiple: {
      type: Boolean,
      required: !1,
      default: !1
    }
  }
}, No = { class: "row form-row" }, Po = ["for", "id", "innerHTML"], Eo = ["innerHTML"], Oo = ["for", "id", "innerHTML"], Ho = ["innerHTML"], Fo = ["innerHTML"];
function Mo(s, c, f, z, V, H) {
  const P = Ke("SelectPartial");
  return C(), x("div", null, [
    s.labelPosition == "horizontal" ? (C(), x("div", {
      key: 0,
      class: R(s.isFilterDirty(s.filter.key) ? "dirty-filter-wrapper" : "")
    }, [
      T("div", No, [
        T("div", {
          class: R("col-" + s.labelColumnSize)
        }, [
          T("label", {
            for: s.filter.key,
            class: R(
              "col-form-label harness-vue-bootstrap-select-label harness-vue-bootstrap-select-label-horizontal " + (s.isFilterDirty(s.filter.key) ? "dirty-filter-label" : "")
            ),
            id: s.filter.key + "-label",
            innerHTML: s.filter.label
          }, null, 10, Po)
        ], 2),
        T("div", {
          class: R("col-" + (12 - s.labelColumnSize))
        }, [
          Se(P, Oe(Re({ ...s.$props, ...s.$attrs })), null, 16),
          s.helperText ? (C(), x("small", {
            key: 0,
            innerHTML: s.helperText,
            class: R(
              "form-text harness-vue-bootstrap-select-helper-text harness-vue-bootstrap-helper-text " + s.helperTextClass
            )
          }, null, 10, Eo)) : G("", !0)
        ], 2)
      ])
    ], 2)) : G("", !0),
    s.labelPosition == "vertical" ? (C(), x("div", {
      key: 1,
      class: R(s.isFilterDirty(s.filter.key) ? "dirty-filter-wrapper" : "")
    }, [
      T("label", {
        for: s.filter.key,
        class: R(
          "col-form-label harness-vue-bootstrap-select-label harness-vue-bootstrap-select-label-vertical " + (s.isFilterDirty(s.filter.key) ? "dirty-filter-label" : "")
        ),
        id: s.filter.key + "-label",
        innerHTML: s.filter.label
      }, null, 10, Oo),
      Se(P, Oe(Re({ ...s.$props, ...s.$attrs })), null, 16),
      s.helperText ? (C(), x("small", {
        key: 0,
        innerHTML: s.helperText,
        class: R(
          "form-text harness-vue-bootstrap-select-helper-text harness-vue-bootstrap-helper-text " + s.helperTextClass
        )
      }, null, 10, Ho)) : G("", !0)
    ], 2)) : G("", !0),
    s.labelPosition == "none" ? (C(), x("div", {
      key: 2,
      class: R(
        "form-inline " + (s.isFilterDirty(s.filter.key) ? "dirty-filter-wrapper" : "")
      )
    }, [
      Se(P, Oe(Re({ ...s.$props, ...s.$attrs })), null, 16),
      s.helperText ? (C(), x("small", {
        key: 0,
        innerHTML: s.helperText,
        class: R(
          "form-text harness-vue-bootstrap-select-helper-text harness-vue-bootstrap-helper-text " + s.helperTextClass
        )
      }, null, 10, Fo)) : G("", !0)
    ], 2)) : G("", !0)
  ]);
}
const jo = /* @__PURE__ */ Te(Ao, [["render", Mo]]), Bo = {
  name: "CheckboxPartial",
  mixins: [Ve, Je],
  props: {
    option: {
      type: Object,
      required: !0
    }
  }
}, $o = ["name", "id", "value", "disabled", "aria-labelledby"];
function Ro(s, c, f, z, V, H) {
  return $e((C(), x("input", {
    class: "form-check-input harness-vue-bootstrap-radiogroup-input",
    type: "radio",
    name: s.filter.key,
    id: s.filter.key + f.option.key,
    value: f.option.key,
    disabled: f.option.disabled,
    "onUpdate:modelValue": c[0] || (c[0] = (P) => s.boundValue = P),
    "aria-labelledby": s.filter.key + f.option.key + "-label"
  }, null, 8, $o)), [
    [Mi, s.boundValue]
  ]);
}
const Io = /* @__PURE__ */ Te(Bo, [["render", Ro]]), zo = {
  name: "harness-vue-bootstrap-radiogroup",
  components: { RadioGroupPartial: Io },
  mixins: [Ve, Je],
  props: {
    inline: {
      type: Boolean,
      required: !1,
      default: !1
    }
  }
}, Vo = { key: 0 }, Wo = ["for", "innerHTML"], Uo = ["id", "for", "disabled", "innerHTML"], Go = ["innerHTML"], Qo = { key: 1 }, Xo = { class: "row form-row" }, Ko = ["for", "innerHTML"], Jo = ["id", "for", "disabled", "innerHTML"], Yo = ["innerHTML"];
function Zo(s, c, f, z, V, H) {
  const P = Ke("RadioGroupPartial");
  return C(), x("div", null, [
    s.labelPosition === "vertical" ? (C(), x("fieldset", Vo, [
      T("legend", {
        class: "col-form-label harness-vue-bootstrap-radiogroup-legend",
        for: s.filter.key,
        innerHTML: s.filter.label
      }, null, 8, Wo),
      (C(!0), x(he, null, ye(s.getOptionsForFilter(s.filter.key), (A, te) => (C(), x("div", {
        class: R("form-check" + (f.inline ? " form-check-inline" : "")),
        key: te
      }, [
        Se(P, Oe(Re({ ...s.$props, ...s.$attrs, option: A })), null, 16),
        T("label", {
          class: "form-check-label harness-vue-bootstrap-radiogroup-label",
          id: s.filter.key + A.key + "-label",
          for: s.filter.key + A.key,
          disabled: A.disabled,
          innerHTML: A.label
        }, null, 8, Uo)
      ], 2))), 128)),
      s.helperText ? (C(), x("small", {
        key: 0,
        innerHTML: s.helperText,
        class: R(
          "form-text harness-vue-bootstrap-helper-text harness-vue-bootstrap-radiogroup-helper-text " + s.helperTextClass
        )
      }, null, 10, Go)) : G("", !0)
    ])) : G("", !0),
    s.labelPosition === "horizontal" ? (C(), x("fieldset", Qo, [
      T("div", Xo, [
        T("div", {
          class: R("col-" + s.labelColumnSize)
        }, [
          T("legend", {
            class: "col-form-label harness-vue-bootstrap-radiogroup-legend",
            for: s.filter.key,
            innerHTML: s.filter.label
          }, null, 8, Ko)
        ], 2),
        T("div", {
          class: R("col-" + (12 - s.labelColumnSize))
        }, [
          (C(!0), x(he, null, ye(s.getOptionsForFilter(s.filter.key), (A, te) => (C(), x("div", {
            class: R("form-check" + (f.inline ? " form-check-inline" : "")),
            key: te
          }, [
            Se(P, Oe(Re({ ...s.$props, ...s.$attrs, option: A })), null, 16),
            T("label", {
              class: "form-check-label harness-vue-bootstrap-radiogroup-label",
              id: s.filter.key + A.key + "-label",
              for: s.filter.key + A.key,
              disabled: A.disabled,
              innerHTML: A.label
            }, null, 8, Jo)
          ], 2))), 128)),
          s.helperText ? (C(), x("small", {
            key: 0,
            innerHTML: s.helperText,
            class: R(
              "form-text harness-vue-bootstrap-helper-text harness-vue-bootstrap-radiogroup-helper-text " + s.helperTextClass
            )
          }, null, 10, Yo)) : G("", !0)
        ], 2)
      ])
    ])) : G("", !0)
  ]);
}
const el = /* @__PURE__ */ Te(zo, [["render", Zo]]), tl = {
  name: "CheckboxPartial",
  mixins: [Ve, Je],
  props: {
    inline: {
      type: Boolean,
      required: !0
    },
    collapse: {
      type: Boolean,
      required: !0
    },
    collapsed: {
      type: Boolean,
      required: !0
    },
    option: {
      type: Object,
      required: !0
    }
  }
}, rl = ["name", "id", "value", "aria-labelledby"];
function nl(s, c, f, z, V, H) {
  return $e((C(), x("input", {
    class: "form-check-input harness-vue-bootstrap-checkboxgroup-input",
    type: "checkbox",
    name: s.filter.key + f.option.key,
    id: s.filter.key + f.option.key,
    value: f.option.key,
    "onUpdate:modelValue": c[0] || (c[0] = (P) => s.boundValue = P),
    "aria-labelledby": s.filter.key + f.option.key + "-label"
  }, null, 8, rl)), [
    [ji, s.boundValue]
  ]);
}
const il = /* @__PURE__ */ Te(tl, [["render", nl]]);
const sl = {
  name: "harness-vue-bootstrap-checkboxgroup",
  mixins: [Ve, Je],
  components: { CheckboxPartial: il },
  data: () => ({ collapsed: !0 }),
  props: {
    inline: {
      type: Boolean,
      docstring: "asdasdasd",
      required: !1,
      default: !1
    },
    collapse: {
      type: Boolean,
      required: !1,
      default: !1
    }
  }
}, al = { key: 0 }, ol = ["for", "data-toggle", "href", "role"], ll = ["innerHTML"], ul = ["data-toggle", "href", "role"], fl = {
  key: 0,
  class: "bi-chevron-down"
}, cl = {
  key: 1,
  class: "bi-chevron-up"
}, dl = ["href"], hl = { key: 0 }, pl = { key: 1 }, gl = ["id"], yl = ["id", "for", "innerHTML"], bl = ["innerHTML"], vl = { key: 1 }, ml = { class: "row form-row" }, kl = ["data-toggle", "href", "role", "for"], Tl = ["innerHTML"], Cl = ["data-toggle", "href", "role"], wl = {
  key: 0,
  class: "bi-chevron-down"
}, Sl = {
  key: 1,
  class: "bi-chevron-up"
}, xl = ["href"], _l = { key: 0 }, Dl = { key: 1 }, Ll = ["id"], ql = ["id", "for", "innerHTML"], Al = ["innerHTML"], Nl = { key: 2 }, Pl = ["id", "for", "innerHTML"], El = ["innerHTML"];
function Ol(s, c, f, z, V, H) {
  const P = Ke("CheckboxPartial");
  return C(), x("div", null, [
    s.labelPosition === "vertical" ? (C(), x("fieldset", al, [
      T("legend", {
        class: "col-form-label harness-vue-bootstrap-checkboxgroup-legend",
        for: s.filter.key,
        "data-toggle": f.collapse ? "collapse" : "",
        href: f.collapse ? "#harness-vue-bootstrap-checkbox-collapse-" + s.filter.key : "",
        role: f.collapse ? "button" : "",
        onClick: c[1] || (c[1] = (A) => s.collapsed = !s.collapsed)
      }, [
        T("span", {
          innerHTML: s.filter.label
        }, null, 8, ll),
        f.collapse ? (C(), x("button", {
          key: 0,
          class: "harness-vue-bootstrap-collapse-toggle-button",
          "data-toggle": f.collapse ? "collapse" : "",
          href: f.collapse ? "#harness-vue-bootstrap-checkbox-collapse-" + s.filter.key : "",
          role: f.collapse ? "button" : "",
          onClick: c[0] || (c[0] = (A) => s.collapsed = !s.collapsed),
          "aria-expanded": "false",
          "aria-label": "Collapse Toggle"
        }, [
          f.collapse && s.collapsed ? (C(), x("i", fl)) : G("", !0),
          f.collapse && !s.collapsed ? (C(), x("i", cl)) : G("", !0)
        ], 8, ul)) : G("", !0)
      ], 8, ol),
      f.collapse ? (C(), x("div", {
        key: 0,
        "data-toggle": "collapse",
        href: f.collapse ? "#harness-vue-bootstrap-checkbox-collapse-" + s.filter.key : "",
        role: "button",
        class: "harness-vue-bootstrap-checkboxgroup-collapse-label",
        onClick: c[2] || (c[2] = (A) => s.collapsed = !s.collapsed)
      }, [
        f.collapse && s.getFilter(s.filter.key).length === s.getOptionsForFilter(s.filter.key).length ? (C(), x("span", hl, " (All Selected) ")) : f.collapse ? (C(), x("span", pl, " (" + we(s.getFilter(s.filter.key).length) + " of " + we(s.getOptionsForFilter(s.filter.key).length) + " selected) ", 1)) : G("", !0)
      ], 8, dl)) : G("", !0),
      T("div", {
        class: R(f.collapse ? "collapse" : ""),
        id: f.collapse ? "harness-vue-bootstrap-checkbox-collapse-" + s.filter.key : ""
      }, [
        (C(!0), x(he, null, ye(s.getOptionsForFilter(s.filter.key), (A, te) => (C(), x("div", {
          class: R("form-check" + (f.inline ? " form-check-inline" : "")),
          key: te
        }, [
          Se(P, Oe(Re({ ...s.$props, ...s.$attrs, collapsed: s.collapsed, option: A })), null, 16),
          T("label", {
            class: "form-check-label harness-vue-bootstrap-checkboxgroup-label",
            id: s.filter.key + A.key + "-label",
            for: s.filter.key + A.key,
            innerHTML: A.label
          }, null, 8, yl)
        ], 2))), 128)),
        s.helperText ? (C(), x("small", {
          key: 0,
          innerHTML: s.helperText,
          class: R(
            "form-text harness-vue-bootstrap-helper-text harness-vue-bootstrap-checkboxgroup-helper-text " + s.helperTextClass
          )
        }, null, 10, bl)) : G("", !0)
      ], 10, gl)
    ])) : G("", !0),
    s.labelPosition === "horizontal" ? (C(), x("fieldset", vl, [
      T("div", ml, [
        T("div", {
          class: R("col-" + s.labelColumnSize)
        }, [
          T("legend", {
            class: "col-form-label harness-vue-bootstrap-checkboxgroup-legend",
            "data-toggle": f.collapse ? "collapse" : "",
            href: f.collapse ? "#harness-vue-bootstrap-checkbox-collapse-" + s.filter.key : "",
            role: f.collapse ? "button" : "",
            for: s.filter.key,
            onClick: c[4] || (c[4] = (A) => s.collapsed = !s.collapsed)
          }, [
            T("span", {
              innerHTML: s.filter.label
            }, null, 8, Tl),
            f.collapse ? (C(), x("button", {
              key: 0,
              class: "harness-vue-bootstrap-collapse-toggle-button",
              "data-toggle": f.collapse ? "collapse" : "",
              href: f.collapse ? "#harness-vue-bootstrap-checkbox-collapse-" + s.filter.key : "",
              role: f.collapse ? "button" : "",
              onClick: c[3] || (c[3] = (A) => s.collapsed = !s.collapsed),
              "aria-expanded": "false",
              "aria-label": "Collapse Toggle"
            }, [
              f.collapse && s.collapsed ? (C(), x("i", wl)) : G("", !0),
              f.collapse && !s.collapsed ? (C(), x("i", Sl)) : G("", !0)
            ], 8, Cl)) : G("", !0)
          ], 8, kl)
        ], 2),
        T("div", {
          class: R("col-" + (12 - s.labelColumnSize))
        }, [
          f.collapse ? (C(), x("div", {
            key: 0,
            class: "col-form-label harness-vue-bootstrap-checkboxgroup-collapse-label",
            "data-toggle": "collapse",
            href: "#harness-vue-bootstrap-checkbox-collapse-" + s.filter.key,
            role: "button",
            onClick: c[5] || (c[5] = (A) => s.collapsed = !s.collapsed)
          }, [
            f.collapse && s.getFilter(s.filter.key).length === s.getOptionsForFilter(s.filter.key).length ? (C(), x("span", _l, " (All Selected) ")) : f.collapse ? (C(), x("span", Dl, " (" + we(s.getFilter(s.filter.key).length) + " of " + we(s.getOptionsForFilter(s.filter.key).length) + " selected) ", 1)) : G("", !0)
          ], 8, xl)) : G("", !0),
          T("div", {
            class: R(f.collapse ? "collapse" : ""),
            id: f.collapse ? "harness-vue-bootstrap-checkbox-collapse-" + s.filter.key : ""
          }, [
            (C(!0), x(he, null, ye(s.getOptionsForFilter(s.filter.key), (A, te) => (C(), x("div", {
              class: R("form-check" + (f.inline ? " form-check-inline" : "")),
              key: te
            }, [
              Se(P, Oe(Re({ ...s.$props, ...s.$attrs, collapsed: s.collapsed, option: A })), null, 16),
              T("label", {
                class: "form-check-label harness-vue-bootstrap-checkboxgroup-label",
                id: s.filter.key + A.key + "-label",
                for: s.filter.key + A.key,
                innerHTML: A.label
              }, null, 8, ql)
            ], 2))), 128)),
            s.helperText ? (C(), x("small", {
              key: 0,
              innerHTML: s.helperText,
              class: R(
                "form-text harness-vue-bootstrap-helper-text harness-vue-bootstrap-checkboxgroup-helper-text " + s.helperTextClass
              )
            }, null, 10, Al)) : G("", !0)
          ], 10, Ll)
        ], 2)
      ])
    ])) : G("", !0),
    s.labelPosition === "none" ? (C(), x("fieldset", Nl, [
      (C(!0), x(he, null, ye(s.getOptionsForFilter(s.filter.key), (A, te) => (C(), x("div", {
        class: R("form-check" + (f.inline ? " form-check-inline" : "")),
        key: te
      }, [
        Se(P, Oe(Re({ ...s.$props, ...s.$attrs, collapsed: s.collapsed, option: A })), null, 16),
        T("label", {
          class: "form-check-label harness-vue-bootstrap-checkboxgroup-label",
          id: s.filter.key + A.key + "-label",
          for: s.filter.key + A.key,
          innerHTML: A.label
        }, null, 8, Pl)
      ], 2))), 128)),
      s.helperText ? (C(), x("small", {
        key: 0,
        innerHTML: s.helperText,
        class: R(
          "form-text harness-vue-bootstrap-helper-text harness-vue-bootstrap-checkboxgroup-helper-text " + s.helperTextClass
        )
      }, null, 10, El)) : G("", !0)
    ])) : G("", !0)
  ]);
}
const Hl = /* @__PURE__ */ Te(sl, [["render", Ol]]);
const Fl = {
  name: "HarnessVueBootstrapMultiselectListbox",
  mixins: [Ve, Je],
  props: {
    searchable: {
      type: Boolean,
      required: !1,
      default: !1
    },
    typeahead: {
      type: Boolean,
      required: !1,
      default: !1
    }
  },
  data() {
    return {
      bloodhound: null,
      leftBox: [],
      rightBox: [],
      search: "",
      searchDisabled: !1
    };
  },
  computed: {
    leftBoxOptions() {
      return this.unselectedOptions.filter(
        (s) => this.search === "" || s.label.toLowerCase().includes(this.search.toLowerCase())
      );
    },
    rightBoxOptions() {
      return this.getOptionsForFilter(this.filter.key).filter(
        (s) => this.getFilter(this.filter.key).includes(s.key)
      );
    },
    unselectedOptions() {
      return this.getOptionsForFilter(this.filter.key).filter(
        (s) => !this.getFilter(this.filter.key).includes(s.key)
      );
    }
  },
  methods: {
    leftToRight() {
      const s = this.getFilter(this.filter.key).concat(this.leftBox);
      this.setFilterLoadData(this.filter.key, s), this.lifecycleBloodhound();
    },
    rightToLeft() {
      const s = this.getFilter(this.filter.key).filter(
        (c) => !this.rightBox.includes(c)
      );
      this.setFilterLoadData(this.filter.key, s), this.lifecycleBloodhound();
    },
    lifecycleBloodhound() {
      this.bloodhound && (this.bloodhound.clear(), this.unselectedOptions.length ? (this.searchDisabled = !1, this.bloodhound.add(this.unselectedOptions.map((s) => s.label))) : this.searchDisabled = !0);
    },
    initTypeahead() {
      this.bloodhound = new mt({
        datumTokenizer: mt.tokenizers.ngram,
        queryTokenizer: mt.tokenizers.ngram,
        local: this.leftBoxOptions.map((c) => c.label)
      });
      const s = [
        "input",
        "hint",
        "menu",
        "dataset",
        "suggestion",
        "empty",
        "open",
        "cursor",
        "highlight"
      ].reduce((c, f) => (c[f] = `harness-vue-bootstrap-multiselect-listbox-typeahead-${f}`, c), {});
      Cr(`#harness-vue-bootstrap-multiselect-listbox-search-${this.filter.key}`).typeahead(
        {
          highlight: !0,
          minLength: 1,
          classNames: s
        },
        {
          name: this.filter.key,
          limit: 10,
          source: this.bloodhound
        }
      ).bind("typeahead:select", (c, f) => {
        this.search = f;
      }).bind("typeahead:autocomplete", (c, f) => {
        this.search = f;
      });
    }
  },
  mounted() {
    this.searchable && this.typeahead && this.initTypeahead();
  }
}, Ml = { class: "harness-vue-bootstrap-select-label harness-vue-bootstrap-multiselect-listbox-top-label" }, jl = {
  key: 0,
  class: "row"
}, Bl = { class: "col" }, $l = ["id", "disabled"], Rl = { class: "row align-items-center" }, Il = { class: "col-5" }, zl = /* @__PURE__ */ T("label", { class: "col-form-label harness-vue-bootstrap-select-label harness-vue-bootstrap-multiselect-listbox-select-label harness-vue-bootstrap-select-label-vertical" }, "Options", -1), Vl = ["value", "title"], Wl = { class: "col-2" }, Ul = { class: "text-center" }, Gl = /* @__PURE__ */ T("i", { class: "bi bi-caret-left-fill" }, null, -1), Ql = [
  Gl
], Xl = /* @__PURE__ */ T("i", { class: "bi bi-caret-right-fill" }, null, -1), Kl = [
  Xl
], Jl = { class: "col-5" }, Yl = /* @__PURE__ */ T("label", { class: "col-form-label harness-vue-bootstrap-select-label harness-vue-bootstrap-multiselect-listbox-select-label harness-vue-bootstrap-select-label-vertical" }, "Selected", -1), Zl = ["value", "title"];
function eu(s, c, f, z, V, H) {
  return C(), x("div", null, [
    T("label", Ml, we(this.filter.label), 1),
    f.searchable ? (C(), x("div", jl, [
      T("div", Bl, [
        $e(T("input", {
          type: "text",
          id: `harness-vue-bootstrap-multiselect-listbox-search-${s.filter.key}`,
          class: "form-control harness-vue-bootstrap-input harness-vue-bootstrap-multiselect-listbox-search-input",
          disabled: V.searchDisabled,
          "onUpdate:modelValue": c[0] || (c[0] = (P) => V.search = P)
        }, null, 8, $l), [
          [kn, V.search]
        ])
      ])
    ])) : G("", !0),
    T("div", Rl, [
      T("div", Il, [
        zl,
        $e(T("select", {
          class: "form-control harness-vue-bootstrap-select harness-vue-bootstrap-multiselect-listbox-select harness-vue-bootstrap-multiselect-listbox-select-left",
          multiple: "true",
          "onUpdate:modelValue": c[1] || (c[1] = (P) => V.leftBox = P)
        }, [
          (C(!0), x(he, null, ye(H.leftBoxOptions, (P) => (C(), x("option", {
            key: P.key,
            value: P.key,
            title: P.label
          }, we(P.label), 9, Vl))), 128))
        ], 512), [
          [Kt, V.leftBox]
        ])
      ]),
      T("div", Wl, [
        T("div", Ul, [
          T("button", {
            class: "btn btn-xs",
            onClick: c[2] || (c[2] = (...P) => H.rightToLeft && H.rightToLeft(...P))
          }, Ql),
          T("button", {
            class: "btn btn-xs",
            onClick: c[3] || (c[3] = (...P) => H.leftToRight && H.leftToRight(...P))
          }, Kl)
        ])
      ]),
      T("div", Jl, [
        Yl,
        $e(T("select", {
          class: "form-control harness-vue-bootstrap-select harness-vue-bootstrap-multiselect-listbox-select harness-vue-bootstrap-multiselect-listbox-select-right",
          multiple: "true",
          "onUpdate:modelValue": c[4] || (c[4] = (P) => V.rightBox = P)
        }, [
          (C(!0), x(he, null, ye(H.rightBoxOptions, (P) => (C(), x("option", {
            key: P.key,
            value: P.key,
            title: P.label
          }, we(P.label), 9, Zl))), 128))
        ], 512), [
          [Kt, V.rightBox]
        ])
      ])
    ])
  ]);
}
const tu = /* @__PURE__ */ Te(Fl, [["render", eu]]), bn = {
  FilterGrid: Wi,
  ChartGrid: Qi,
  GridWithFilters: ns,
  DataTable508: fs,
  ChartWithTable: Rs,
  InteractiveTable: ka,
  FilterPicker: Fa,
  FilterAccordion: no,
  HarnessVueBootstrapInput: So,
  HarnessVueBootstrapSelect: jo,
  HarnessVueBootstrapRadioGroup: el,
  HarnessVueBootstrapCheckboxGroup: Hl,
  HarnessVueBootstrapMultiselectListbox: tu
}, nu = {
  install(s, c) {
    Object.keys(bn).forEach((f) => {
      s.component(f, bn[f]);
    });
  }
};
export {
  bn as components,
  nu as harnessVueBootstrap
};
